/* application-folder-context.c generated by valac 0.56.14, the Vala compiler
 * generated from application-folder-context.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "geary-client-44.1.h"
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

enum  {
	APPLICATION_FOLDER_CONTEXT_0_PROPERTY,
	APPLICATION_FOLDER_CONTEXT_FOLDER_PROPERTY,
	APPLICATION_FOLDER_CONTEXT_DISPLAY_NAME_PROPERTY,
	APPLICATION_FOLDER_CONTEXT_ICON_NAME_PROPERTY,
	APPLICATION_FOLDER_CONTEXT_DISPLAYED_COUNT_PROPERTY,
	APPLICATION_FOLDER_CONTEXT_NUM_PROPERTIES
};
static GParamSpec* application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ApplicationFolderContextPrivate {
	GearyFolder* _folder;
	gchar* _display_name;
	gchar* _icon_name;
	ApplicationFolderContextEmailCount _displayed_count;
};

static gint ApplicationFolderContext_private_offset;
static gpointer application_folder_context_parent_class = NULL;
static GeeComparableIface * application_folder_context_gee_comparable_parent_iface = NULL;

static void application_folder_context_set_folder (ApplicationFolderContext* self,
                                            GearyFolder* value);
static void __lambda4_ (ApplicationFolderContext* self);
static void application_folder_context_update (ApplicationFolderContext* self);
static void ___lambda4__geary_folder_use_changed (GearyFolder* _sender,
                                           GearyFolderSpecialUse old_use,
                                           GearyFolderSpecialUse new_use,
                                           gpointer self);
static gint application_folder_context_real_compare_to (GeeComparable* base,
                                                 ApplicationFolderContext* other);
static gchar* application_folder_context_get_default_icon_name (ApplicationFolderContext* self);
static void application_folder_context_finalize (GObject * obj);
static GType application_folder_context_get_type_once (void);
static void _vala_application_folder_context_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_application_folder_context_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
application_folder_context_get_instance_private (ApplicationFolderContext* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationFolderContext_private_offset);
}

/** Specifies different kinds of displayable email counts. */
static GType
application_folder_context_email_count_get_type_once (void)
{
	static const GEnumValue values[] = {{APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_NONE, "APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_NONE", "none"}, {APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_UNREAD, "APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_UNREAD", "unread"}, {APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_TOTAL, "APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_TOTAL", "total"}, {0, NULL, NULL}};
	GType application_folder_context_email_count_type_id;
	application_folder_context_email_count_type_id = g_enum_register_static ("ApplicationFolderContextEmailCount", values);
	return application_folder_context_email_count_type_id;
}

GType
application_folder_context_email_count_get_type (void)
{
	static volatile gsize application_folder_context_email_count_type_id__once = 0;
	if (g_once_init_enter (&application_folder_context_email_count_type_id__once)) {
		GType application_folder_context_email_count_type_id;
		application_folder_context_email_count_type_id = application_folder_context_email_count_get_type_once ();
		g_once_init_leave (&application_folder_context_email_count_type_id__once, application_folder_context_email_count_type_id);
	}
	return application_folder_context_email_count_type_id__once;
}

GearyFolder*
application_folder_context_get_folder (ApplicationFolderContext* self)
{
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 27 "../src/client/application/application-folder-context.vala"
	g_return_val_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self), NULL);
#line 27 "../src/client/application/application-folder-context.vala"
	_tmp0_ = self->priv->_folder;
#line 27 "../src/client/application/application-folder-context.vala"
	result = _tmp0_;
#line 27 "../src/client/application/application-folder-context.vala"
	return result;
#line 112 "application-folder-context.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../src/client/application/application-folder-context.vala"
	return self ? g_object_ref (self) : NULL;
#line 120 "application-folder-context.c"
}

static void
application_folder_context_set_folder (ApplicationFolderContext* self,
                                       GearyFolder* value)
{
	GearyFolder* old_value;
#line 27 "../src/client/application/application-folder-context.vala"
	g_return_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self));
#line 27 "../src/client/application/application-folder-context.vala"
	old_value = application_folder_context_get_folder (self);
#line 27 "../src/client/application/application-folder-context.vala"
	if (old_value != value) {
#line 134 "application-folder-context.c"
		GearyFolder* _tmp0_;
#line 27 "../src/client/application/application-folder-context.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../src/client/application/application-folder-context.vala"
		_g_object_unref0 (self->priv->_folder);
#line 27 "../src/client/application/application-folder-context.vala"
		self->priv->_folder = _tmp0_;
#line 27 "../src/client/application/application-folder-context.vala"
		g_object_notify_by_pspec ((GObject *) self, application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_FOLDER_PROPERTY]);
#line 144 "application-folder-context.c"
	}
}

const gchar*
application_folder_context_get_display_name (ApplicationFolderContext* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/client/application/application-folder-context.vala"
	g_return_val_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self), NULL);
#line 30 "../src/client/application/application-folder-context.vala"
	_tmp0_ = self->priv->_display_name;
#line 30 "../src/client/application/application-folder-context.vala"
	result = _tmp0_;
#line 30 "../src/client/application/application-folder-context.vala"
	return result;
#line 161 "application-folder-context.c"
}

void
application_folder_context_set_display_name (ApplicationFolderContext* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 30 "../src/client/application/application-folder-context.vala"
	g_return_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self));
#line 30 "../src/client/application/application-folder-context.vala"
	old_value = application_folder_context_get_display_name (self);
#line 30 "../src/client/application/application-folder-context.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 175 "application-folder-context.c"
		gchar* _tmp0_;
#line 30 "../src/client/application/application-folder-context.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/client/application/application-folder-context.vala"
		_g_free0 (self->priv->_display_name);
#line 30 "../src/client/application/application-folder-context.vala"
		self->priv->_display_name = _tmp0_;
#line 30 "../src/client/application/application-folder-context.vala"
		g_object_notify_by_pspec ((GObject *) self, application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_DISPLAY_NAME_PROPERTY]);
#line 185 "application-folder-context.c"
	}
}

const gchar*
application_folder_context_get_icon_name (ApplicationFolderContext* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/client/application/application-folder-context.vala"
	g_return_val_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self), NULL);
#line 33 "../src/client/application/application-folder-context.vala"
	_tmp0_ = self->priv->_icon_name;
#line 33 "../src/client/application/application-folder-context.vala"
	result = _tmp0_;
#line 33 "../src/client/application/application-folder-context.vala"
	return result;
#line 202 "application-folder-context.c"
}

void
application_folder_context_set_icon_name (ApplicationFolderContext* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 33 "../src/client/application/application-folder-context.vala"
	g_return_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self));
#line 33 "../src/client/application/application-folder-context.vala"
	old_value = application_folder_context_get_icon_name (self);
#line 33 "../src/client/application/application-folder-context.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 216 "application-folder-context.c"
		gchar* _tmp0_;
#line 33 "../src/client/application/application-folder-context.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/client/application/application-folder-context.vala"
		_g_free0 (self->priv->_icon_name);
#line 33 "../src/client/application/application-folder-context.vala"
		self->priv->_icon_name = _tmp0_;
#line 33 "../src/client/application/application-folder-context.vala"
		g_object_notify_by_pspec ((GObject *) self, application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_ICON_NAME_PROPERTY]);
#line 226 "application-folder-context.c"
	}
}

ApplicationFolderContextEmailCount
application_folder_context_get_displayed_count (ApplicationFolderContext* self)
{
	ApplicationFolderContextEmailCount result;
#line 36 "../src/client/application/application-folder-context.vala"
	g_return_val_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self), 0);
#line 36 "../src/client/application/application-folder-context.vala"
	result = self->priv->_displayed_count;
#line 36 "../src/client/application/application-folder-context.vala"
	return result;
#line 240 "application-folder-context.c"
}

void
application_folder_context_set_displayed_count (ApplicationFolderContext* self,
                                                ApplicationFolderContextEmailCount value)
{
	ApplicationFolderContextEmailCount old_value;
#line 36 "../src/client/application/application-folder-context.vala"
	g_return_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self));
#line 36 "../src/client/application/application-folder-context.vala"
	old_value = application_folder_context_get_displayed_count (self);
#line 36 "../src/client/application/application-folder-context.vala"
	if (old_value != value) {
#line 36 "../src/client/application/application-folder-context.vala"
		self->priv->_displayed_count = value;
#line 36 "../src/client/application/application-folder-context.vala"
		g_object_notify_by_pspec ((GObject *) self, application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_DISPLAYED_COUNT_PROPERTY]);
#line 258 "application-folder-context.c"
	}
}

static void
__lambda4_ (ApplicationFolderContext* self)
{
#line 41 "../src/client/application/application-folder-context.vala"
	application_folder_context_update (self);
#line 267 "application-folder-context.c"
}

static void
___lambda4__geary_folder_use_changed (GearyFolder* _sender,
                                      GearyFolderSpecialUse old_use,
                                      GearyFolderSpecialUse new_use,
                                      gpointer self)
{
#line 41 "../src/client/application/application-folder-context.vala"
	__lambda4_ ((ApplicationFolderContext*) self);
#line 278 "application-folder-context.c"
}

ApplicationFolderContext*
application_folder_context_construct (GType object_type,
                                      GearyFolder* folder)
{
	ApplicationFolderContext * self = NULL;
	GearyFolder* _tmp0_;
#line 39 "../src/client/application/application-folder-context.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER), NULL);
#line 39 "../src/client/application/application-folder-context.vala"
	self = (ApplicationFolderContext*) geary_base_object_construct (object_type);
#line 40 "../src/client/application/application-folder-context.vala"
	application_folder_context_set_folder (self, folder);
#line 41 "../src/client/application/application-folder-context.vala"
	_tmp0_ = self->priv->_folder;
#line 41 "../src/client/application/application-folder-context.vala"
	g_signal_connect_object (_tmp0_, "use-changed", (GCallback) ___lambda4__geary_folder_use_changed, self, 0);
#line 42 "../src/client/application/application-folder-context.vala"
	application_folder_context_update (self);
#line 39 "../src/client/application/application-folder-context.vala"
	return self;
#line 301 "application-folder-context.c"
}

ApplicationFolderContext*
application_folder_context_new (GearyFolder* folder)
{
#line 39 "../src/client/application/application-folder-context.vala"
	return application_folder_context_construct (APPLICATION_TYPE_FOLDER_CONTEXT, folder);
#line 309 "application-folder-context.c"
}

static gint
application_folder_context_real_compare_to (GeeComparable* base,
                                            ApplicationFolderContext* other)
{
	ApplicationFolderContext * self;
	GearyFolder* _tmp0_;
	GearyFolderPath* _tmp1_;
	GearyFolderPath* _tmp2_;
	GearyFolder* _tmp3_;
	GearyFolderPath* _tmp4_;
	GearyFolderPath* _tmp5_;
	gint result;
#line 45 "../src/client/application/application-folder-context.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_FOLDER_CONTEXT, ApplicationFolderContext);
#line 45 "../src/client/application/application-folder-context.vala"
	g_return_val_if_fail (APPLICATION_IS_FOLDER_CONTEXT (other), 0);
#line 46 "../src/client/application/application-folder-context.vala"
	_tmp0_ = self->priv->_folder;
#line 46 "../src/client/application/application-folder-context.vala"
	_tmp1_ = geary_folder_get_path (_tmp0_);
#line 46 "../src/client/application/application-folder-context.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/client/application/application-folder-context.vala"
	_tmp3_ = other->priv->_folder;
#line 46 "../src/client/application/application-folder-context.vala"
	_tmp4_ = geary_folder_get_path (_tmp3_);
#line 46 "../src/client/application/application-folder-context.vala"
	_tmp5_ = _tmp4_;
#line 46 "../src/client/application/application-folder-context.vala"
	result = gee_comparable_compare_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COMPARABLE, GeeComparable), _tmp5_);
#line 46 "../src/client/application/application-folder-context.vala"
	return result;
#line 344 "application-folder-context.c"
}

static gchar*
application_folder_context_get_default_icon_name (ApplicationFolderContext* self)
{
	GearyServiceProvider service_provider = 0;
	GearyFolder* _tmp0_;
	GearyAccount* _tmp1_;
	GearyAccount* _tmp2_;
	GearyAccountInformation* _tmp3_;
	GearyAccountInformation* _tmp4_;
	GearyServiceProvider _tmp5_;
	GearyServiceProvider _tmp6_;
	gchar* result;
#line 49 "../src/client/application/application-folder-context.vala"
	g_return_val_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self), NULL);
#line 50 "../src/client/application/application-folder-context.vala"
	_tmp0_ = self->priv->_folder;
#line 50 "../src/client/application/application-folder-context.vala"
	_tmp1_ = geary_folder_get_account (_tmp0_);
#line 50 "../src/client/application/application-folder-context.vala"
	_tmp2_ = _tmp1_;
#line 50 "../src/client/application/application-folder-context.vala"
	_tmp3_ = geary_account_get_information (_tmp2_);
#line 50 "../src/client/application/application-folder-context.vala"
	_tmp4_ = _tmp3_;
#line 50 "../src/client/application/application-folder-context.vala"
	_tmp5_ = geary_account_information_get_service_provider (_tmp4_);
#line 50 "../src/client/application/application-folder-context.vala"
	_tmp6_ = _tmp5_;
#line 50 "../src/client/application/application-folder-context.vala"
	service_provider = _tmp6_;
#line 52 "../src/client/application/application-folder-context.vala"
	switch (service_provider) {
#line 52 "../src/client/application/application-folder-context.vala"
		case GEARY_SERVICE_PROVIDER_GMAIL:
#line 381 "application-folder-context.c"
		{
			gchar* _tmp7_;
#line 54 "../src/client/application/application-folder-context.vala"
			_tmp7_ = g_strdup ("tag-symbolic");
#line 54 "../src/client/application/application-folder-context.vala"
			result = _tmp7_;
#line 54 "../src/client/application/application-folder-context.vala"
			return result;
#line 390 "application-folder-context.c"
		}
		default:
		{
			gchar* _tmp8_;
#line 56 "../src/client/application/application-folder-context.vala"
			_tmp8_ = g_strdup ("folder-symbolic");
#line 56 "../src/client/application/application-folder-context.vala"
			result = _tmp8_;
#line 56 "../src/client/application/application-folder-context.vala"
			return result;
#line 401 "application-folder-context.c"
		}
	}
}

static void
application_folder_context_update (ApplicationFolderContext* self)
{
	GearyFolder* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GearyFolder* _tmp3_;
	GearyFolderSpecialUse _tmp4_;
	GearyFolderSpecialUse _tmp5_;
	GearyFolder* _tmp8_;
	GearyFolderSpecialUse _tmp9_;
	GearyFolderSpecialUse _tmp10_;
#line 60 "../src/client/application/application-folder-context.vala"
	g_return_if_fail (APPLICATION_IS_FOLDER_CONTEXT (self));
#line 61 "../src/client/application/application-folder-context.vala"
	_tmp0_ = self->priv->_folder;
#line 61 "../src/client/application/application-folder-context.vala"
	_tmp1_ = util_i18n_to_folder_display_name (_tmp0_);
#line 61 "../src/client/application/application-folder-context.vala"
	_tmp2_ = _tmp1_;
#line 61 "../src/client/application/application-folder-context.vala"
	application_folder_context_set_display_name (self, _tmp2_);
#line 61 "../src/client/application/application-folder-context.vala"
	_g_free0 (_tmp2_);
#line 63 "../src/client/application/application-folder-context.vala"
	_tmp3_ = self->priv->_folder;
#line 63 "../src/client/application/application-folder-context.vala"
	_tmp4_ = geary_folder_get_used_as (_tmp3_);
#line 63 "../src/client/application/application-folder-context.vala"
	_tmp5_ = _tmp4_;
#line 63 "../src/client/application/application-folder-context.vala"
	switch (_tmp5_) {
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_INBOX:
#line 440 "application-folder-context.c"
		{
#line 65 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "mail-inbox-symbolic");
#line 66 "../src/client/application/application-folder-context.vala"
			break;
#line 446 "application-folder-context.c"
		}
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_DRAFTS:
#line 450 "application-folder-context.c"
		{
#line 69 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "mail-drafts-symbolic");
#line 70 "../src/client/application/application-folder-context.vala"
			break;
#line 456 "application-folder-context.c"
		}
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_SENT:
#line 460 "application-folder-context.c"
		{
#line 73 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "mail-sent-symbolic");
#line 74 "../src/client/application/application-folder-context.vala"
			break;
#line 466 "application-folder-context.c"
		}
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_FLAGGED:
#line 470 "application-folder-context.c"
		{
#line 77 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "starred-symbolic");
#line 78 "../src/client/application/application-folder-context.vala"
			break;
#line 476 "application-folder-context.c"
		}
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_IMPORTANT:
#line 480 "application-folder-context.c"
		{
#line 81 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "task-due-symbolic");
#line 82 "../src/client/application/application-folder-context.vala"
			break;
#line 486 "application-folder-context.c"
		}
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_ALL_MAIL:
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_ARCHIVE:
#line 492 "application-folder-context.c"
		{
#line 86 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "mail-archive-symbolic");
#line 87 "../src/client/application/application-folder-context.vala"
			break;
#line 498 "application-folder-context.c"
		}
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_JUNK:
#line 502 "application-folder-context.c"
		{
#line 90 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "dialog-warning-symbolic");
#line 91 "../src/client/application/application-folder-context.vala"
			break;
#line 508 "application-folder-context.c"
		}
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_TRASH:
#line 512 "application-folder-context.c"
		{
#line 94 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "user-trash-symbolic");
#line 95 "../src/client/application/application-folder-context.vala"
			break;
#line 518 "application-folder-context.c"
		}
#line 63 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_OUTBOX:
#line 522 "application-folder-context.c"
		{
#line 98 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, "mail-outbox-symbolic");
#line 99 "../src/client/application/application-folder-context.vala"
			break;
#line 528 "application-folder-context.c"
		}
		default:
		{
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 102 "../src/client/application/application-folder-context.vala"
			_tmp6_ = application_folder_context_get_default_icon_name (self);
#line 102 "../src/client/application/application-folder-context.vala"
			_tmp7_ = _tmp6_;
#line 102 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_icon_name (self, _tmp7_);
#line 102 "../src/client/application/application-folder-context.vala"
			_g_free0 (_tmp7_);
#line 103 "../src/client/application/application-folder-context.vala"
			break;
#line 544 "application-folder-context.c"
		}
	}
#line 106 "../src/client/application/application-folder-context.vala"
	_tmp8_ = self->priv->_folder;
#line 106 "../src/client/application/application-folder-context.vala"
	_tmp9_ = geary_folder_get_used_as (_tmp8_);
#line 106 "../src/client/application/application-folder-context.vala"
	_tmp10_ = _tmp9_;
#line 106 "../src/client/application/application-folder-context.vala"
	switch (_tmp10_) {
#line 106 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_DRAFTS:
#line 106 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_OUTBOX:
#line 559 "application-folder-context.c"
		{
#line 109 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_displayed_count (self, APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_TOTAL);
#line 110 "../src/client/application/application-folder-context.vala"
			break;
#line 565 "application-folder-context.c"
		}
#line 106 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_INBOX:
#line 106 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_JUNK:
#line 106 "../src/client/application/application-folder-context.vala"
		case GEARY_FOLDER_SPECIAL_USE_NONE:
#line 573 "application-folder-context.c"
		{
#line 115 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_displayed_count (self, APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_UNREAD);
#line 116 "../src/client/application/application-folder-context.vala"
			break;
#line 579 "application-folder-context.c"
		}
		default:
		{
#line 119 "../src/client/application/application-folder-context.vala"
			application_folder_context_set_displayed_count (self, APPLICATION_FOLDER_CONTEXT_EMAIL_COUNT_NONE);
#line 120 "../src/client/application/application-folder-context.vala"
			break;
#line 587 "application-folder-context.c"
		}
	}
}

static void
application_folder_context_class_init (ApplicationFolderContextClass * klass,
                                       gpointer klass_data)
{
#line 12 "../src/client/application/application-folder-context.vala"
	application_folder_context_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/client/application/application-folder-context.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationFolderContext_private_offset);
#line 12 "../src/client/application/application-folder-context.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_folder_context_get_property;
#line 12 "../src/client/application/application-folder-context.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_folder_context_set_property;
#line 12 "../src/client/application/application-folder-context.vala"
	G_OBJECT_CLASS (klass)->finalize = application_folder_context_finalize;
#line 606 "application-folder-context.c"
	/** The account for this context. */
#line 12 "../src/client/application/application-folder-context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_FOLDER_CONTEXT_FOLDER_PROPERTY, application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_FOLDER_PROPERTY] = g_param_spec_object ("folder", "folder", "folder", GEARY_TYPE_FOLDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 610 "application-folder-context.c"
	/** Returns the human-readable name of the folder */
#line 12 "../src/client/application/application-folder-context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_FOLDER_CONTEXT_DISPLAY_NAME_PROPERTY, application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 614 "application-folder-context.c"
	/** The icon to use for the folder */
#line 12 "../src/client/application/application-folder-context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_FOLDER_CONTEXT_ICON_NAME_PROPERTY, application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 618 "application-folder-context.c"
	/** The count to be displayed for the folder. */
#line 12 "../src/client/application/application-folder-context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_FOLDER_CONTEXT_DISPLAYED_COUNT_PROPERTY, application_folder_context_properties[APPLICATION_FOLDER_CONTEXT_DISPLAYED_COUNT_PROPERTY] = g_param_spec_enum ("displayed-count", "displayed-count", "displayed-count", APPLICATION_FOLDER_CONTEXT_TYPE_EMAIL_COUNT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 622 "application-folder-context.c"
}

static void
application_folder_context_gee_comparable_interface_init (GeeComparableIface * iface,
                                                          gpointer iface_data)
{
#line 12 "../src/client/application/application-folder-context.vala"
	application_folder_context_gee_comparable_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "../src/client/application/application-folder-context.vala"
	iface->compare_to = (gint (*) (GeeComparable*, gconstpointer)) application_folder_context_real_compare_to;
#line 633 "application-folder-context.c"
}

static void
application_folder_context_instance_init (ApplicationFolderContext * self,
                                          gpointer klass)
{
#line 12 "../src/client/application/application-folder-context.vala"
	self->priv = application_folder_context_get_instance_private (self);
#line 642 "application-folder-context.c"
}

static void
application_folder_context_finalize (GObject * obj)
{
	ApplicationFolderContext * self;
#line 12 "../src/client/application/application-folder-context.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_FOLDER_CONTEXT, ApplicationFolderContext);
#line 27 "../src/client/application/application-folder-context.vala"
	_g_object_unref0 (self->priv->_folder);
#line 30 "../src/client/application/application-folder-context.vala"
	_g_free0 (self->priv->_display_name);
#line 33 "../src/client/application/application-folder-context.vala"
	_g_free0 (self->priv->_icon_name);
#line 12 "../src/client/application/application-folder-context.vala"
	G_OBJECT_CLASS (application_folder_context_parent_class)->finalize (obj);
#line 659 "application-folder-context.c"
}

/**
 * Collects application state related to a single folder.
 */
static GType
application_folder_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationFolderContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_folder_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationFolderContext), 0, (GInstanceInitFunc) application_folder_context_instance_init, NULL };
	static const GInterfaceInfo gee_comparable_info = { (GInterfaceInitFunc) application_folder_context_gee_comparable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType application_folder_context_type_id;
	application_folder_context_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "ApplicationFolderContext", &g_define_type_info, 0);
	g_type_add_interface_static (application_folder_context_type_id, GEE_TYPE_COMPARABLE, &gee_comparable_info);
	ApplicationFolderContext_private_offset = g_type_add_instance_private (application_folder_context_type_id, sizeof (ApplicationFolderContextPrivate));
	return application_folder_context_type_id;
}

GType
application_folder_context_get_type (void)
{
	static volatile gsize application_folder_context_type_id__once = 0;
	if (g_once_init_enter (&application_folder_context_type_id__once)) {
		GType application_folder_context_type_id;
		application_folder_context_type_id = application_folder_context_get_type_once ();
		g_once_init_leave (&application_folder_context_type_id__once, application_folder_context_type_id);
	}
	return application_folder_context_type_id__once;
}

static void
_vala_application_folder_context_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	ApplicationFolderContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_FOLDER_CONTEXT, ApplicationFolderContext);
#line 12 "../src/client/application/application-folder-context.vala"
	switch (property_id) {
#line 12 "../src/client/application/application-folder-context.vala"
		case APPLICATION_FOLDER_CONTEXT_FOLDER_PROPERTY:
#line 12 "../src/client/application/application-folder-context.vala"
		g_value_set_object (value, application_folder_context_get_folder (self));
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 12 "../src/client/application/application-folder-context.vala"
		case APPLICATION_FOLDER_CONTEXT_DISPLAY_NAME_PROPERTY:
#line 12 "../src/client/application/application-folder-context.vala"
		g_value_set_string (value, application_folder_context_get_display_name (self));
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 12 "../src/client/application/application-folder-context.vala"
		case APPLICATION_FOLDER_CONTEXT_ICON_NAME_PROPERTY:
#line 12 "../src/client/application/application-folder-context.vala"
		g_value_set_string (value, application_folder_context_get_icon_name (self));
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 12 "../src/client/application/application-folder-context.vala"
		case APPLICATION_FOLDER_CONTEXT_DISPLAYED_COUNT_PROPERTY:
#line 12 "../src/client/application/application-folder-context.vala"
		g_value_set_enum (value, application_folder_context_get_displayed_count (self));
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 723 "application-folder-context.c"
		default:
#line 12 "../src/client/application/application-folder-context.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 729 "application-folder-context.c"
	}
}

static void
_vala_application_folder_context_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	ApplicationFolderContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_FOLDER_CONTEXT, ApplicationFolderContext);
#line 12 "../src/client/application/application-folder-context.vala"
	switch (property_id) {
#line 12 "../src/client/application/application-folder-context.vala"
		case APPLICATION_FOLDER_CONTEXT_FOLDER_PROPERTY:
#line 12 "../src/client/application/application-folder-context.vala"
		application_folder_context_set_folder (self, g_value_get_object (value));
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 12 "../src/client/application/application-folder-context.vala"
		case APPLICATION_FOLDER_CONTEXT_DISPLAY_NAME_PROPERTY:
#line 12 "../src/client/application/application-folder-context.vala"
		application_folder_context_set_display_name (self, g_value_get_string (value));
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 12 "../src/client/application/application-folder-context.vala"
		case APPLICATION_FOLDER_CONTEXT_ICON_NAME_PROPERTY:
#line 12 "../src/client/application/application-folder-context.vala"
		application_folder_context_set_icon_name (self, g_value_get_string (value));
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 12 "../src/client/application/application-folder-context.vala"
		case APPLICATION_FOLDER_CONTEXT_DISPLAYED_COUNT_PROPERTY:
#line 12 "../src/client/application/application-folder-context.vala"
		application_folder_context_set_displayed_count (self, g_value_get_enum (value));
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 767 "application-folder-context.c"
		default:
#line 12 "../src/client/application/application-folder-context.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/client/application/application-folder-context.vala"
		break;
#line 773 "application-folder-context.c"
	}
}

