/* status-bar.c generated by valac 0.56.14, the Vala compiler
 * generated from status-bar.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "geary-client-44.1.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

typedef enum  {
	STATUS_BAR_CONTEXT_OUTBOX
} StatusBarContext;

#define STATUS_BAR_TYPE_CONTEXT (status_bar_context_get_type ())
enum  {
	STATUS_BAR_0_PROPERTY,
	STATUS_BAR_NUM_PROPERTIES
};
static GParamSpec* status_bar_properties[STATUS_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _StatusBarPrivate {
	GeeHashMap* context_ids;
	GeeHashMap* message_ids;
	GeeHashMap* message_counts;
};

static gint StatusBar_private_offset;
static gpointer status_bar_parent_class = NULL;

VALA_EXTERN GType status_bar_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* status_bar_message_get_text (StatusBarMessage self);
VALA_EXTERN StatusBarContext status_bar_message_get_context (StatusBarMessage self);
static void status_bar_set_context_id (StatusBar* self,
                                StatusBarContext context);
static gint status_bar_get_count (StatusBar* self,
                           StatusBarMessage message);
static void status_bar_push_message (StatusBar* self,
                              StatusBarMessage message);
static void status_bar_remove_message (StatusBar* self,
                                StatusBarMessage message);
static void status_bar_finalize (GObject * obj);
static GType status_bar_get_type_once (void);

static inline gpointer
status_bar_get_instance_private (StatusBar* self)
{
	return G_STRUCT_MEMBER_P (self, StatusBar_private_offset);
}

gchar*
status_bar_message_get_text (StatusBarMessage self)
{
	gchar* result;
#line 23 "../src/client/components/status-bar.vala"
	switch (self) {
#line 23 "../src/client/components/status-bar.vala"
		case STATUS_BAR_MESSAGE_OUTBOX_SENDING:
#line 76 "status-bar.c"
		{
			gchar* _tmp0_;
#line 26 "../src/client/components/status-bar.vala"
			_tmp0_ = g_strdup (_ ("Sending…"));
#line 26 "../src/client/components/status-bar.vala"
			result = _tmp0_;
#line 26 "../src/client/components/status-bar.vala"
			return result;
#line 85 "status-bar.c"
		}
#line 23 "../src/client/components/status-bar.vala"
		case STATUS_BAR_MESSAGE_OUTBOX_SEND_FAILURE:
#line 89 "status-bar.c"
		{
			gchar* _tmp1_;
#line 29 "../src/client/components/status-bar.vala"
			_tmp1_ = g_strdup (_ ("Error sending email"));
#line 29 "../src/client/components/status-bar.vala"
			result = _tmp1_;
#line 29 "../src/client/components/status-bar.vala"
			return result;
#line 98 "status-bar.c"
		}
#line 23 "../src/client/components/status-bar.vala"
		case STATUS_BAR_MESSAGE_OUTBOX_SAVE_SENT_MAIL_FAILED:
#line 102 "status-bar.c"
		{
			gchar* _tmp2_;
#line 33 "../src/client/components/status-bar.vala"
			_tmp2_ = g_strdup (_ ("Error saving sent mail"));
#line 33 "../src/client/components/status-bar.vala"
			result = _tmp2_;
#line 33 "../src/client/components/status-bar.vala"
			return result;
#line 111 "status-bar.c"
		}
		default:
		{
#line 35 "../src/client/components/status-bar.vala"
			g_assert_not_reached ();
#line 117 "status-bar.c"
		}
	}
}

StatusBarContext
status_bar_message_get_context (StatusBarMessage self)
{
	StatusBarContext result;
#line 40 "../src/client/components/status-bar.vala"
	switch (self) {
#line 40 "../src/client/components/status-bar.vala"
		case STATUS_BAR_MESSAGE_OUTBOX_SENDING:
#line 130 "status-bar.c"
		{
#line 42 "../src/client/components/status-bar.vala"
			result = STATUS_BAR_CONTEXT_OUTBOX;
#line 42 "../src/client/components/status-bar.vala"
			return result;
#line 136 "status-bar.c"
		}
#line 40 "../src/client/components/status-bar.vala"
		case STATUS_BAR_MESSAGE_OUTBOX_SEND_FAILURE:
#line 140 "status-bar.c"
		{
#line 44 "../src/client/components/status-bar.vala"
			result = STATUS_BAR_CONTEXT_OUTBOX;
#line 44 "../src/client/components/status-bar.vala"
			return result;
#line 146 "status-bar.c"
		}
#line 40 "../src/client/components/status-bar.vala"
		case STATUS_BAR_MESSAGE_OUTBOX_SAVE_SENT_MAIL_FAILED:
#line 150 "status-bar.c"
		{
#line 46 "../src/client/components/status-bar.vala"
			result = STATUS_BAR_CONTEXT_OUTBOX;
#line 46 "../src/client/components/status-bar.vala"
			return result;
#line 156 "status-bar.c"
		}
		default:
		{
#line 48 "../src/client/components/status-bar.vala"
			g_assert_not_reached ();
#line 162 "status-bar.c"
		}
	}
}

static GType
status_bar_message_get_type_once (void)
{
	static const GEnumValue values[] = {{STATUS_BAR_MESSAGE_OUTBOX_SENDING, "STATUS_BAR_MESSAGE_OUTBOX_SENDING", "outbox-sending"}, {STATUS_BAR_MESSAGE_OUTBOX_SEND_FAILURE, "STATUS_BAR_MESSAGE_OUTBOX_SEND_FAILURE", "outbox-send-failure"}, {STATUS_BAR_MESSAGE_OUTBOX_SAVE_SENT_MAIL_FAILED, "STATUS_BAR_MESSAGE_OUTBOX_SAVE_SENT_MAIL_FAILED", "outbox-save-sent-mail-failed"}, {0, NULL, NULL}};
	GType status_bar_message_type_id;
	status_bar_message_type_id = g_enum_register_static ("StatusBarMessage", values);
	return status_bar_message_type_id;
}

GType
status_bar_message_get_type (void)
{
	static volatile gsize status_bar_message_type_id__once = 0;
	if (g_once_init_enter (&status_bar_message_type_id__once)) {
		GType status_bar_message_type_id;
		status_bar_message_type_id = status_bar_message_get_type_once ();
		g_once_init_leave (&status_bar_message_type_id__once, status_bar_message_type_id);
	}
	return status_bar_message_type_id__once;
}

static GType
status_bar_context_get_type_once (void)
{
	static const GEnumValue values[] = {{STATUS_BAR_CONTEXT_OUTBOX, "STATUS_BAR_CONTEXT_OUTBOX", "outbox"}, {0, NULL, NULL}};
	GType status_bar_context_type_id;
	status_bar_context_type_id = g_enum_register_static ("StatusBarContext", values);
	return status_bar_context_type_id;
}

GType
status_bar_context_get_type (void)
{
	static volatile gsize status_bar_context_type_id__once = 0;
	if (g_once_init_enter (&status_bar_context_type_id__once)) {
		GType status_bar_context_type_id;
		status_bar_context_type_id = status_bar_context_get_type_once ();
		g_once_init_leave (&status_bar_context_type_id__once, status_bar_context_type_id);
	}
	return status_bar_context_type_id__once;
}

StatusBar*
status_bar_construct (GType object_type)
{
	StatusBar * self = NULL;
#line 61 "../src/client/components/status-bar.vala"
	self = (StatusBar*) g_object_new (object_type, NULL);
#line 62 "../src/client/components/status-bar.vala"
	status_bar_set_context_id (self, STATUS_BAR_CONTEXT_OUTBOX);
#line 61 "../src/client/components/status-bar.vala"
	return self;
#line 219 "status-bar.c"
}

StatusBar*
status_bar_new (void)
{
#line 61 "../src/client/components/status-bar.vala"
	return status_bar_construct (TYPE_STATUS_BAR);
#line 227 "status-bar.c"
}

static void
status_bar_set_context_id (StatusBar* self,
                           StatusBarContext context)
{
	GeeHashMap* _tmp0_;
	GEnumValue* _tmp1_;
#line 65 "../src/client/components/status-bar.vala"
	g_return_if_fail (IS_STATUS_BAR (self));
#line 66 "../src/client/components/status-bar.vala"
	_tmp0_ = self->priv->context_ids;
#line 66 "../src/client/components/status-bar.vala"
	_tmp1_ = g_enum_get_value (g_type_class_ref (STATUS_BAR_TYPE_CONTEXT), context);
#line 66 "../src/client/components/status-bar.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) context), (gpointer) ((guintptr) gtk_statusbar_get_context_id (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_statusbar_get_type (), GtkStatusbar), (_tmp1_ != NULL) ? _tmp1_->value_name : NULL)));
#line 244 "status-bar.c"
}

static gint
status_bar_get_count (StatusBar* self,
                      StatusBarMessage message)
{
	gint _tmp0_ = 0;
	GeeHashMap* _tmp1_;
	gint result;
#line 69 "../src/client/components/status-bar.vala"
	g_return_val_if_fail (IS_STATUS_BAR (self), 0);
#line 70 "../src/client/components/status-bar.vala"
	_tmp1_ = self->priv->message_counts;
#line 70 "../src/client/components/status-bar.vala"
	if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) message))) {
#line 260 "status-bar.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
#line 70 "../src/client/components/status-bar.vala"
		_tmp2_ = self->priv->message_counts;
#line 70 "../src/client/components/status-bar.vala"
		_tmp3_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) message));
#line 70 "../src/client/components/status-bar.vala"
		_tmp0_ = (gint) ((gintptr) _tmp3_);
#line 269 "status-bar.c"
	} else {
#line 70 "../src/client/components/status-bar.vala"
		_tmp0_ = 0;
#line 273 "status-bar.c"
	}
#line 70 "../src/client/components/status-bar.vala"
	result = _tmp0_;
#line 70 "../src/client/components/status-bar.vala"
	return result;
#line 279 "status-bar.c"
}

static void
status_bar_push_message (StatusBar* self,
                         StatusBarMessage message)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 73 "../src/client/components/status-bar.vala"
	g_return_if_fail (IS_STATUS_BAR (self));
#line 74 "../src/client/components/status-bar.vala"
	_tmp0_ = self->priv->message_ids;
#line 74 "../src/client/components/status-bar.vala"
	_tmp1_ = self->priv->context_ids;
#line 74 "../src/client/components/status-bar.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) status_bar_message_get_context (message)));
#line 74 "../src/client/components/status-bar.vala"
	_tmp3_ = status_bar_message_get_text (message);
#line 74 "../src/client/components/status-bar.vala"
	_tmp4_ = _tmp3_;
#line 74 "../src/client/components/status-bar.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) message), (gpointer) ((guintptr) gtk_statusbar_push (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_statusbar_get_type (), GtkStatusbar), (guint) ((guintptr) _tmp2_), _tmp4_)));
#line 74 "../src/client/components/status-bar.vala"
	_g_free0 (_tmp4_);
#line 307 "status-bar.c"
}

static void
status_bar_remove_message (StatusBar* self,
                           StatusBarMessage message)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeHashMap* _tmp2_;
	gpointer _tmp3_;
	GeeHashMap* _tmp4_;
#line 77 "../src/client/components/status-bar.vala"
	g_return_if_fail (IS_STATUS_BAR (self));
#line 78 "../src/client/components/status-bar.vala"
	_tmp0_ = self->priv->context_ids;
#line 78 "../src/client/components/status-bar.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) status_bar_message_get_context (message)));
#line 78 "../src/client/components/status-bar.vala"
	_tmp2_ = self->priv->message_ids;
#line 78 "../src/client/components/status-bar.vala"
	_tmp3_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) message));
#line 78 "../src/client/components/status-bar.vala"
	gtk_statusbar_remove (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_statusbar_get_type (), GtkStatusbar), (guint) ((guintptr) _tmp1_), (guint) ((guintptr) _tmp3_));
#line 79 "../src/client/components/status-bar.vala"
	_tmp4_ = self->priv->message_ids;
#line 79 "../src/client/components/status-bar.vala"
	gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) message), NULL);
#line 335 "status-bar.c"
}

/**
     * Return whether the message has been activated more times than it has
     * been deactivated.
     */
gboolean
status_bar_is_message_active (StatusBar* self,
                              StatusBarMessage message)
{
	GeeHashMap* _tmp0_;
	gboolean result;
#line 86 "../src/client/components/status-bar.vala"
	g_return_val_if_fail (IS_STATUS_BAR (self), FALSE);
#line 87 "../src/client/components/status-bar.vala"
	_tmp0_ = self->priv->message_ids;
#line 87 "../src/client/components/status-bar.vala"
	result = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) message));
#line 87 "../src/client/components/status-bar.vala"
	return result;
#line 356 "status-bar.c"
}

void
status_bar_activate_message (StatusBar* self,
                             StatusBarMessage message)
{
	GeeHashMap* _tmp0_;
#line 90 "../src/client/components/status-bar.vala"
	g_return_if_fail (IS_STATUS_BAR (self));
#line 91 "../src/client/components/status-bar.vala"
	if (status_bar_is_message_active (self, message)) {
#line 92 "../src/client/components/status-bar.vala"
		status_bar_remove_message (self, message);
#line 370 "status-bar.c"
	}
#line 94 "../src/client/components/status-bar.vala"
	status_bar_push_message (self, message);
#line 95 "../src/client/components/status-bar.vala"
	_tmp0_ = self->priv->message_counts;
#line 95 "../src/client/components/status-bar.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) message), (gpointer) ((gintptr) (status_bar_get_count (self, message) + 1)));
#line 378 "status-bar.c"
}

void
status_bar_deactivate_message (StatusBar* self,
                               StatusBarMessage message)
{
	gint count = 0;
	GeeHashMap* _tmp0_;
#line 98 "../src/client/components/status-bar.vala"
	g_return_if_fail (IS_STATUS_BAR (self));
#line 99 "../src/client/components/status-bar.vala"
	if (!status_bar_is_message_active (self, message)) {
#line 100 "../src/client/components/status-bar.vala"
		return;
#line 393 "status-bar.c"
	}
#line 102 "../src/client/components/status-bar.vala"
	count = status_bar_get_count (self, message);
#line 103 "../src/client/components/status-bar.vala"
	if (count == 1) {
#line 104 "../src/client/components/status-bar.vala"
		status_bar_remove_message (self, message);
#line 401 "status-bar.c"
	}
#line 105 "../src/client/components/status-bar.vala"
	_tmp0_ = self->priv->message_counts;
#line 105 "../src/client/components/status-bar.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) message), (gpointer) ((gintptr) (count - 1)));
#line 407 "status-bar.c"
}

static void
status_bar_class_init (StatusBarClass * klass,
                       gpointer klass_data)
{
#line 16 "../src/client/components/status-bar.vala"
	status_bar_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/client/components/status-bar.vala"
	g_type_class_adjust_private_offset (klass, &StatusBar_private_offset);
#line 16 "../src/client/components/status-bar.vala"
	G_OBJECT_CLASS (klass)->finalize = status_bar_finalize;
#line 420 "status-bar.c"
}

static void
status_bar_instance_init (StatusBar * self,
                          gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 16 "../src/client/components/status-bar.vala"
	self->priv = status_bar_get_instance_private (self);
#line 57 "../src/client/components/status-bar.vala"
	_tmp0_ = gee_hash_map_new (STATUS_BAR_TYPE_CONTEXT, NULL, NULL, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 57 "../src/client/components/status-bar.vala"
	self->priv->context_ids = _tmp0_;
#line 58 "../src/client/components/status-bar.vala"
	_tmp1_ = gee_hash_map_new (STATUS_BAR_TYPE_MESSAGE, NULL, NULL, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "../src/client/components/status-bar.vala"
	self->priv->message_ids = _tmp1_;
#line 59 "../src/client/components/status-bar.vala"
	_tmp2_ = gee_hash_map_new (STATUS_BAR_TYPE_MESSAGE, NULL, NULL, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 59 "../src/client/components/status-bar.vala"
	self->priv->message_counts = _tmp2_;
#line 444 "status-bar.c"
}

static void
status_bar_finalize (GObject * obj)
{
	StatusBar * self;
#line 16 "../src/client/components/status-bar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATUS_BAR, StatusBar);
#line 57 "../src/client/components/status-bar.vala"
	_g_object_unref0 (self->priv->context_ids);
#line 58 "../src/client/components/status-bar.vala"
	_g_object_unref0 (self->priv->message_ids);
#line 59 "../src/client/components/status-bar.vala"
	_g_object_unref0 (self->priv->message_counts);
#line 16 "../src/client/components/status-bar.vala"
	G_OBJECT_CLASS (status_bar_parent_class)->finalize (obj);
#line 461 "status-bar.c"
}

/**
 * A wrapper around Gtk.Statusbar that predefines messages and context areas so
 * you don't have to keep track of them elsewhere.  You can activate and
 * deactivate messages, instead of worrying about context areas and stacks.
 * Internally, activations are reference counted, and every new activation
 * pushes the message to the top of its context area's stack.  Only when
 * the number of deactivations equals the number of activations is the message
 * removed from the stack entirely.
 */
static GType
status_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StatusBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) status_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StatusBar), 0, (GInstanceInitFunc) status_bar_instance_init, NULL };
	GType status_bar_type_id;
	status_bar_type_id = g_type_register_static (gtk_statusbar_get_type (), "StatusBar", &g_define_type_info, 0);
	StatusBar_private_offset = g_type_add_instance_private (status_bar_type_id, sizeof (StatusBarPrivate));
	return status_bar_type_id;
}

GType
status_bar_get_type (void)
{
	static volatile gsize status_bar_type_id__once = 0;
	if (g_once_init_enter (&status_bar_type_id__once)) {
		GType status_bar_type_id;
		status_bar_type_id = status_bar_get_type_once ();
		g_once_init_leave (&status_bar_type_id__once, status_bar_type_id);
	}
	return status_bar_type_id__once;
}

