/* conversation-list-model.c generated by valac 0.56.14, the Vala compiler
 * generated from conversation-list-model.vala, do not modify */

/*
 * Copyright © 2022 John Renner <john@jrenner.net>
 * Copyright © 2022 Cédric Bellegarde <cedric.bellegarde@adishatz.org>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */
/* The whole goal of this class to wrap the ConversationMonitor with a view that presents a sorted list*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "geary-client-44.1.h"
#include "geary-engine.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	CONVERSATION_LIST_MODEL_0_PROPERTY,
	CONVERSATION_LIST_MODEL_MONITOR_PROPERTY,
	CONVERSATION_LIST_MODEL_NUM_PROPERTIES
};
static GParamSpec* conversation_list_model_properties[CONVERSATION_LIST_MODEL_NUM_PROPERTIES];
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block78Data Block78Data;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
enum  {
	CONVERSATION_LIST_MODEL_CONVERSATIONS_ADDED_SIGNAL,
	CONVERSATION_LIST_MODEL_CONVERSATIONS_REMOVED_SIGNAL,
	CONVERSATION_LIST_MODEL_CONVERSATIONS_LOADED_SIGNAL,
	CONVERSATION_LIST_MODEL_CONVERSATION_UPDATED_SIGNAL,
	CONVERSATION_LIST_MODEL_NUM_SIGNALS
};
static guint conversation_list_model_signals[CONVERSATION_LIST_MODEL_NUM_SIGNALS] = {0};

struct _ConversationListModelPrivate {
	GearyAppConversationMonitor* _monitor;
	gboolean scanning;
};

struct _Block78Data {
	int _ref_count_;
	GPtrArray* self;
	GCompareFunc compare_func;
};

static gint ConversationListModel_private_offset;
static gpointer conversation_list_model_parent_class = NULL;
static GListModelInterface * conversation_list_model_g_list_model_parent_iface = NULL;

VALA_EXTERN GearyAppConversationMonitor* conversation_list_model_get_monitor (ConversationListModel* self);
static void conversation_list_model_on_conversations_added (ConversationListModel* self,
                                                     GeeCollection* conversations);
static void _conversation_list_model_on_conversations_added_geary_app_conversation_monitor_conversations_added (GearyAppConversationMonitor* _sender,
                                                                                                         GeeCollection* conversations,
                                                                                                         gpointer self);
static void conversation_list_model_on_conversation_updated (ConversationListModel* self,
                                                      GearyAppConversationMonitor* sender,
                                                      GearyAppConversation* convo,
                                                      GeeCollection* emails);
static void _conversation_list_model_on_conversation_updated_geary_app_conversation_monitor_conversation_appended (GearyAppConversationMonitor* _sender,
                                                                                                            GearyAppConversation* conversation,
                                                                                                            GeeCollection* email,
                                                                                                            gpointer self);
static void _conversation_list_model_on_conversation_updated_geary_app_conversation_monitor_conversation_trimmed (GearyAppConversationMonitor* _sender,
                                                                                                           GearyAppConversation* conversation,
                                                                                                           GeeCollection* email,
                                                                                                           gpointer self);
static void conversation_list_model_on_conversations_removed (ConversationListModel* self,
                                                       GeeCollection* conversations);
static void _conversation_list_model_on_conversations_removed_geary_app_conversation_monitor_conversations_removed (GearyAppConversationMonitor* _sender,
                                                                                                             GeeCollection* conversations,
                                                                                                             gpointer self);
static void conversation_list_model_on_scan_started (ConversationListModel* self,
                                              GearyAppConversationMonitor* source);
static void _conversation_list_model_on_scan_started_geary_app_conversation_monitor_scan_started (GearyAppConversationMonitor* _sender,
                                                                                           gpointer self);
static void conversation_list_model_on_scan_completed (ConversationListModel* self,
                                                GearyAppConversationMonitor* source);
static void _conversation_list_model_on_scan_completed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                               gpointer self);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN void conversation_list_model_set_monitor (ConversationListModel* self,
                                          GearyAppConversationMonitor* value);
VALA_EXTERN ConversationListModel* conversation_list_model_new (GearyAppConversationMonitor* monitor);
VALA_EXTERN ConversationListModel* conversation_list_model_construct (GType object_type,
                                                          GearyAppConversationMonitor* monitor);
static gint conversation_list_model_compare (GObject* a,
                                      GObject* b);
static gboolean __lambda23_ (ConversationListModel* self);
static gboolean ___lambda23__gsource_func (gpointer self);
static GObject* conversation_list_model_real_get_item (GListModel* base,
                                                guint position);
static GType conversation_list_model_real_get_item_type (GListModel* base);
static guint conversation_list_model_real_get_n_items (GListModel* base);
static gboolean conversation_list_model_insert_conversation (ConversationListModel* self,
                                                      GearyAppConversation* convo);
static GPtrArray* conversation_list_model_conversations_indexes (ConversationListModel* self,
                                                          GeeCollection* conversations);
static void conversation_list_model_update_added (ConversationListModel* self,
                                           GPtrArray* indexes);
static Block78Data* block78_data_ref (Block78Data* _data78_);
static void block78_data_unref (void * _userdata_);
static gint ___lambda0__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static gint __lambda21_ (guint a,
                  guint b);
static gint ___lambda21__gcompare_func (gconstpointer a,
                                 gconstpointer b);
static guint* _uint_dup (guint* self);
static void conversation_list_model_update_removed (ConversationListModel* self,
                                             GPtrArray* indexes);
static gint __lambda22_ (guint a,
                  guint b);
static gint ___lambda22__gcompare_func (gconstpointer a,
                                 gconstpointer b);
static gint _conversation_list_model_compare_gcompare_func (gconstpointer a,
                                                     gconstpointer b);
static void conversation_list_model_finalize (GObject * obj);
static GType conversation_list_model_get_type_once (void);
static void _vala_conversation_list_model_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_conversation_list_model_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
conversation_list_model_get_instance_private (ConversationListModel* self)
{
	return G_STRUCT_MEMBER_P (self, ConversationListModel_private_offset);
}

static void
_conversation_list_model_on_conversations_added_geary_app_conversation_monitor_conversations_added (GearyAppConversationMonitor* _sender,
                                                                                                    GeeCollection* conversations,
                                                                                                    gpointer self)
{
#line 28 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_on_conversations_added ((ConversationListModel*) self, conversations);
#line 155 "conversation-list-model.c"
}

static void
_conversation_list_model_on_conversation_updated_geary_app_conversation_monitor_conversation_appended (GearyAppConversationMonitor* _sender,
                                                                                                       GearyAppConversation* conversation,
                                                                                                       GeeCollection* email,
                                                                                                       gpointer self)
{
#line 29 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_on_conversation_updated ((ConversationListModel*) self, _sender, conversation, email);
#line 166 "conversation-list-model.c"
}

static void
_conversation_list_model_on_conversation_updated_geary_app_conversation_monitor_conversation_trimmed (GearyAppConversationMonitor* _sender,
                                                                                                      GearyAppConversation* conversation,
                                                                                                      GeeCollection* email,
                                                                                                      gpointer self)
{
#line 30 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_on_conversation_updated ((ConversationListModel*) self, _sender, conversation, email);
#line 177 "conversation-list-model.c"
}

static void
_conversation_list_model_on_conversations_removed_geary_app_conversation_monitor_conversations_removed (GearyAppConversationMonitor* _sender,
                                                                                                        GeeCollection* conversations,
                                                                                                        gpointer self)
{
#line 31 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_on_conversations_removed ((ConversationListModel*) self, conversations);
#line 187 "conversation-list-model.c"
}

static void
_conversation_list_model_on_scan_started_geary_app_conversation_monitor_scan_started (GearyAppConversationMonitor* _sender,
                                                                                      gpointer self)
{
#line 32 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_on_scan_started ((ConversationListModel*) self, _sender);
#line 196 "conversation-list-model.c"
}

static void
_conversation_list_model_on_scan_completed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                          gpointer self)
{
#line 33 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_on_scan_completed ((ConversationListModel*) self, _sender);
#line 205 "conversation-list-model.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 11 "../src/client/conversation-list/conversation-list-model.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 213 "conversation-list-model.c"
}

GearyAppConversationMonitor*
conversation_list_model_get_monitor (ConversationListModel* self)
{
	GearyAppConversationMonitor* result;
	GearyAppConversationMonitor* _tmp0_;
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_MODEL (self), NULL);
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = self->priv->_monitor;
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	result = _tmp0_;
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 229 "conversation-list-model.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	return self ? g_object_ref (self) : NULL;
#line 237 "conversation-list-model.c"
}

void
conversation_list_model_set_monitor (ConversationListModel* self,
                                     GearyAppConversationMonitor* value)
{
	GearyAppConversationMonitor* old_value;
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_MODEL (self));
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	old_value = conversation_list_model_get_monitor (self);
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	if (old_value != value) {
#line 251 "conversation-list-model.c"
		GearyAppConversationMonitor* _tmp0_;
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
		_g_object_unref0 (self->priv->_monitor);
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
		self->priv->_monitor = _tmp0_;
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_list_model_properties[CONVERSATION_LIST_MODEL_MONITOR_PROPERTY]);
#line 261 "conversation-list-model.c"
	}
}

ConversationListModel*
conversation_list_model_construct (GType object_type,
                                   GearyAppConversationMonitor* monitor)
{
	ConversationListModel * self = NULL;
#line 16 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (monitor, GEARY_APP_TYPE_CONVERSATION_MONITOR), NULL);
#line 16 "../src/client/conversation-list/conversation-list-model.vala"
	self = (ConversationListModel*) g_object_new (object_type, NULL);
#line 17 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_set_monitor (self, monitor);
#line 19 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_connect_object (monitor, "conversations-added", (GCallback) _conversation_list_model_on_conversations_added_geary_app_conversation_monitor_conversations_added, self, 0);
#line 20 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_connect_object (monitor, "conversation-appended", (GCallback) _conversation_list_model_on_conversation_updated_geary_app_conversation_monitor_conversation_appended, self, 0);
#line 21 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_connect_object (monitor, "conversation-trimmed", (GCallback) _conversation_list_model_on_conversation_updated_geary_app_conversation_monitor_conversation_trimmed, self, 0);
#line 22 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_connect_object (monitor, "conversations-removed", (GCallback) _conversation_list_model_on_conversations_removed_geary_app_conversation_monitor_conversations_removed, self, 0);
#line 23 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_connect_object (monitor, "scan-started", (GCallback) _conversation_list_model_on_scan_started_geary_app_conversation_monitor_scan_started, self, 0);
#line 24 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_connect_object (monitor, "scan-completed", (GCallback) _conversation_list_model_on_scan_completed_geary_app_conversation_monitor_scan_completed, self, 0);
#line 16 "../src/client/conversation-list/conversation-list-model.vala"
	return self;
#line 290 "conversation-list-model.c"
}

ConversationListModel*
conversation_list_model_new (GearyAppConversationMonitor* monitor)
{
#line 16 "../src/client/conversation-list/conversation-list-model.vala"
	return conversation_list_model_construct (CONVERSATION_LIST_TYPE_MODEL, monitor);
#line 298 "conversation-list-model.c"
}

static gint
conversation_list_model_compare (GObject* a,
                                 GObject* b)
{
	gint result;
#line 41 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (a, G_TYPE_OBJECT), 0);
#line 41 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (b, G_TYPE_OBJECT), 0);
#line 42 "../src/client/conversation-list/conversation-list-model.vala"
	result = util_email_compare_conversation_descending (G_TYPE_CHECK_INSTANCE_TYPE (a, GEARY_APP_TYPE_CONVERSATION) ? ((GearyAppConversation*) a) : NULL, G_TYPE_CHECK_INSTANCE_TYPE (b, GEARY_APP_TYPE_CONVERSATION) ? ((GearyAppConversation*) b) : NULL);
#line 42 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 314 "conversation-list-model.c"
}

static void
conversation_list_model_on_scan_started (ConversationListModel* self,
                                         GearyAppConversationMonitor* source)
{
#line 49 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_MODEL (self));
#line 49 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (source, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 50 "../src/client/conversation-list/conversation-list-model.vala"
	self->priv->scanning = TRUE;
#line 327 "conversation-list-model.c"
}

static gboolean
__lambda23_ (ConversationListModel* self)
{
	gboolean result;
#line 56 "../src/client/conversation-list/conversation-list-model.vala"
	if (!self->priv->scanning) {
#line 57 "../src/client/conversation-list/conversation-list-model.vala"
		g_signal_emit (self, conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATIONS_LOADED_SIGNAL], 0);
#line 338 "conversation-list-model.c"
	}
#line 59 "../src/client/conversation-list/conversation-list-model.vala"
	result = FALSE;
#line 59 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 344 "conversation-list-model.c"
}

static gboolean
___lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda23_ ((ConversationListModel*) self);
#line 55 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 354 "conversation-list-model.c"
}

static void
conversation_list_model_on_scan_completed (ConversationListModel* self,
                                           GearyAppConversationMonitor* source)
{
#line 53 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_MODEL (self));
#line 53 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (source, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 54 "../src/client/conversation-list/conversation-list-model.vala"
	self->priv->scanning = FALSE;
#line 55 "../src/client/conversation-list/conversation-list-model.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda23__gsource_func, g_object_ref (self), g_object_unref);
#line 369 "conversation-list-model.c"
}

gboolean
conversation_list_model_load_more (ConversationListModel* self,
                                   gint amount)
{
	GearyAppConversationMonitor* _tmp0_;
	GearyAppConversationMonitor* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean result;
#line 63 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_MODEL (self), FALSE);
#line 64 "../src/client/conversation-list/conversation-list-model.vala"
	if (self->priv->scanning) {
#line 65 "../src/client/conversation-list/conversation-list-model.vala"
		result = FALSE;
#line 65 "../src/client/conversation-list/conversation-list-model.vala"
		return result;
#line 389 "conversation-list-model.c"
	}
#line 68 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = self->priv->_monitor;
#line 68 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp1_ = self->priv->_monitor;
#line 68 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp2_ = geary_app_conversation_monitor_get_min_window_count (_tmp1_);
#line 68 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp3_ = _tmp2_;
#line 68 "../src/client/conversation-list/conversation-list-model.vala"
	geary_app_conversation_monitor_set_min_window_count (_tmp1_, _tmp3_ + amount);
#line 69 "../src/client/conversation-list/conversation-list-model.vala"
	result = TRUE;
#line 69 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 405 "conversation-list-model.c"
}

static GObject*
conversation_list_model_real_get_item (GListModel* base,
                                       guint position)
{
	ConversationListModel * self;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	GObject* _tmp2_;
	GObject* result;
#line 77 "../src/client/conversation-list/conversation-list-model.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_LIST_TYPE_MODEL, ConversationListModel);
#line 78 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = self->items;
#line 78 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp1_ = g_ptr_array_index (_tmp0_, position);
#line 78 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((GearyAppConversation*) _tmp1_, G_TYPE_OBJECT, GObject));
#line 78 "../src/client/conversation-list/conversation-list-model.vala"
	result = _tmp2_;
#line 78 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 429 "conversation-list-model.c"
}

static GType
conversation_list_model_real_get_item_type (GListModel* base)
{
	ConversationListModel * self;
	GType result;
#line 81 "../src/client/conversation-list/conversation-list-model.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_LIST_TYPE_MODEL, ConversationListModel);
#line 82 "../src/client/conversation-list/conversation-list-model.vala"
	result = GEARY_APP_TYPE_CONVERSATION;
#line 82 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 443 "conversation-list-model.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5905 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5906 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5906 "glib-2.0.vapi"
	return result;
#line 456 "conversation-list-model.c"
}

static guint
conversation_list_model_real_get_n_items (GListModel* base)
{
	ConversationListModel * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint result;
#line 85 "../src/client/conversation-list/conversation-list-model.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_LIST_TYPE_MODEL, ConversationListModel);
#line 86 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = self->items;
#line 86 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 86 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp2_ = _tmp1_;
#line 86 "../src/client/conversation-list/conversation-list-model.vala"
	result = (guint) _tmp2_;
#line 86 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 479 "conversation-list-model.c"
}

static gboolean
conversation_list_model_insert_conversation (ConversationListModel* self,
                                             GearyAppConversation* convo)
{
	GearyEmail* last_email = NULL;
	GearyEmail* _tmp0_;
	GearyEmail* _tmp1_;
	GPtrArray* _tmp2_;
	GearyAppConversation* _tmp3_;
	gboolean result;
#line 89 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_MODEL (self), FALSE);
#line 89 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (convo, GEARY_APP_TYPE_CONVERSATION), FALSE);
#line 91 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = geary_app_conversation_get_latest_recv_email (convo, GEARY_APP_CONVERSATION_LOCATION_ANYWHERE, NULL);
#line 91 "../src/client/conversation-list/conversation-list-model.vala"
	last_email = _tmp0_;
#line 93 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp1_ = last_email;
#line 93 "../src/client/conversation-list/conversation-list-model.vala"
	if (_tmp1_ == NULL) {
#line 94 "../src/client/conversation-list/conversation-list-model.vala"
		g_debug ("conversation-list-model.vala:94: Cannot add conversation: last email i" \
"s null");
#line 95 "../src/client/conversation-list/conversation-list-model.vala"
		result = FALSE;
#line 95 "../src/client/conversation-list/conversation-list-model.vala"
		_g_object_unref0 (last_email);
#line 95 "../src/client/conversation-list/conversation-list-model.vala"
		return result;
#line 512 "conversation-list-model.c"
	}
#line 98 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp2_ = self->items;
#line 98 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp3_ = _g_object_ref0 (convo);
#line 98 "../src/client/conversation-list/conversation-list-model.vala"
	g_ptr_array_add (_tmp2_, _tmp3_);
#line 100 "../src/client/conversation-list/conversation-list-model.vala"
	result = TRUE;
#line 100 "../src/client/conversation-list/conversation-list-model.vala"
	_g_object_unref0 (last_email);
#line 100 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 526 "conversation-list-model.c"
}

static GPtrArray*
conversation_list_model_conversations_indexes (ConversationListModel* self,
                                               GeeCollection* conversations)
{
	GPtrArray* indexes = NULL;
	GPtrArray* _tmp0_;
	guint index = 0U;
	GPtrArray* result;
#line 103 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_MODEL (self), NULL);
#line 103 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversations, GEE_TYPE_COLLECTION), NULL);
#line 104 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, NULL);
#line 104 "../src/client/conversation-list/conversation-list-model.vala"
	indexes = _tmp0_;
#line 545 "conversation-list-model.c"
	{
		GeeIterator* _convo_it = NULL;
		GeeIterator* _tmp1_;
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (conversations, GEE_TYPE_ITERABLE, GeeIterable));
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
		_convo_it = _tmp1_;
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
		while (TRUE) {
#line 555 "conversation-list-model.c"
			GeeIterator* _tmp2_;
			GearyAppConversation* convo = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GPtrArray* _tmp5_;
			GearyAppConversation* _tmp6_;
			guint _tmp7_ = 0U;
			gboolean _tmp8_;
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp2_ = _convo_it;
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
				break;
#line 570 "conversation-list-model.c"
			}
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp3_ = _convo_it;
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
			convo = (GearyAppConversation*) _tmp4_;
#line 108 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp5_ = self->items;
#line 108 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp6_ = convo;
#line 108 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp8_ = g_ptr_array_find (_tmp5_, _tmp6_, &_tmp7_);
#line 108 "../src/client/conversation-list/conversation-list-model.vala"
			index = _tmp7_;
#line 108 "../src/client/conversation-list/conversation-list-model.vala"
			if (_tmp8_) {
#line 588 "conversation-list-model.c"
				GPtrArray* _tmp9_;
#line 109 "../src/client/conversation-list/conversation-list-model.vala"
				_tmp9_ = indexes;
#line 109 "../src/client/conversation-list/conversation-list-model.vala"
				g_ptr_array_add (_tmp9_, (gpointer) ((guintptr) index));
#line 594 "conversation-list-model.c"
			}
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
			_g_object_unref0 (convo);
#line 598 "conversation-list-model.c"
		}
#line 107 "../src/client/conversation-list/conversation-list-model.vala"
		_g_object_unref0 (_convo_it);
#line 602 "conversation-list-model.c"
	}
#line 113 "../src/client/conversation-list/conversation-list-model.vala"
	result = indexes;
#line 113 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 608 "conversation-list-model.c"
}

static Block78Data*
block78_data_ref (Block78Data* _data78_)
{
#line 5877 "glib-2.0.vapi"
	g_atomic_int_inc (&_data78_->_ref_count_);
#line 5877 "glib-2.0.vapi"
	return _data78_;
#line 618 "conversation-list-model.c"
}

static void
block78_data_unref (void * _userdata_)
{
	Block78Data* _data78_;
	_data78_ = (Block78Data*) _userdata_;
#line 5877 "glib-2.0.vapi"
	if (g_atomic_int_dec_and_test (&_data78_->_ref_count_)) {
#line 628 "conversation-list-model.c"
		GPtrArray* self;
#line 5877 "glib-2.0.vapi"
		self = _data78_->self;
#line 5877 "glib-2.0.vapi"
		_g_ptr_array_unref0 (self);
#line 5877 "glib-2.0.vapi"
		g_slice_free (Block78Data, _data78_);
#line 636 "conversation-list-model.c"
	}
}

static gint
__lambda0_ (Block78Data* _data78_,
            gconstpointer** a,
            gconstpointer** b)
{
	GPtrArray* self;
	gint result;
#line 5878 "glib-2.0.vapi"
	self = _data78_->self;
#line 5879 "glib-2.0.vapi"
	result = _data78_->compare_func ((gconstpointer**) (*a), (gconstpointer**) (*b));
#line 5879 "glib-2.0.vapi"
	return result;
#line 653 "conversation-list-model.c"
}

static gint
___lambda0__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda0_ (self, a, b);
#line 5878 "glib-2.0.vapi"
	return result;
#line 665 "conversation-list-model.c"
}

static void
vala_g_ptr_array_sort (GPtrArray* self,
                       GCompareFunc compare_func)
{
	Block78Data* _data78_;
#line 5877 "glib-2.0.vapi"
	g_return_if_fail (self != NULL);
#line 5877 "glib-2.0.vapi"
	_data78_ = g_slice_new0 (Block78Data);
#line 5877 "glib-2.0.vapi"
	_data78_->_ref_count_ = 1;
#line 5877 "glib-2.0.vapi"
	_data78_->self = g_ptr_array_ref (self);
#line 5877 "glib-2.0.vapi"
	_data78_->compare_func = compare_func;
#line 5878 "glib-2.0.vapi"
	g_ptr_array_sort_with_data (self, ___lambda0__gcompare_data_func, _data78_);
#line 5877 "glib-2.0.vapi"
	block78_data_unref (_data78_);
#line 5877 "glib-2.0.vapi"
	_data78_ = NULL;
#line 689 "conversation-list-model.c"
}

static gint
__lambda21_ (guint a,
             guint b)
{
	gint result;
#line 118 "../src/client/conversation-list/conversation-list-model.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 118 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 701 "conversation-list-model.c"
}

static gint
___lambda21__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda21_ ((guint) ((guintptr) a), (guint) ((guintptr) b));
#line 117 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 712 "conversation-list-model.c"
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 128 "../src/client/conversation-list/conversation-list-model.vala"
	dup = g_new0 (guint, 1);
#line 128 "../src/client/conversation-list/conversation-list-model.vala"
	memcpy (dup, self, sizeof (guint));
#line 128 "../src/client/conversation-list/conversation-list-model.vala"
	return dup;
#line 725 "conversation-list-model.c"
}

static gpointer
__uint_dup0 (gpointer self)
{
#line 128 "../src/client/conversation-list/conversation-list-model.vala"
	return self ? _uint_dup (self) : NULL;
#line 733 "conversation-list-model.c"
}

static void
conversation_list_model_update_added (ConversationListModel* self,
                                      GPtrArray* indexes)
{
#line 116 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_MODEL (self));
#line 116 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (indexes != NULL);
#line 117 "../src/client/conversation-list/conversation-list-model.vala"
	vala_g_ptr_array_sort (indexes, ___lambda21__gcompare_func);
#line 121 "../src/client/conversation-list/conversation-list-model.vala"
	while (TRUE) {
#line 748 "conversation-list-model.c"
		gint _tmp0_;
		gint _tmp1_;
		guint* last_index = NULL;
		guint count = 0U;
		gconstpointer _tmp8_;
#line 121 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp0_ = vala_g_ptr_array_get_length (indexes);
#line 121 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp1_ = _tmp0_;
#line 121 "../src/client/conversation-list/conversation-list-model.vala"
		if (!(_tmp1_ > 0)) {
#line 121 "../src/client/conversation-list/conversation-list-model.vala"
			break;
#line 762 "conversation-list-model.c"
		}
#line 122 "../src/client/conversation-list/conversation-list-model.vala"
		last_index = NULL;
#line 123 "../src/client/conversation-list/conversation-list-model.vala"
		count = (guint) 0;
#line 768 "conversation-list-model.c"
		{
			GPtrArray* index_collection = NULL;
			guint index_index = 0U;
#line 124 "../src/client/conversation-list/conversation-list-model.vala"
			index_collection = indexes;
#line 124 "../src/client/conversation-list/conversation-list-model.vala"
			for (index_index = 0; index_index < index_collection->len; index_index = index_index + 1) {
#line 776 "conversation-list-model.c"
				guint index = 0U;
#line 124 "../src/client/conversation-list/conversation-list-model.vala"
				index = g_ptr_array_index (index_collection, index_index);
#line 780 "conversation-list-model.c"
				{
					gboolean _tmp2_ = FALSE;
					guint* _tmp3_;
					guint _tmp5_;
					guint* _tmp6_;
					guint _tmp7_;
#line 125 "../src/client/conversation-list/conversation-list-model.vala"
					_tmp3_ = last_index;
#line 125 "../src/client/conversation-list/conversation-list-model.vala"
					if (_tmp3_ != NULL) {
#line 791 "conversation-list-model.c"
						guint* _tmp4_;
#line 125 "../src/client/conversation-list/conversation-list-model.vala"
						_tmp4_ = last_index;
#line 125 "../src/client/conversation-list/conversation-list-model.vala"
						_tmp2_ = index > ((*_tmp4_) + 1);
#line 797 "conversation-list-model.c"
					} else {
#line 125 "../src/client/conversation-list/conversation-list-model.vala"
						_tmp2_ = FALSE;
#line 801 "conversation-list-model.c"
					}
#line 125 "../src/client/conversation-list/conversation-list-model.vala"
					if (_tmp2_) {
#line 126 "../src/client/conversation-list/conversation-list-model.vala"
						break;
#line 807 "conversation-list-model.c"
					}
#line 128 "../src/client/conversation-list/conversation-list-model.vala"
					_tmp5_ = (guint) ((gint) index);
#line 128 "../src/client/conversation-list/conversation-list-model.vala"
					_tmp6_ = __uint_dup0 (&_tmp5_);
#line 128 "../src/client/conversation-list/conversation-list-model.vala"
					_g_free0 (last_index);
#line 128 "../src/client/conversation-list/conversation-list-model.vala"
					last_index = _tmp6_;
#line 129 "../src/client/conversation-list/conversation-list-model.vala"
					_tmp7_ = count;
#line 129 "../src/client/conversation-list/conversation-list-model.vala"
					count = _tmp7_ + 1;
#line 821 "conversation-list-model.c"
				}
			}
		}
#line 131 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp8_ = g_ptr_array_index (indexes, (guint) 0);
#line 131 "../src/client/conversation-list/conversation-list-model.vala"
		g_list_model_items_changed (G_TYPE_CHECK_INSTANCE_CAST (self, g_list_model_get_type (), GListModel), (guint) ((guintptr) _tmp8_), (guint) 0, count);
#line 132 "../src/client/conversation-list/conversation-list-model.vala"
		g_ptr_array_remove_range (indexes, (guint) 0, count);
#line 121 "../src/client/conversation-list/conversation-list-model.vala"
		_g_free0 (last_index);
#line 833 "conversation-list-model.c"
	}
}

static gint
__lambda22_ (guint a,
             guint b)
{
	gint result;
#line 138 "../src/client/conversation-list/conversation-list-model.vala"
	result = ((gint) (a < b)) - ((gint) (a > b));
#line 138 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 846 "conversation-list-model.c"
}

static gint
___lambda22__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda22_ ((guint) ((guintptr) a), (guint) ((guintptr) b));
#line 137 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 857 "conversation-list-model.c"
}

static void
conversation_list_model_update_removed (ConversationListModel* self,
                                        GPtrArray* indexes)
{
#line 136 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_MODEL (self));
#line 136 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (indexes != NULL);
#line 137 "../src/client/conversation-list/conversation-list-model.vala"
	vala_g_ptr_array_sort (indexes, ___lambda22__gcompare_func);
#line 141 "../src/client/conversation-list/conversation-list-model.vala"
	while (TRUE) {
#line 872 "conversation-list-model.c"
		gint _tmp0_;
		gint _tmp1_;
		guint* last_index = NULL;
		guint count = 0U;
		guint* _tmp7_;
#line 141 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp0_ = vala_g_ptr_array_get_length (indexes);
#line 141 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp1_ = _tmp0_;
#line 141 "../src/client/conversation-list/conversation-list-model.vala"
		if (!(_tmp1_ > 0)) {
#line 141 "../src/client/conversation-list/conversation-list-model.vala"
			break;
#line 886 "conversation-list-model.c"
		}
#line 142 "../src/client/conversation-list/conversation-list-model.vala"
		last_index = NULL;
#line 143 "../src/client/conversation-list/conversation-list-model.vala"
		count = (guint) 0;
#line 892 "conversation-list-model.c"
		{
			GPtrArray* index_collection = NULL;
			guint index_index = 0U;
#line 144 "../src/client/conversation-list/conversation-list-model.vala"
			index_collection = indexes;
#line 144 "../src/client/conversation-list/conversation-list-model.vala"
			for (index_index = 0; index_index < index_collection->len; index_index = index_index + 1) {
#line 900 "conversation-list-model.c"
				guint index = 0U;
#line 144 "../src/client/conversation-list/conversation-list-model.vala"
				index = g_ptr_array_index (index_collection, index_index);
#line 904 "conversation-list-model.c"
				{
					gboolean _tmp2_ = FALSE;
					guint* _tmp3_;
					guint* _tmp5_;
					guint _tmp6_;
#line 145 "../src/client/conversation-list/conversation-list-model.vala"
					_tmp3_ = last_index;
#line 145 "../src/client/conversation-list/conversation-list-model.vala"
					if (_tmp3_ != NULL) {
#line 914 "conversation-list-model.c"
						guint* _tmp4_;
#line 145 "../src/client/conversation-list/conversation-list-model.vala"
						_tmp4_ = last_index;
#line 145 "../src/client/conversation-list/conversation-list-model.vala"
						_tmp2_ = index < ((*_tmp4_) - 1);
#line 920 "conversation-list-model.c"
					} else {
#line 145 "../src/client/conversation-list/conversation-list-model.vala"
						_tmp2_ = FALSE;
#line 924 "conversation-list-model.c"
					}
#line 145 "../src/client/conversation-list/conversation-list-model.vala"
					if (_tmp2_) {
#line 146 "../src/client/conversation-list/conversation-list-model.vala"
						break;
#line 930 "conversation-list-model.c"
					}
#line 148 "../src/client/conversation-list/conversation-list-model.vala"
					_tmp5_ = __uint_dup0 (&index);
#line 148 "../src/client/conversation-list/conversation-list-model.vala"
					_g_free0 (last_index);
#line 148 "../src/client/conversation-list/conversation-list-model.vala"
					last_index = _tmp5_;
#line 149 "../src/client/conversation-list/conversation-list-model.vala"
					_tmp6_ = count;
#line 149 "../src/client/conversation-list/conversation-list-model.vala"
					count = _tmp6_ + 1;
#line 942 "conversation-list-model.c"
				}
			}
		}
#line 151 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp7_ = last_index;
#line 151 "../src/client/conversation-list/conversation-list-model.vala"
		g_list_model_items_changed (G_TYPE_CHECK_INSTANCE_CAST (self, g_list_model_get_type (), GListModel), *_tmp7_, count, (guint) 0);
#line 152 "../src/client/conversation-list/conversation-list-model.vala"
		g_ptr_array_remove_range (indexes, (guint) 0, count);
#line 141 "../src/client/conversation-list/conversation-list-model.vala"
		_g_free0 (last_index);
#line 954 "conversation-list-model.c"
	}
}

static gint
_conversation_list_model_compare_gcompare_func (gconstpointer a,
                                                gconstpointer b)
{
	gint result;
	result = conversation_list_model_compare ((GObject*) a, (GObject*) b);
#line 167 "../src/client/conversation-list/conversation-list-model.vala"
	return result;
#line 966 "conversation-list-model.c"
}

static void
conversation_list_model_on_conversations_added (ConversationListModel* self,
                                                GeeCollection* conversations)
{
	gint _tmp0_;
	gint _tmp1_;
	gint added = 0;
	GPtrArray* _tmp8_;
	GPtrArray* indexes = NULL;
	GPtrArray* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 156 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_MODEL (self));
#line 156 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversations, GEE_TYPE_COLLECTION));
#line 157 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = gee_collection_get_size (conversations);
#line 157 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp1_ = _tmp0_;
#line 157 "../src/client/conversation-list/conversation-list-model.vala"
	g_debug ("conversation-list-model.vala:157: Adding %d conversations.", _tmp1_);
#line 159 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_emit (self, conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATIONS_ADDED_SIGNAL], 0, TRUE);
#line 161 "../src/client/conversation-list/conversation-list-model.vala"
	added = 0;
#line 995 "conversation-list-model.c"
	{
		GeeIterator* _convo_it = NULL;
		GeeIterator* _tmp2_;
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (conversations, GEE_TYPE_ITERABLE, GeeIterable));
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
		_convo_it = _tmp2_;
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
		while (TRUE) {
#line 1005 "conversation-list-model.c"
			GeeIterator* _tmp3_;
			GearyAppConversation* convo = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GearyAppConversation* _tmp6_;
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp3_ = _convo_it;
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
				break;
#line 1017 "conversation-list-model.c"
			}
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp4_ = _convo_it;
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
			convo = (GearyAppConversation*) _tmp5_;
#line 163 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp6_ = convo;
#line 163 "../src/client/conversation-list/conversation-list-model.vala"
			if (conversation_list_model_insert_conversation (self, _tmp6_)) {
#line 1029 "conversation-list-model.c"
				gint _tmp7_;
#line 164 "../src/client/conversation-list/conversation-list-model.vala"
				_tmp7_ = added;
#line 164 "../src/client/conversation-list/conversation-list-model.vala"
				added = _tmp7_ + 1;
#line 1035 "conversation-list-model.c"
			}
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
			_g_object_unref0 (convo);
#line 1039 "conversation-list-model.c"
		}
#line 162 "../src/client/conversation-list/conversation-list-model.vala"
		_g_object_unref0 (_convo_it);
#line 1043 "conversation-list-model.c"
	}
#line 167 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp8_ = self->items;
#line 167 "../src/client/conversation-list/conversation-list-model.vala"
	vala_g_ptr_array_sort (_tmp8_, _conversation_list_model_compare_gcompare_func);
#line 169 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp9_ = conversation_list_model_conversations_indexes (self, conversations);
#line 169 "../src/client/conversation-list/conversation-list-model.vala"
	indexes = _tmp9_;
#line 170 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_update_added (self, indexes);
#line 172 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_emit (self, conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATIONS_ADDED_SIGNAL], 0, FALSE);
#line 174 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp10_ = gee_collection_get_size (conversations);
#line 174 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp11_ = _tmp10_;
#line 174 "../src/client/conversation-list/conversation-list-model.vala"
	g_debug ("conversation-list-model.vala:174: Added %d/%d conversations.", added, _tmp11_);
#line 156 "../src/client/conversation-list/conversation-list-model.vala"
	_g_ptr_array_unref0 (indexes);
#line 1065 "conversation-list-model.c"
}

static void
conversation_list_model_on_conversations_removed (ConversationListModel* self,
                                                  GeeCollection* conversations)
{
	GPtrArray* indexes = NULL;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint removed = 0;
	GPtrArray* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 177 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_MODEL (self));
#line 177 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversations, GEE_TYPE_COLLECTION));
#line 178 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = conversation_list_model_conversations_indexes (self, conversations);
#line 178 "../src/client/conversation-list/conversation-list-model.vala"
	indexes = _tmp0_;
#line 180 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp1_ = gee_collection_get_size (conversations);
#line 180 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp2_ = _tmp1_;
#line 180 "../src/client/conversation-list/conversation-list-model.vala"
	g_debug ("conversation-list-model.vala:180: Removing %d conversations.", _tmp2_);
#line 182 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_emit (self, conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATIONS_REMOVED_SIGNAL], 0, TRUE);
#line 184 "../src/client/conversation-list/conversation-list-model.vala"
	removed = 0;
#line 1098 "conversation-list-model.c"
	{
		GeeIterator* _convo_it = NULL;
		GeeIterator* _tmp3_;
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (conversations, GEE_TYPE_ITERABLE, GeeIterable));
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
		_convo_it = _tmp3_;
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
		while (TRUE) {
#line 1108 "conversation-list-model.c"
			GeeIterator* _tmp4_;
			GearyAppConversation* convo = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GPtrArray* _tmp7_;
			GearyAppConversation* _tmp8_;
			gint _tmp9_;
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp4_ = _convo_it;
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
				break;
#line 1122 "conversation-list-model.c"
			}
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp5_ = _convo_it;
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
			convo = (GearyAppConversation*) _tmp6_;
#line 186 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp7_ = self->items;
#line 186 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp8_ = convo;
#line 186 "../src/client/conversation-list/conversation-list-model.vala"
			g_ptr_array_remove (_tmp7_, _tmp8_);
#line 187 "../src/client/conversation-list/conversation-list-model.vala"
			_tmp9_ = removed;
#line 187 "../src/client/conversation-list/conversation-list-model.vala"
			removed = _tmp9_ + 1;
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
			_g_object_unref0 (convo);
#line 1142 "conversation-list-model.c"
		}
#line 185 "../src/client/conversation-list/conversation-list-model.vala"
		_g_object_unref0 (_convo_it);
#line 1146 "conversation-list-model.c"
	}
#line 190 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp10_ = indexes;
#line 190 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_update_removed (self, _tmp10_);
#line 192 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_emit (self, conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATIONS_REMOVED_SIGNAL], 0, FALSE);
#line 194 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp11_ = gee_collection_get_size (conversations);
#line 194 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp12_ = _tmp11_;
#line 194 "../src/client/conversation-list/conversation-list-model.vala"
	g_debug ("conversation-list-model.vala:194: Removed %ld/%d conversations.", (glong) removed, _tmp12_);
#line 177 "../src/client/conversation-list/conversation-list-model.vala"
	_g_ptr_array_unref0 (indexes);
#line 1162 "conversation-list-model.c"
}

static void
conversation_list_model_on_conversation_updated (ConversationListModel* self,
                                                 GearyAppConversationMonitor* sender,
                                                 GearyAppConversation* convo,
                                                 GeeCollection* emails)
{
	guint initial_index = 0U;
	GPtrArray* _tmp0_;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
	GPtrArray* _tmp3_;
	guint final_index = 0U;
	gboolean _tmp4_ = FALSE;
	GPtrArray* _tmp5_;
	guint _tmp6_ = 0U;
	gboolean _tmp7_;
	guint _tmp8_ = 0U;
	guint count = 0U;
#line 197 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_MODEL (self));
#line 197 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sender, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 197 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (convo, GEARY_APP_TYPE_CONVERSATION));
#line 197 "../src/client/conversation-list/conversation-list-model.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (emails, GEE_TYPE_COLLECTION));
#line 198 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_emit (self, conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATION_UPDATED_SIGNAL], 0, convo);
#line 201 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = self->items;
#line 201 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp2_ = g_ptr_array_find (_tmp0_, convo, &_tmp1_);
#line 201 "../src/client/conversation-list/conversation-list-model.vala"
	initial_index = _tmp1_;
#line 201 "../src/client/conversation-list/conversation-list-model.vala"
	if (!_tmp2_) {
#line 202 "../src/client/conversation-list/conversation-list-model.vala"
		return;
#line 1203 "conversation-list-model.c"
	}
#line 205 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp3_ = self->items;
#line 205 "../src/client/conversation-list/conversation-list-model.vala"
	vala_g_ptr_array_sort (_tmp3_, _conversation_list_model_compare_gcompare_func);
#line 208 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp5_ = self->items;
#line 208 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp7_ = g_ptr_array_find (_tmp5_, convo, &_tmp6_);
#line 208 "../src/client/conversation-list/conversation-list-model.vala"
	final_index = _tmp6_;
#line 208 "../src/client/conversation-list/conversation-list-model.vala"
	if (!_tmp7_) {
#line 208 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp4_ = TRUE;
#line 1219 "conversation-list-model.c"
	} else {
#line 208 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp4_ = initial_index == final_index;
#line 1223 "conversation-list-model.c"
	}
#line 208 "../src/client/conversation-list/conversation-list-model.vala"
	if (_tmp4_) {
#line 209 "../src/client/conversation-list/conversation-list-model.vala"
		return;
#line 1229 "conversation-list-model.c"
	}
#line 212 "../src/client/conversation-list/conversation-list-model.vala"
	if (initial_index > final_index) {
#line 213 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp8_ = (initial_index + 1) - final_index;
#line 1235 "conversation-list-model.c"
	} else {
#line 214 "../src/client/conversation-list/conversation-list-model.vala"
		_tmp8_ = (final_index + 1) - initial_index;
#line 1239 "conversation-list-model.c"
	}
#line 212 "../src/client/conversation-list/conversation-list-model.vala"
	count = _tmp8_;
#line 215 "../src/client/conversation-list/conversation-list-model.vala"
	g_list_model_items_changed (G_TYPE_CHECK_INSTANCE_CAST (self, g_list_model_get_type (), GListModel), MIN (initial_index, final_index), count, count);
#line 1245 "conversation-list-model.c"
}

static void
conversation_list_model_class_init (ConversationListModelClass * klass,
                                    gpointer klass_data)
{
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	g_type_class_adjust_private_offset (klass, &ConversationListModel_private_offset);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_conversation_list_model_get_property;
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_conversation_list_model_set_property;
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	G_OBJECT_CLASS (klass)->finalize = conversation_list_model_finalize;
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_LIST_MODEL_MONITOR_PROPERTY, conversation_list_model_properties[CONVERSATION_LIST_MODEL_MONITOR_PROPERTY] = g_param_spec_object ("monitor", "monitor", "monitor", GEARY_APP_TYPE_CONVERSATION_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATIONS_ADDED_SIGNAL] = g_signal_new ("conversations-added", CONVERSATION_LIST_TYPE_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATIONS_REMOVED_SIGNAL] = g_signal_new ("conversations-removed", CONVERSATION_LIST_TYPE_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATIONS_LOADED_SIGNAL] = g_signal_new ("conversations-loaded", CONVERSATION_LIST_TYPE_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_signals[CONVERSATION_LIST_MODEL_CONVERSATION_UPDATED_SIGNAL] = g_signal_new ("conversation-updated", CONVERSATION_LIST_TYPE_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_APP_TYPE_CONVERSATION);
#line 1272 "conversation-list-model.c"
}

static void
conversation_list_model_g_list_model_interface_init (GListModelInterface * iface,
                                                     gpointer iface_data)
{
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	conversation_list_model_g_list_model_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	iface->get_item = (GObject* (*) (GListModel*, guint)) conversation_list_model_real_get_item;
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	iface->get_item_type = (GType (*) (GListModel*)) conversation_list_model_real_get_item_type;
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	iface->get_n_items = (guint (*) (GListModel*)) conversation_list_model_real_get_n_items;
#line 1287 "conversation-list-model.c"
}

static void
conversation_list_model_instance_init (ConversationListModel * self,
                                       gpointer klass)
{
	GPtrArray* _tmp0_;
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	self->priv = conversation_list_model_get_instance_private (self);
#line 11 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 11 "../src/client/conversation-list/conversation-list-model.vala"
	self->items = _tmp0_;
#line 14 "../src/client/conversation-list/conversation-list-model.vala"
	self->priv->scanning = FALSE;
#line 1303 "conversation-list-model.c"
}

static void
conversation_list_model_finalize (GObject * obj)
{
	ConversationListModel * self;
	GearyAppConversationMonitor* _tmp0_;
	guint _tmp1_;
	GearyAppConversationMonitor* _tmp2_;
	guint _tmp3_;
	GearyAppConversationMonitor* _tmp4_;
	guint _tmp5_;
	GearyAppConversationMonitor* _tmp6_;
	guint _tmp7_;
	GearyAppConversationMonitor* _tmp8_;
	guint _tmp9_;
	GearyAppConversationMonitor* _tmp10_;
	guint _tmp11_;
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONVERSATION_LIST_TYPE_MODEL, ConversationListModel);
#line 28 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp0_ = self->priv->_monitor;
#line 28 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_parse_name ("conversations-added", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp1_, NULL, FALSE);
#line 28 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _conversation_list_model_on_conversations_added_geary_app_conversation_monitor_conversations_added, self);
#line 29 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp2_ = self->priv->_monitor;
#line 29 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_parse_name ("conversation-appended", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp3_, NULL, FALSE);
#line 29 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _conversation_list_model_on_conversation_updated_geary_app_conversation_monitor_conversation_appended, self);
#line 30 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp4_ = self->priv->_monitor;
#line 30 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_parse_name ("conversation-trimmed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp5_, NULL, FALSE);
#line 30 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _conversation_list_model_on_conversation_updated_geary_app_conversation_monitor_conversation_trimmed, self);
#line 31 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp6_ = self->priv->_monitor;
#line 31 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_parse_name ("conversations-removed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp7_, NULL, FALSE);
#line 31 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _conversation_list_model_on_conversations_removed_geary_app_conversation_monitor_conversations_removed, self);
#line 32 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp8_ = self->priv->_monitor;
#line 32 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_parse_name ("scan-started", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp9_, NULL, FALSE);
#line 32 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _conversation_list_model_on_scan_started_geary_app_conversation_monitor_scan_started, self);
#line 33 "../src/client/conversation-list/conversation-list-model.vala"
	_tmp10_ = self->priv->_monitor;
#line 33 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_parse_name ("scan-completed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp11_, NULL, FALSE);
#line 33 "../src/client/conversation-list/conversation-list-model.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _conversation_list_model_on_scan_completed_geary_app_conversation_monitor_scan_completed, self);
#line 11 "../src/client/conversation-list/conversation-list-model.vala"
	_g_ptr_array_unref0 (self->items);
#line 12 "../src/client/conversation-list/conversation-list-model.vala"
	_g_object_unref0 (self->priv->_monitor);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	G_OBJECT_CLASS (conversation_list_model_parent_class)->finalize (obj);
#line 1366 "conversation-list-model.c"
}

static GType
conversation_list_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConversationListModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conversation_list_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConversationListModel), 0, (GInstanceInitFunc) conversation_list_model_instance_init, NULL };
	static const GInterfaceInfo g_list_model_info = { (GInterfaceInitFunc) conversation_list_model_g_list_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType conversation_list_model_type_id;
	conversation_list_model_type_id = g_type_register_static (G_TYPE_OBJECT, "ConversationListModel", &g_define_type_info, 0);
	g_type_add_interface_static (conversation_list_model_type_id, g_list_model_get_type (), &g_list_model_info);
	ConversationListModel_private_offset = g_type_add_instance_private (conversation_list_model_type_id, sizeof (ConversationListModelPrivate));
	return conversation_list_model_type_id;
}

GType
conversation_list_model_get_type (void)
{
	static volatile gsize conversation_list_model_type_id__once = 0;
	if (g_once_init_enter (&conversation_list_model_type_id__once)) {
		GType conversation_list_model_type_id;
		conversation_list_model_type_id = conversation_list_model_get_type_once ();
		g_once_init_leave (&conversation_list_model_type_id__once, conversation_list_model_type_id);
	}
	return conversation_list_model_type_id__once;
}

static void
_vala_conversation_list_model_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	ConversationListModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONVERSATION_LIST_TYPE_MODEL, ConversationListModel);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	switch (property_id) {
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		case CONVERSATION_LIST_MODEL_MONITOR_PROPERTY:
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		g_value_set_object (value, conversation_list_model_get_monitor (self));
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		break;
#line 1409 "conversation-list-model.c"
		default:
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		break;
#line 1415 "conversation-list-model.c"
	}
}

static void
_vala_conversation_list_model_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	ConversationListModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONVERSATION_LIST_TYPE_MODEL, ConversationListModel);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
	switch (property_id) {
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		case CONVERSATION_LIST_MODEL_MONITOR_PROPERTY:
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		conversation_list_model_set_monitor (self, g_value_get_object (value));
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		break;
#line 1435 "conversation-list-model.c"
		default:
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/client/conversation-list/conversation-list-model.vala"
		break;
#line 1441 "conversation-list-model.c"
	}
}

