/* conversation-viewer.c generated by valac 0.56.14, the Vala compiler
 * generated from conversation-viewer.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2016,2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "geary-client-44.1.h"
#include <gee.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <handy.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

enum  {
	CONVERSATION_VIEWER_0_PROPERTY,
	CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY,
	CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY,
	CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY,
	CONVERSATION_VIEWER_NUM_PROPERTIES
};
static GParamSpec* conversation_viewer_properties[CONVERSATION_VIEWER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ConversationViewerLoadConversationData ConversationViewerLoadConversationData;
typedef struct _Block99Data Block99Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ConversationViewerUpdateFindResultsData ConversationViewerUpdateFindResultsData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block100Data Block100Data;
enum  {
	CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL,
	CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL,
	CONVERSATION_VIEWER_NUM_SIGNALS
};
static guint conversation_viewer_signals[CONVERSATION_VIEWER_NUM_SIGNALS] = {0};

struct _ConversationViewerPrivate {
	ConversationListBox* _current_list;
	ComposerWidget* _current_composer;
	ConversationWebView* _previous_web_view;
	ApplicationConfiguration* config;
	GeeSet* selection_while_composing;
	GCancellable* find_cancellable;
	GtkSpinner* loading_page;
	GtkGrid* no_conversations_page;
	GtkGrid* conversation_page;
	GtkGrid* multiple_conversations_page;
	GtkGrid* empty_folder_page;
	GtkGrid* empty_search_page;
	GtkGrid* composer_page;
	GtkScrolledWindow* conversation_scroller;
	ComponentsEntryUndo* conversation_find_undo;
	GtkButton* conversation_find_next;
	GtkButton* conversation_find_prev;
};

struct _ConversationViewerLoadConversationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationViewer* self;
	GearyAppConversation* conversation;
	GeeCollection* scroll_to;
	GearyAppEmailStore* store;
	ApplicationContactStore* contacts;
	gboolean start_mark_timer;
	GtkScrolledWindow* old_scroller;
	GtkScrolledWindow* _tmp0_;
	ConversationListBox* new_list;
	ApplicationConfiguration* _tmp1_;
	GtkScrolledWindow* _tmp2_;
	GtkAdjustment* _tmp3_;
	ConversationListBox* _tmp4_;
	ConversationListBox* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	ConversationListBox* _tmp8_;
	ConversationListBoxSearchManager* _tmp9_;
	ConversationListBoxSearchManager* _tmp10_;
	ConversationListBox* _tmp11_;
	GtkGrid* _tmp12_;
	GearySearchQuery* query;
	GearyFolder* _tmp13_;
	GearyFolder* _tmp14_;
	GearyAccount* _tmp15_;
	GearyAccount* _tmp16_;
	GearySearchQuery* _tmp17_;
	GearySearchQuery* _tmp18_;
	GearyAppSearchFolder* search_folder;
	GearyFolder* _tmp19_;
	GearyFolder* _tmp20_;
	GearyAppSearchFolder* _tmp21_;
	GearyAppSearchFolder* _tmp22_;
	GearyAppSearchFolder* _tmp23_;
	GearySearchQuery* _tmp24_;
	GearySearchQuery* _tmp25_;
	GearySearchQuery* _tmp26_;
	ConversationListBox* _tmp27_;
	GearySearchQuery* _tmp28_;
	GtkScrolledWindow* _tmp29_;
	GError* _inner_error0_;
};

struct _Block99Data {
	int _ref_count_;
	ConversationViewer* self;
	ConversationListBox* list;
	gpointer _async_data_;
};

struct _ConversationViewerUpdateFindResultsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationViewer* self;
	Block99Data* _data99_;
	ConversationListBox* _tmp0_;
	ConversationListBox* _tmp1_;
	ConversationListBox* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* cancellable;
	GCancellable* _tmp5_;
	GCancellable* _tmp6_;
	GCancellable* _tmp7_;
	GCancellable* _tmp8_;
	GearySearchQuery* query;
	ConversationListBox* _tmp9_;
	GearyAppConversation* _tmp10_;
	GearyAppConversation* _tmp11_;
	GearyFolder* _tmp12_;
	GearyFolder* _tmp13_;
	GearyAccount* _tmp14_;
	GearyAccount* _tmp15_;
	GearySearchQuery* _tmp16_;
	GearySearchQuery* _tmp17_;
	ConversationListBox* _tmp18_;
	ConversationListBoxSearchManager* _tmp19_;
	ConversationListBoxSearchManager* _tmp20_;
	GearySearchQuery* _tmp21_;
	GError* err;
	GError* _tmp22_;
	const gchar* _tmp23_;
	GError* _inner_error0_;
};

struct _Block100Data {
	int _ref_count_;
	ConversationViewer* self;
	ConversationEmail* email_view;
};

static gint ConversationViewer_private_offset;
static gpointer conversation_viewer_parent_class = NULL;
static GearyBaseInterfaceIface * conversation_viewer_geary_base_interface_parent_iface = NULL;

static void conversation_viewer_set_current_list (ConversationViewer* self,
                                           ConversationListBox* value);
static void conversation_viewer_set_current_composer (ConversationViewer* self,
                                               ComposerWidget* value);
VALA_EXTERN ConversationWebView* conversation_viewer_get_previous_web_view (ConversationViewer* self);
VALA_EXTERN void conversation_viewer_set_previous_web_view (ConversationViewer* self,
                                                ConversationWebView* value);
static void conversation_viewer_new_conversation_scroller (ConversationViewer* self);
static void conversation_viewer_real_get_preferred_width (GtkWidget* base,
                                                   gint* minimum_size,
                                                   gint* natural_size);
static void conversation_viewer_on_composer_closed (ConversationViewer* self);
static void _conversation_viewer_on_composer_closed_composer_box_vanished (ComposerBox* _sender,
                                                                    gpointer self);
static void conversation_viewer_set_visible_child (ConversationViewer* self,
                                            GtkWidget* widget);
static void _conversation_viewer_on_composer_closed_composer_embed_vanished (ComposerEmbed* _sender,
                                                                      gpointer self);
static void conversation_viewer_load_conversation_data_free (gpointer _data);
static gboolean conversation_viewer_load_conversation_co (ConversationViewerLoadConversationData* _data_);
static GtkScrolledWindow* conversation_viewer_remove_current_list (ConversationViewer* self);
static void __lambda134_ (ConversationViewer* self,
                   guint count);
static void ___lambda134__conversation_list_box_search_manager_matches_updated (ConversationListBoxSearchManager* _sender,
                                                                         guint matches,
                                                                         gpointer self);
static void conversation_viewer_add_new_list (ConversationViewer* self,
                                       ConversationListBox* list);
static GearySearchQuery* conversation_viewer_get_find_search_query (ConversationViewer* self,
                                                             GearyAccount* account,
                                                             GError** error);
static void conversation_viewer_load_conversation_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static gboolean conversation_viewer_on_conversation_scroll (ConversationViewer* self);
static gboolean _conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                              GdkEventScroll* event,
                                                                              gpointer self);
static gboolean _conversation_viewer_on_conversation_scroll_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                      GdkEventButton* event,
                                                                                      gpointer self);
static void conversation_viewer_update_find_results_data_free (gpointer _data);
static void conversation_viewer_update_find_results (ConversationViewer* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static void conversation_viewer_update_find_results_finish (ConversationViewer* self,
                                                     GAsyncResult* _res_);
static gboolean conversation_viewer_update_find_results_co (ConversationViewerUpdateFindResultsData* _data_);
static Block99Data* block99_data_ref (Block99Data* _data99_);
static void block99_data_unref (void * _userdata_);
static void ___lambda135_ (Block99Data* _data99_);
static void ____lambda135__g_cancellable_cancelled (GCancellable* _sender,
                                             gpointer self);
static void conversation_viewer_update_find_results_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void conversation_viewer_on_find_mode_changed (ConversationViewer* self,
                                               GObject* obj,
                                               GParamSpec* param);
static Block100Data* block100_data_ref (Block100Data* _data100_);
static void block100_data_unref (void * _userdata_);
static void _____lambda136_ (Block100Data* _data100_,
                      GObject* obj,
                      GAsyncResult* res);
static void ______lambda136__gasync_ready_callback (GObject* source_object,
                                             GAsyncResult* res,
                                             gpointer self);
static void _conversation_viewer_on_find_mode_changed_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void conversation_viewer_on_find_text_changed (ConversationViewer* self,
                                               GtkSearchEntry* entry);
static void _conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                                gpointer self);
static void conversation_viewer_on_find_next (ConversationViewer* self,
                                       GtkWidget* entry);
static void _conversation_viewer_on_find_next_gtk_button_activate (GtkButton* _sender,
                                                            gpointer self);
static void conversation_viewer_on_find_prev (ConversationViewer* self,
                                       GtkWidget* entry);
static void _conversation_viewer_on_find_prev_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void conversation_viewer_finalize (GObject * obj);
static GType conversation_viewer_get_type_once (void);
static void _vala_conversation_viewer_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_conversation_viewer_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
conversation_viewer_get_instance_private (ConversationViewer* self)
{
	return G_STRUCT_MEMBER_P (self, ConversationViewer_private_offset);
}

ConversationListBox*
conversation_viewer_get_current_list (ConversationViewer* self)
{
	ConversationListBox* result;
	ConversationListBox* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 288 "conversation-viewer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	return self ? g_object_ref (self) : NULL;
#line 296 "conversation-viewer.c"
}

static void
conversation_viewer_set_current_list (ConversationViewer* self,
                                      ConversationListBox* value)
{
	ConversationListBox* old_value;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_current_list (self);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 310 "conversation-viewer.c"
		ConversationListBox* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_current_list);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_current_list = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY]);
#line 320 "conversation-viewer.c"
	}
}

ComposerWidget*
conversation_viewer_get_current_composer (ConversationViewer* self)
{
	ComposerWidget* result;
	ComposerWidget* _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_composer;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 337 "conversation-viewer.c"
}

static void
conversation_viewer_set_current_composer (ConversationViewer* self,
                                          ComposerWidget* value)
{
	ComposerWidget* old_value;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_current_composer (self);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 351 "conversation-viewer.c"
		ComposerWidget* _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_current_composer);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_current_composer = _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY]);
#line 361 "conversation-viewer.c"
	}
}

ConversationWebView*
conversation_viewer_get_previous_web_view (ConversationViewer* self)
{
	ConversationWebView* result;
	ConversationWebView* _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_previous_web_view;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 378 "conversation-viewer.c"
}

void
conversation_viewer_set_previous_web_view (ConversationViewer* self,
                                           ConversationWebView* value)
{
	ConversationWebView* old_value;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_previous_web_view (self);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 392 "conversation-viewer.c"
		ConversationWebView* _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_previous_web_view);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_previous_web_view = _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY]);
#line 402 "conversation-viewer.c"
	}
}

/**
     * Constructs a new conversation view instance.
     */
ConversationViewer*
conversation_viewer_construct (GType object_type,
                               ApplicationConfiguration* config)
{
	ConversationViewer * self = NULL;
	ApplicationConfiguration* _tmp0_;
	HdyStatusPage* no_conversations = NULL;
	HdyStatusPage* _tmp1_;
	GtkGrid* _tmp2_;
	HdyStatusPage* multi_conversations = NULL;
	HdyStatusPage* _tmp3_;
	GtkGrid* _tmp4_;
	HdyStatusPage* empty_folder = NULL;
	HdyStatusPage* _tmp5_;
	GtkGrid* _tmp6_;
	HdyStatusPage* empty_search = NULL;
	HdyStatusPage* _tmp7_;
	GtkGrid* _tmp8_;
	GtkSearchEntry* _tmp9_;
	ComponentsEntryUndo* _tmp10_;
	GtkSearchBar* _tmp11_;
	GtkSearchEntry* _tmp12_;
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (config), NULL);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = (ConversationViewer*) g_object_new (object_type, NULL);
#line 76 "../src/client/conversation-viewer/conversation-viewer.vala"
	geary_base_interface_base_ref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 77 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (config);
#line 77 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->config);
#line 77 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->config = _tmp0_;
#line 79 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = (HdyStatusPage*) hdy_status_page_new ();
#line 79 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp1_);
#line 79 "../src/client/conversation-viewer/conversation-viewer.vala"
	no_conversations = _tmp1_;
#line 81 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_icon_name (no_conversations, "folder-symbolic");
#line 84 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_title (no_conversations, _ ("No Conversations Selected"));
#line 87 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_description (no_conversations, _ ("Selecting a conversation from the list will display it here."));
#line 90 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget), TRUE);
#line 91 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget), TRUE);
#line 92 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget));
#line 93 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = self->priv->no_conversations_page;
#line 93 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget));
#line 95 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = (HdyStatusPage*) hdy_status_page_new ();
#line 95 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp3_);
#line 95 "../src/client/conversation-viewer/conversation-viewer.vala"
	multi_conversations = _tmp3_;
#line 97 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_icon_name (multi_conversations, "folder-symbolic");
#line 100 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_title (multi_conversations, _ ("Multiple Conversations Selected"));
#line 103 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_description (multi_conversations, _ ("Choosing an action will apply to all selected conversations."));
#line 106 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget), TRUE);
#line 107 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget), TRUE);
#line 108 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget));
#line 109 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = self->priv->multiple_conversations_page;
#line 109 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget));
#line 111 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = (HdyStatusPage*) hdy_status_page_new ();
#line 111 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp5_);
#line 111 "../src/client/conversation-viewer/conversation-viewer.vala"
	empty_folder = _tmp5_;
#line 113 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_icon_name (empty_folder, "folder-symbolic");
#line 116 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_title (empty_folder, _ ("No Conversations Found"));
#line 119 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_description (empty_folder, _ ("This folder does not contain any conversations."));
#line 122 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget), TRUE);
#line 123 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget), TRUE);
#line 124 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget));
#line 125 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = self->priv->empty_folder_page;
#line 125 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget));
#line 127 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = (HdyStatusPage*) hdy_status_page_new ();
#line 127 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp7_);
#line 127 "../src/client/conversation-viewer/conversation-viewer.vala"
	empty_search = _tmp7_;
#line 129 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_icon_name (empty_search, "folder-symbolic");
#line 132 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_title (empty_search, _ ("No Conversations Found"));
#line 135 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_description (empty_search, _ ("Your search returned no results, try refining your search terms."));
#line 138 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget), TRUE);
#line 139 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget), TRUE);
#line 140 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget));
#line 141 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp8_ = self->priv->empty_search_page;
#line 141 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget));
#line 143 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp9_ = self->conversation_find_entry;
#line 143 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp10_ = components_entry_undo_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_entry_get_type (), GtkEntry));
#line 143 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_find_undo);
#line 143 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->conversation_find_undo = _tmp10_;
#line 148 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_new_conversation_scroller (self);
#line 151 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp11_ = self->conversation_find_bar;
#line 151 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp12_ = self->conversation_find_entry;
#line 151 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_search_bar_connect_entry (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_entry_get_type (), GtkEntry));
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (empty_search);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (empty_folder);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (multi_conversations);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (no_conversations);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	return self;
#line 557 "conversation-viewer.c"
}

ConversationViewer*
conversation_viewer_new (ApplicationConfiguration* config)
{
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	return conversation_viewer_construct (TYPE_CONVERSATION_VIEWER, config);
#line 565 "conversation-viewer.c"
}

static void
conversation_viewer_real_get_preferred_width (GtkWidget* base,
                                              gint* minimum_size,
                                              gint* natural_size)
{
	ConversationViewer * self;
	gint _vala_minimum_size = 0;
	gint _vala_natural_size = 0;
#line 158 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
	_vala_minimum_size = 300;
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
	_vala_natural_size = 700;
#line 158 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (minimum_size) {
#line 158 "../src/client/conversation-viewer/conversation-viewer.vala"
		*minimum_size = _vala_minimum_size;
#line 586 "conversation-viewer.c"
	}
#line 158 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (natural_size) {
#line 158 "../src/client/conversation-viewer/conversation-viewer.vala"
		*natural_size = _vala_natural_size;
#line 592 "conversation-viewer.c"
	}
}

/**
     * Puts the view into composer mode, showing a full-height composer.
     */
static void
_conversation_viewer_on_composer_closed_composer_box_vanished (ComposerBox* _sender,
                                                               gpointer self)
{
#line 180 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_composer_closed ((ConversationViewer*) self);
#line 605 "conversation-viewer.c"
}

void
conversation_viewer_do_compose (ConversationViewer* self,
                                ComposerWidget* composer)
{
	ApplicationMainWindow* main_window = NULL;
	GtkWidget* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ApplicationMainWindow* _tmp2_;
#line 166 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 166 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (COMPOSER_IS_WIDGET (composer));
#line 167 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 167 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp0_) ? ((ApplicationMainWindow*) _tmp0_) : NULL);
#line 167 "../src/client/conversation-viewer/conversation-viewer.vala"
	main_window = _tmp1_;
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = main_window;
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp2_ != NULL) {
#line 630 "conversation-viewer.c"
		ComposerBox* box = NULL;
		ApplicationMainWindow* _tmp3_;
		ComponentsConversationHeaderBar* _tmp4_;
		ComposerBox* _tmp5_;
		ConversationListView* conversation_list = NULL;
		ApplicationMainWindow* _tmp6_;
		ConversationListView* _tmp7_;
		ConversationListView* _tmp8_;
		ConversationListView* _tmp9_;
		ConversationListView* _tmp10_;
		GeeSet* _tmp11_;
		GeeSet* _tmp12_;
		GeeSet* _tmp13_;
		ConversationListView* _tmp14_;
		ComposerBox* _tmp15_;
		GtkGrid* _tmp16_;
		ComposerBox* _tmp17_;
		GtkGrid* _tmp18_;
#line 169 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = main_window;
#line 169 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = _tmp3_->conversation_headerbar;
#line 169 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = composer_box_new (composer, _tmp4_);
#line 169 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_ref_sink (_tmp5_);
#line 169 "../src/client/conversation-viewer/conversation-viewer.vala"
		box = _tmp5_;
#line 172 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_composer (self, composer);
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = main_window;
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp7_ = application_main_window_get_conversation_list_view (_tmp6_);
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = _tmp7_;
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list = _tmp9_;
#line 177 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp10_ = conversation_list;
#line 177 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp11_ = conversation_list_view_get_selected (_tmp10_);
#line 177 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp12_ = _tmp11_;
#line 177 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 177 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->selection_while_composing);
#line 177 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->selection_while_composing = _tmp13_;
#line 178 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp14_ = conversation_list;
#line 178 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_view_unselect_all (_tmp14_);
#line 180 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp15_ = box;
#line 180 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_connect_object (_tmp15_, "vanished", (GCallback) _conversation_viewer_on_composer_closed_composer_box_vanished, self, 0);
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp16_ = self->priv->composer_page;
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp17_ = box;
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
#line 182 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp18_ = self->priv->composer_page;
#line 182 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget));
#line 183 "../src/client/conversation-viewer/conversation-viewer.vala"
		composer_widget_update_window_title (composer);
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (conversation_list);
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (box);
#line 707 "conversation-viewer.c"
	}
#line 166 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (main_window);
#line 711 "conversation-viewer.c"
}

/**
     * Puts the view into composer mode, showing an embedded composer.
     */
static void
_conversation_viewer_on_composer_closed_composer_embed_vanished (ComposerEmbed* _sender,
                                                                 gpointer self)
{
#line 198 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_composer_closed ((ConversationViewer*) self);
#line 723 "conversation-viewer.c"
}

void
conversation_viewer_do_compose_embedded (ConversationViewer* self,
                                         ComposerWidget* composer,
                                         GearyEmail* referred)
{
	ComposerEmbed* embed = NULL;
	GtkScrolledWindow* _tmp0_;
	ComposerEmbed* _tmp1_;
	ComposerEmbed* _tmp2_;
	gboolean kinetic = FALSE;
	GtkScrolledWindow* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	ConversationListBox* _tmp7_;
	GtkScrolledWindow* _tmp13_;
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (COMPOSER_IS_WIDGET (composer));
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail ((referred == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (referred, GEARY_TYPE_EMAIL));
#line 192 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_composer (self, composer);
#line 193 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->conversation_scroller;
#line 193 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = composer_embed_new (referred, composer, _tmp0_);
#line 193 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp1_);
#line 193 "../src/client/conversation-viewer/conversation-viewer.vala"
	embed = _tmp1_;
#line 198 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = embed;
#line 198 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (_tmp2_, "vanished", (GCallback) _conversation_viewer_on_composer_closed_composer_embed_vanished, self, 0);
#line 203 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = self->priv->conversation_scroller;
#line 203 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = gtk_scrolled_window_get_kinetic_scrolling (_tmp3_);
#line 203 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = _tmp4_;
#line 203 "../src/client/conversation-viewer/conversation-viewer.vala"
	kinetic = _tmp5_;
#line 204 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (kinetic) {
#line 771 "conversation-viewer.c"
		GtkScrolledWindow* _tmp6_;
#line 204 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = self->priv->conversation_scroller;
#line 204 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_scrolled_window_set_kinetic_scrolling (_tmp6_, FALSE);
#line 777 "conversation-viewer.c"
	}
#line 206 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = self->priv->_current_list;
#line 206 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp7_ != NULL) {
#line 783 "conversation-viewer.c"
		ConversationListBox* _tmp8_;
		ComposerEmbed* _tmp9_;
		GearyEmailIdentifier* _tmp10_;
		GearyEmailIdentifier* _tmp11_;
#line 207 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = self->priv->_current_list;
#line 207 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = embed;
#line 207 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp10_ = composer_widget_get_saved_id (composer);
#line 207 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp11_ = _tmp10_;
#line 207 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_add_embedded_composer (_tmp8_, _tmp9_, _tmp11_ != NULL);
#line 211 "../src/client/conversation-viewer/conversation-viewer.vala"
		composer_widget_update_window_title (composer);
#line 800 "conversation-viewer.c"
	}
#line 214 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (kinetic) {
#line 804 "conversation-viewer.c"
		GtkScrolledWindow* _tmp12_;
#line 214 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp12_ = self->priv->conversation_scroller;
#line 214 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_scrolled_window_set_kinetic_scrolling (_tmp12_, TRUE);
#line 810 "conversation-viewer.c"
	}
#line 217 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp13_ = self->priv->conversation_scroller;
#line 217 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (composer, gtk_widget_get_type (), GtkWidget), -1, (gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget)) / 3) * 2);
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (embed);
#line 818 "conversation-viewer.c"
}

/**
     * Shows the loading UI.
     */
void
conversation_viewer_show_loading (ConversationViewer* self)
{
	GtkSpinner* _tmp0_;
	GtkSpinner* _tmp1_;
#line 225 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 226 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->loading_page;
#line 226 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_spinner_start (_tmp0_);
#line 227 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->loading_page;
#line 227 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 839 "conversation-viewer.c"
}

/**
     * Shows the UI when no conversations have been selected
     */
void
conversation_viewer_show_none_selected (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 233 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 234 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->no_conversations_page;
#line 234 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 855 "conversation-viewer.c"
}

/**
     * Shows the UI when multiple conversations have been selected
     */
void
conversation_viewer_show_multiple_selected (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 240 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 241 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->multiple_conversations_page;
#line 241 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 871 "conversation-viewer.c"
}

/**
     * Shows the empty folder UI.
     */
void
conversation_viewer_show_empty_folder (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 247 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 248 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->empty_folder_page;
#line 248 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 887 "conversation-viewer.c"
}

/**
     * Shows the empty search UI.
     */
void
conversation_viewer_show_empty_search (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 254 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 255 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->empty_search_page;
#line 255 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 903 "conversation-viewer.c"
}

/** Shows and focuses the find entry. */
void
conversation_viewer_enable_find (ConversationViewer* self)
{
	GtkSearchBar* _tmp0_;
	GtkSearchEntry* _tmp1_;
#line 259 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 260 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->conversation_find_bar;
#line 260 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_search_bar_set_search_mode (_tmp0_, TRUE);
#line 261 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->conversation_find_entry;
#line 261 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 922 "conversation-viewer.c"
}

static void
conversation_viewer_load_conversation_data_free (gpointer _data)
{
	ConversationViewerLoadConversationData* _data_;
	_data_ = _data;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_slice_free (ConversationViewerLoadConversationData, _data_);
#line 942 "conversation-viewer.c"
}

void
conversation_viewer_load_conversation (ConversationViewer* self,
                                       GearyAppConversation* conversation,
                                       GeeCollection* scroll_to,
                                       GearyAppEmailStore* store,
                                       ApplicationContactStore* contacts,
                                       gboolean start_mark_timer,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ConversationViewerLoadConversationData* _data_;
	ConversationViewer* _tmp0_;
	GearyAppConversation* _tmp1_;
	GeeCollection* _tmp2_;
	GearyAppEmailStore* _tmp3_;
	ApplicationContactStore* _tmp4_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversation, GEARY_APP_TYPE_CONVERSATION));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (scroll_to, GEE_TYPE_COLLECTION));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (store, GEARY_APP_TYPE_EMAIL_STORE));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (APPLICATION_IS_CONTACT_STORE (contacts));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_slice_new0 (ConversationViewerLoadConversationData);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_viewer_load_conversation_data_free);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->self = _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = _g_object_ref0 (conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->conversation = _tmp1_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _g_object_ref0 (scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->scroll_to = _tmp2_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = _g_object_ref0 (store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->store = _tmp3_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = _g_object_ref0 (contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->contacts = _tmp4_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->start_mark_timer = start_mark_timer;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_load_conversation_co (_data_);
#line 1009 "conversation-viewer.c"
}

void
conversation_viewer_load_conversation_finish (ConversationViewer* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	ConversationViewerLoadConversationData* _data_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (NULL == _data_) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		return;
#line 1024 "conversation-viewer.c"
	}
}

/**
     * Shows a conversation in the viewer.
     */
static void
__lambda134_ (ConversationViewer* self,
              guint count)
{
	gboolean found = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GtkSearchEntry* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
#line 297 "../src/client/conversation-viewer/conversation-viewer.vala"
	found = count > ((guint) 0);
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (found) {
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = TRUE;
#line 1047 "conversation-viewer.c"
	} else {
		GtkSearchEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = self->conversation_find_entry;
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_entry_get_type (), GtkEntry));
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = _tmp3_;
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = geary_string_is_empty (_tmp4_);
#line 1060 "conversation-viewer.c"
	}
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp1_) {
#line 301 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = "edit-find-symbolic";
#line 1066 "conversation-viewer.c"
	} else {
#line 301 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = "computer-fail-symbolic";
#line 1070 "conversation-viewer.c"
	}
#line 298 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = self->conversation_find_entry;
#line 298 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_entry_set_icon_from_icon_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_entry_get_type (), GtkEntry), GTK_ENTRY_ICON_PRIMARY, _tmp0_);
#line 303 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = self->priv->conversation_find_next;
#line 303 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), found);
#line 304 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = self->priv->conversation_find_prev;
#line 304 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), found);
#line 1084 "conversation-viewer.c"
}

static void
___lambda134__conversation_list_box_search_manager_matches_updated (ConversationListBoxSearchManager* _sender,
                                                                    guint matches,
                                                                    gpointer self)
{
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
	__lambda134_ ((ConversationViewer*) self, matches);
#line 1094 "conversation-viewer.c"
}

static void
conversation_viewer_load_conversation_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	ConversationViewerLoadConversationData* _data_;
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = _user_data_;
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_source_object_ = source_object;
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_res_ = _res_;
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_load_conversation_co (_data_);
#line 1111 "conversation-viewer.c"
}

static gboolean
conversation_viewer_load_conversation_co (ConversationViewerLoadConversationData* _data_)
{
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (_data_->_state_) {
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 0:
#line 1121 "conversation-viewer.c"
		goto _state_0;
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 1:
#line 1125 "conversation-viewer.c"
		goto _state_1;
		default:
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_assert_not_reached ();
#line 1130 "conversation-viewer.c"
	}
	_state_0:
#line 276 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp0_ = conversation_viewer_remove_current_list (_data_->self);
#line 276 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->old_scroller = _data_->_tmp0_;
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp1_ = _data_->self->priv->config;
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp2_ = _data_->self->priv->conversation_scroller;
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp3_ = gtk_scrolled_window_get_vadjustment (_data_->_tmp2_);
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp4_ = conversation_list_box_new (_data_->conversation, !_data_->start_mark_timer, _data_->store, _data_->contacts, _data_->_tmp1_, _data_->_tmp3_);
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_data_->_tmp4_);
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->new_list = _data_->_tmp4_;
#line 290 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp5_ = _data_->new_list;
#line 290 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_emit (_data_->self, conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL], 0, _data_->_tmp5_);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp6_ = _data_->self->priv->conversation_find_next;
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 295 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp7_ = _data_->self->priv->conversation_find_prev;
#line 295 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp8_ = _data_->new_list;
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp9_ = conversation_list_box_get_search (_data_->_tmp8_);
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (_data_->_tmp10_, "matches-updated", (GCallback) ___lambda134__conversation_list_box_search_manager_matches_updated, _data_->self, 0);
#line 306 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp11_ = _data_->new_list;
#line 306 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_add_new_list (_data_->self, _data_->_tmp11_);
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp12_ = _data_->self->priv->conversation_page;
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp13_ = geary_app_conversation_get_base_folder (_data_->conversation);
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp15_ = geary_folder_get_account (_data_->_tmp14_);
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp17_ = conversation_viewer_get_find_search_query (_data_->self, _data_->_tmp16_, &_data_->_inner_error0_);
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->query = _data_->_tmp17_;
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->new_list);
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->old_scroller);
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_unref (_data_->_async_result);
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
		return FALSE;
#line 1201 "conversation-viewer.c"
	}
#line 312 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp18_ = _data_->query;
#line 312 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_tmp18_ == NULL) {
#line 313 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp19_ = geary_app_conversation_get_base_folder (_data_->conversation);
#line 313 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 313 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp20_, GEARY_APP_TYPE_SEARCH_FOLDER) ? ((GearyAppSearchFolder*) _data_->_tmp20_) : NULL);
#line 313 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->search_folder = _data_->_tmp21_;
#line 314 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp22_ = _data_->search_folder;
#line 314 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_data_->_tmp22_ != NULL) {
#line 315 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp23_ = _data_->search_folder;
#line 315 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp24_ = geary_app_search_folder_get_query (_data_->_tmp23_);
#line 315 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 315 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp26_ = _g_object_ref0 (_data_->_tmp25_);
#line 315 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->query);
#line 315 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->query = _data_->_tmp26_;
#line 1231 "conversation-viewer.c"
		}
#line 312 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->search_folder);
#line 1235 "conversation-viewer.c"
	}
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp27_ = _data_->new_list;
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp28_ = _data_->query;
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_state_ = 1;
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_load_conversation (_data_->_tmp27_, _data_->scroll_to, _data_->_tmp28_, conversation_viewer_load_conversation_ready, _data_);
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1247 "conversation-viewer.c"
	_state_1:
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_load_conversation_finish (_data_->_tmp27_, _data_->_res_, &_data_->_inner_error0_);
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->query);
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->new_list);
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->old_scroller);
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_unref (_data_->_async_result);
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
		return FALSE;
#line 1265 "conversation-viewer.c"
	}
#line 322 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp29_ = _data_->old_scroller;
#line 322 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp29_, gtk_widget_get_type (), GtkWidget));
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->query);
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->new_list);
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->old_scroller);
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_state_ != 0) {
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1285 "conversation-viewer.c"
		}
	}
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_unref (_data_->_async_result);
#line 267 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1292 "conversation-viewer.c"
}

static void
conversation_viewer_add_new_list (ConversationViewer* self,
                                  ConversationListBox* list)
{
	GtkViewport* viewport = NULL;
	GtkViewport* _tmp0_;
	GtkScrolledWindow* _tmp1_;
#line 326 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 326 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (list));
#line 327 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_list (self, list);
#line 328 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (list, gtk_widget_get_type (), GtkWidget));
#line 334 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = (GtkViewport*) gtk_viewport_new (NULL, NULL);
#line 334 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp0_);
#line 334 "../src/client/conversation-viewer/conversation-viewer.vala"
	viewport = _tmp0_;
#line 335 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_widget_get_type (), GtkWidget));
#line 336 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (list, gtk_widget_get_type (), GtkWidget));
#line 338 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->conversation_scroller;
#line 338 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_widget_get_type (), GtkWidget));
#line 326 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (viewport);
#line 1326 "conversation-viewer.c"
}

static GtkScrolledWindow*
conversation_viewer_remove_current_list (ConversationViewer* self)
{
	GCancellable* _tmp0_;
	ConversationListBox* _tmp2_;
	GtkScrolledWindow* old_scroller = NULL;
	GtkScrolledWindow* _tmp5_;
	GtkScrolledWindow* _tmp6_;
	GtkGrid* _tmp7_;
	GtkScrolledWindow* result;
#line 342 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 343 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->find_cancellable;
#line 343 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 1345 "conversation-viewer.c"
		GCancellable* _tmp1_;
#line 344 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->priv->find_cancellable;
#line 344 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_cancellable_cancel (_tmp1_);
#line 345 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->find_cancellable);
#line 345 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->find_cancellable = NULL;
#line 1355 "conversation-viewer.c"
	}
#line 348 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = self->priv->_current_list;
#line 348 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp2_ != NULL) {
#line 1361 "conversation-viewer.c"
		ConversationListBox* _tmp3_;
		ConversationListBox* _tmp4_;
#line 349 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = self->priv->_current_list;
#line 349 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_cancel_conversation_load (_tmp3_);
#line 350 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = self->priv->_current_list;
#line 350 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_emit (self, conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL], 0, _tmp4_);
#line 351 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_list (self, NULL);
#line 1374 "conversation-viewer.c"
	}
#line 354 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = self->priv->conversation_scroller;
#line 354 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 354 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_scroller = _tmp6_;
#line 356 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = self->priv->conversation_page;
#line 356 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (old_scroller, gtk_widget_get_type (), GtkWidget));
#line 357 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_new_conversation_scroller (self);
#line 358 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = old_scroller;
#line 358 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1392 "conversation-viewer.c"
}

static gboolean
_conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                     GdkEventScroll* event,
                                                                     gpointer self)
{
	gboolean result;
	result = conversation_viewer_on_conversation_scroll ((ConversationViewer*) self);
#line 373 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1404 "conversation-viewer.c"
}

static gboolean
_conversation_viewer_on_conversation_scroll_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                             GdkEventButton* event,
                                                                             gpointer self)
{
	gboolean result;
	result = conversation_viewer_on_conversation_scroll ((ConversationViewer*) self);
#line 376 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1416 "conversation-viewer.c"
}

static void
conversation_viewer_new_conversation_scroller (ConversationViewer* self)
{
	GtkScrolledWindow* scroller = NULL;
	GtkScrolledWindow* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkWidget* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	GtkGrid* _tmp4_;
#line 361 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 367 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 367 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp0_);
#line 367 "../src/client/conversation-viewer/conversation-viewer.vala"
	scroller = _tmp0_;
#line 368 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget));
#line 368 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_style_context_add_class (_tmp1_, "geary-conversation-scroller");
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_set (scroller, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 370 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget), TRUE);
#line 371 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget), TRUE);
#line 372 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget));
#line 373 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget), "scroll-event", (GCallback) _conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event, self, 0);
#line 376 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = gtk_scrolled_window_get_vscrollbar (scroller);
#line 376 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (_tmp2_, "button-release-event", (GCallback) _conversation_viewer_on_conversation_scroll_gtk_widget_button_release_event, self, 0);
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = _g_object_ref0 (scroller);
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_scroller);
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->conversation_scroller = _tmp3_;
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = self->priv->conversation_page;
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget));
#line 361 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (scroller);
#line 1466 "conversation-viewer.c"
}

/**
     * Sets the currently visible page of the stack.
     */
static void
conversation_viewer_set_visible_child (ConversationViewer* self,
                                       GtkWidget* widget)
{
	const gchar* _tmp0_;
	GtkWidget* current = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkGrid* _tmp4_;
#line 387 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 387 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 388 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_buildable_get_name (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_buildable_get_type (), GtkBuildable));
#line 388 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_debug ("conversation-viewer.vala:388: Showing: %s", _tmp0_);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack));
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	current = _tmp2_;
#line 390 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = current;
#line 390 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = self->priv->conversation_page;
#line 390 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
#line 1502 "conversation-viewer.c"
		GtkGrid* _tmp5_;
#line 391 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = self->priv->conversation_page;
#line 391 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (widget != G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
#line 1508 "conversation-viewer.c"
			GtkScrolledWindow* _tmp6_;
			GtkScrolledWindow* _tmp7_;
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = conversation_viewer_remove_current_list (self);
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = _tmp6_;
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp7_);
#line 1517 "conversation-viewer.c"
		}
	} else {
		GtkWidget* _tmp8_;
		GtkSpinner* _tmp9_;
#line 398 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = current;
#line 398 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = self->priv->loading_page;
#line 398 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp8_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget)) {
#line 1528 "conversation-viewer.c"
			GtkSpinner* _tmp10_;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = self->priv->loading_page;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			gtk_spinner_stop (_tmp10_);
#line 1534 "conversation-viewer.c"
		}
	}
#line 403 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_stack_set_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack), widget);
#line 387 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (current);
#line 1541 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_data_free (gpointer _data)
{
	ConversationViewerUpdateFindResultsData* _data_;
	_data_ = _data;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_slice_free (ConversationViewerUpdateFindResultsData, _data_);
#line 1553 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results (ConversationViewer* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	ConversationViewerUpdateFindResultsData* _data_;
	ConversationViewer* _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_slice_new0 (ConversationViewerUpdateFindResultsData);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_viewer_update_find_results_data_free);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->self = _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results_co (_data_);
#line 1577 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_finish (ConversationViewer* self,
                                                GAsyncResult* _res_)
{
	ConversationViewerUpdateFindResultsData* _data_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1587 "conversation-viewer.c"
}

static Block99Data*
block99_data_ref (Block99Data* _data99_)
{
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_atomic_int_inc (&_data99_->_ref_count_);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	return _data99_;
#line 1597 "conversation-viewer.c"
}

static void
block99_data_unref (void * _userdata_)
{
	Block99Data* _data99_;
	_data99_ = (Block99Data*) _userdata_;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (g_atomic_int_dec_and_test (&_data99_->_ref_count_)) {
#line 1607 "conversation-viewer.c"
		ConversationViewer* self;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
		self = _data99_->self;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data99_->list);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_slice_free (Block99Data, _data99_);
#line 1617 "conversation-viewer.c"
	}
}

static void
___lambda135_ (Block99Data* _data99_)
{
	ConversationViewer* self;
	ConversationListBox* _tmp0_;
	ConversationListBoxSearchManager* _tmp1_;
	ConversationListBoxSearchManager* _tmp2_;
#line 413 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = _data99_->self;
#line 414 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _data99_->list;
#line 414 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = conversation_list_box_get_search (_tmp0_);
#line 414 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _tmp1_;
#line 414 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_search_manager_cancel (_tmp2_);
#line 1638 "conversation-viewer.c"
}

static void
____lambda135__g_cancellable_cancelled (GCancellable* _sender,
                                        gpointer self)
{
#line 413 "../src/client/conversation-viewer/conversation-viewer.vala"
	___lambda135_ (self);
#line 1647 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	ConversationViewerUpdateFindResultsData* _data_;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = _user_data_;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_source_object_ = source_object;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_res_ = _res_;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results_co (_data_);
#line 1664 "conversation-viewer.c"
}

static gboolean
conversation_viewer_update_find_results_co (ConversationViewerUpdateFindResultsData* _data_)
{
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (_data_->_state_) {
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 0:
#line 1674 "conversation-viewer.c"
		goto _state_0;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 1:
#line 1678 "conversation-viewer.c"
		goto _state_1;
		default:
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_assert_not_reached ();
#line 1683 "conversation-viewer.c"
	}
	_state_0:
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data99_ = g_slice_new0 (Block99Data);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data99_->_ref_count_ = 1;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data99_->self = g_object_ref (_data_->self);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data99_->_async_data_ = _data_;
#line 407 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp0_ = _data_->self->priv->_current_list;
#line 407 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 407 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data99_->list = _data_->_tmp1_;
#line 408 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp2_ = _data_->_data99_->list;
#line 408 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_tmp2_ != NULL) {
#line 409 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp3_ = _data_->self->priv->find_cancellable;
#line 409 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_data_->_tmp3_ != NULL) {
#line 410 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp4_ = _data_->self->priv->find_cancellable;
#line 410 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_cancellable_cancel (_data_->_tmp4_);
#line 1712 "conversation-viewer.c"
		}
#line 412 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp5_ = g_cancellable_new ();
#line 412 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->cancellable = _data_->_tmp5_;
#line 413 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp6_ = _data_->cancellable;
#line 413 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_connect_data (_data_->_tmp6_, "cancelled", (GCallback) ____lambda135__g_cancellable_cancelled, block99_data_ref (_data_->_data99_), (GClosureNotify) block99_data_unref, 0);
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp7_ = _data_->cancellable;
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->self->priv->find_cancellable);
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->self->priv->find_cancellable = _data_->_tmp8_;
#line 1730 "conversation-viewer.c"
		{
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp9_ = _data_->_data99_->list;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp10_ = conversation_list_box_get_conversation (_data_->_tmp9_);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp12_ = geary_app_conversation_get_base_folder (_data_->_tmp11_);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp14_ = geary_folder_get_account (_data_->_tmp13_);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp16_ = conversation_viewer_get_find_search_query (_data_->self, _data_->_tmp15_, &_data_->_inner_error0_);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->query = _data_->_tmp16_;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1752 "conversation-viewer.c"
				goto __catch0_g_error;
			}
#line 421 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp17_ = _data_->query;
#line 421 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_data_->_tmp17_ != NULL) {
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp18_ = _data_->_data99_->list;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp19_ = conversation_list_box_get_search (_data_->_tmp18_);
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp20_ = _data_->_tmp19_;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp21_ = _data_->query;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_state_ = 1;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list_box_search_manager_highlight_matching_email (_data_->_tmp20_, _data_->_tmp21_, TRUE, conversation_viewer_update_find_results_ready, _data_);
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				return FALSE;
#line 1773 "conversation-viewer.c"
				_state_1:
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list_box_search_manager_highlight_matching_email_finish (_data_->_tmp20_, _data_->_res_, &_data_->_inner_error0_);
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
					_g_object_unref0 (_data_->query);
#line 1781 "conversation-viewer.c"
					goto __catch0_g_error;
				}
			}
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->query);
#line 1787 "conversation-viewer.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->err = _data_->_inner_error0_;
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_inner_error0_ = NULL;
#line 425 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp22_ = _data_->err;
#line 425 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp23_ = _data_->_tmp22_->message;
#line 425 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_warning ("conversation-viewer.vala:425: Error updating find results: %s", _data_->_tmp23_);
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_error_free0 (_data_->err);
#line 1804 "conversation-viewer.c"
		}
		__finally0:
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->cancellable);
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			block99_data_unref (_data_->_data99_);
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_data99_ = NULL;
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_object_unref (_data_->_async_result);
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
			return FALSE;
#line 1823 "conversation-viewer.c"
		}
#line 408 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->cancellable);
#line 1827 "conversation-viewer.c"
	}
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	block99_data_unref (_data_->_data99_);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data99_ = NULL;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_state_ != 0) {
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1841 "conversation-viewer.c"
		}
	}
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_unref (_data_->_async_result);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1848 "conversation-viewer.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 1869 "conversation-viewer.c"
}

static GearySearchQuery*
conversation_viewer_get_find_search_query (ConversationViewer* self,
                                           GearyAccount* account,
                                           GError** error)
{
	GearySearchQuery* query = NULL;
	GtkSearchBar* _tmp0_;
	GError* _inner_error0_ = NULL;
	GearySearchQuery* result;
#line 430 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 430 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT), NULL);
#line 432 "../src/client/conversation-viewer/conversation-viewer.vala"
	query = NULL;
#line 433 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->conversation_find_bar;
#line 433 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (gtk_search_bar_get_search_mode (_tmp0_)) {
#line 1891 "conversation-viewer.c"
		gchar* text = NULL;
		GtkSearchEntry* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->conversation_find_entry;
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_entry_get_type (), GtkEntry));
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = string_strip (_tmp2_);
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
		text = _tmp3_;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = text;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = strlen (_tmp4_);
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = _tmp5_;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp6_ >= 2) {
#line 1915 "conversation-viewer.c"
			UtilEmailSearchExpressionFactory* expr_factory = NULL;
			ApplicationConfiguration* _tmp7_;
			GearyAccountInformation* _tmp8_;
			GearyAccountInformation* _tmp9_;
			UtilEmailSearchExpressionFactory* _tmp10_;
			GearySearchQuery* _tmp11_ = NULL;
			UtilEmailSearchExpressionFactory* _tmp12_;
			const gchar* _tmp13_;
			GeeList* _tmp14_;
			GeeList* _tmp15_;
			const gchar* _tmp16_;
			GearySearchQuery* _tmp17_;
			GearySearchQuery* _tmp18_;
			GearySearchQuery* _tmp19_;
#line 439 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = self->priv->config;
#line 439 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp8_ = geary_account_get_information (account);
#line 439 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp9_ = _tmp8_;
#line 439 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = util_email_search_expression_factory_new (application_configuration_get_search_strategy (_tmp7_), _tmp9_);
#line 439 "../src/client/conversation-viewer/conversation-viewer.vala"
			expr_factory = _tmp10_;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp12_ = expr_factory;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp13_ = text;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp14_ = util_email_search_expression_factory_parse_query (_tmp12_, _tmp13_);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp15_ = _tmp14_;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp16_ = text;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp17_ = geary_account_new_search_query (account, _tmp15_, _tmp16_, &_inner_error0_);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp18_ = _tmp17_;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp15_);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = _tmp18_;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
				g_propagate_error (error, _inner_error0_);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (expr_factory);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_free0 (text);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (query);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
				return NULL;
#line 1970 "conversation-viewer.c"
			}
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp19_ = _tmp11_;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = NULL;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (query);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
			query = _tmp19_;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp11_);
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (expr_factory);
#line 1984 "conversation-viewer.c"
		}
#line 433 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_free0 (text);
#line 1988 "conversation-viewer.c"
	}
#line 449 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = query;
#line 449 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1994 "conversation-viewer.c"
}

static Block100Data*
block100_data_ref (Block100Data* _data100_)
{
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_atomic_int_inc (&_data100_->_ref_count_);
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
	return _data100_;
#line 2004 "conversation-viewer.c"
}

static void
block100_data_unref (void * _userdata_)
{
	Block100Data* _data100_;
	_data100_ = (Block100Data*) _userdata_;
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (g_atomic_int_dec_and_test (&_data100_->_ref_count_)) {
#line 2014 "conversation-viewer.c"
		ConversationViewer* self;
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
		self = _data100_->self;
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data100_->email_view);
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self);
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_slice_free (Block100Data, _data100_);
#line 2024 "conversation-viewer.c"
	}
}

static void
_____lambda136_ (Block100Data* _data100_,
                 GObject* obj,
                 GAsyncResult* res)
{
	ConversationViewer* self;
	gchar* text = NULL;
	ConversationEmail* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = _data100_->self;
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 461 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _data100_->email_view;
#line 461 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = conversation_email_get_selection_for_find_finish (_tmp0_, res);
#line 461 "../src/client/conversation-viewer/conversation-viewer.vala"
	text = _tmp1_;
#line 462 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = text;
#line 462 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp2_ != NULL) {
#line 2054 "conversation-viewer.c"
		GtkSearchEntry* _tmp3_;
		const gchar* _tmp4_;
		GtkSearchEntry* _tmp5_;
#line 463 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = self->conversation_find_entry;
#line 463 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = text;
#line 463 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_entry_get_type (), GtkEntry), _tmp4_);
#line 464 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = self->conversation_find_entry;
#line 464 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_editable_select_region (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_editable_get_type (), GtkEditable), 0, -1);
#line 2068 "conversation-viewer.c"
	}
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_free0 (text);
#line 2072 "conversation-viewer.c"
}

static void
______lambda136__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self)
{
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
	_____lambda136_ (self, source_object, res);
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
	block100_data_unref (self);
#line 2084 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_mode_changed (ConversationViewer* self,
                                          GObject* obj,
                                          GParamSpec* param)
{
	ConversationListBox* _tmp0_;
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (param, G_TYPE_PARAM));
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2103 "conversation-viewer.c"
		GtkSearchBar* _tmp1_;
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->conversation_find_bar;
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (gtk_search_bar_get_search_mode (_tmp1_)) {
#line 2109 "conversation-viewer.c"
			Block100Data* _data100_;
			ConversationListBox* _tmp2_;
			ConversationEmail* _tmp3_;
			ConversationEmail* _tmp4_;
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data100_ = g_slice_new0 (Block100Data);
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data100_->_ref_count_ = 1;
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data100_->self = g_object_ref (self);
#line 457 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp2_ = self->priv->_current_list;
#line 457 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp3_ = conversation_list_box_get_selection_view (_tmp2_);
#line 457 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data100_->email_view = _tmp3_;
#line 459 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp4_ = _data100_->email_view;
#line 459 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp4_ != NULL) {
#line 2130 "conversation-viewer.c"
				ConversationEmail* _tmp5_;
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp5_ = _data100_->email_view;
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_email_get_selection_for_find (_tmp5_, ______lambda136__gasync_ready_callback, block100_data_ref (_data100_));
#line 2136 "conversation-viewer.c"
			}
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
			block100_data_unref (_data100_);
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data100_ = NULL;
#line 2142 "conversation-viewer.c"
		} else {
			ConversationListBox* _tmp6_;
			ConversationListBoxSearchManager* _tmp7_;
			ConversationListBoxSearchManager* _tmp8_;
			GearyAppSearchFolder* search_folder = NULL;
			ConversationListBox* _tmp9_;
			GearyAppConversation* _tmp10_;
			GearyAppConversation* _tmp11_;
			GearyFolder* _tmp12_;
			GearyFolder* _tmp13_;
			GearyAppSearchFolder* _tmp14_;
			ComponentsEntryUndo* _tmp15_;
			GearyAppSearchFolder* _tmp16_;
#line 470 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = self->priv->_current_list;
#line 470 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = conversation_list_box_get_search (_tmp6_);
#line 470 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp8_ = _tmp7_;
#line 470 "../src/client/conversation-viewer/conversation-viewer.vala"
			conversation_list_box_search_manager_unmark_terms (_tmp8_);
#line 471 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp9_ = self->priv->_current_list;
#line 471 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = conversation_list_box_get_conversation (_tmp9_);
#line 471 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = _tmp10_;
#line 471 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp12_ = geary_app_conversation_get_base_folder (_tmp11_);
#line 471 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp13_ = _tmp12_;
#line 471 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, GEARY_APP_TYPE_SEARCH_FOLDER) ? ((GearyAppSearchFolder*) _tmp13_) : NULL);
#line 471 "../src/client/conversation-viewer/conversation-viewer.vala"
			search_folder = _tmp14_;
#line 475 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp15_ = self->priv->conversation_find_undo;
#line 475 "../src/client/conversation-viewer/conversation-viewer.vala"
			components_entry_undo_reset (_tmp15_);
#line 476 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp16_ = search_folder;
#line 476 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp16_ != NULL) {
#line 2186 "conversation-viewer.c"
				GearySearchQuery* query = NULL;
				GearyAppSearchFolder* _tmp17_;
				GearySearchQuery* _tmp18_;
				GearySearchQuery* _tmp19_;
				GearySearchQuery* _tmp20_;
				GearySearchQuery* _tmp21_;
#line 477 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp17_ = search_folder;
#line 477 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp18_ = geary_app_search_folder_get_query (_tmp17_);
#line 477 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp19_ = _tmp18_;
#line 477 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 477 "../src/client/conversation-viewer/conversation-viewer.vala"
				query = _tmp20_;
#line 478 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp21_ = query;
#line 478 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (_tmp21_ != NULL) {
#line 2207 "conversation-viewer.c"
					ConversationListBox* _tmp22_;
					ConversationListBoxSearchManager* _tmp23_;
					ConversationListBoxSearchManager* _tmp24_;
					GearySearchQuery* _tmp25_;
#line 479 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp22_ = self->priv->_current_list;
#line 479 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp23_ = conversation_list_box_get_search (_tmp22_);
#line 479 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp24_ = _tmp23_;
#line 479 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp25_ = query;
#line 479 "../src/client/conversation-viewer/conversation-viewer.vala"
					conversation_list_box_search_manager_highlight_matching_email (_tmp24_, _tmp25_, TRUE, NULL, NULL);
#line 2222 "conversation-viewer.c"
				}
#line 476 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (query);
#line 2226 "conversation-viewer.c"
			}
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (search_folder);
#line 2230 "conversation-viewer.c"
		}
	}
}

static void
_conversation_viewer_on_find_mode_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_mode_changed ((ConversationViewer*) self, _sender, pspec);
#line 2242 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_text_changed (ConversationViewer* self,
                                          GtkSearchEntry* entry)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 490 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 490 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_search_entry_get_type ()));
#line 491 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->conversation_find_next;
#line 491 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 492 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->conversation_find_prev;
#line 492 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 493 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results (self, NULL, NULL);
#line 2265 "conversation-viewer.c"
}

static void
_conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                           gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_text_changed ((ConversationViewer*) self, _sender);
#line 2274 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_next (ConversationViewer* self,
                                  GtkWidget* entry)
{
	ConversationListBox* _tmp0_;
#line 497 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 497 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_widget_get_type ()));
#line 498 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 498 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2290 "conversation-viewer.c"
	}
}

static void
_conversation_viewer_on_find_next_gtk_button_activate (GtkButton* _sender,
                                                       gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_next ((ConversationViewer*) self, _sender);
#line 2300 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_prev (ConversationViewer* self,
                                  GtkWidget* entry)
{
	ConversationListBox* _tmp0_;
#line 504 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 504 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_widget_get_type ()));
#line 505 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 505 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2316 "conversation-viewer.c"
	}
}

static void
_conversation_viewer_on_find_prev_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_prev ((ConversationViewer*) self, _sender);
#line 2326 "conversation-viewer.c"
}

static gboolean
conversation_viewer_on_conversation_scroll (ConversationViewer* self)
{
	ConversationListBox* _tmp0_;
	gboolean result;
#line 510 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), FALSE);
#line 511 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 511 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2340 "conversation-viewer.c"
		ConversationListBox* _tmp1_;
#line 512 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->priv->_current_list;
#line 512 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_mark_visible_read (_tmp1_);
#line 2346 "conversation-viewer.c"
	}
#line 514 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = GDK_EVENT_PROPAGATE;
#line 514 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 2352 "conversation-viewer.c"
}

static void
conversation_viewer_on_composer_closed (ConversationViewer* self)
{
	GtkWidget* _tmp0_;
	GtkGrid* _tmp1_;
#line 517 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 518 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_composer (self, NULL);
#line 519 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack));
#line 519 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->composer_page;
#line 519 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget)) {
#line 2370 "conversation-viewer.c"
		GtkGrid* _tmp2_;
		ApplicationMainWindow* main_window = NULL;
		GtkWidget* _tmp3_;
		ApplicationMainWindow* _tmp4_;
		ApplicationMainWindow* _tmp5_;
#line 520 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = self->priv->conversation_page;
#line 520 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget));
#line 523 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 523 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp3_) ? ((ApplicationMainWindow*) _tmp3_) : NULL);
#line 523 "../src/client/conversation-viewer/conversation-viewer.vala"
		main_window = _tmp4_;
#line 524 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = main_window;
#line 524 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp5_ != NULL) {
#line 2390 "conversation-viewer.c"
			ApplicationMainWindow* _tmp6_;
			GeeSet* _tmp7_;
#line 525 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = main_window;
#line 525 "../src/client/conversation-viewer/conversation-viewer.vala"
			application_main_window_update_title (_tmp6_);
#line 527 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = self->priv->selection_while_composing;
#line 527 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp7_ != NULL) {
#line 2401 "conversation-viewer.c"
				ConversationListView* conversation_list = NULL;
				ApplicationMainWindow* _tmp8_;
				ConversationListView* _tmp9_;
				ConversationListView* _tmp10_;
				ConversationListView* _tmp11_;
				GeeSet* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
#line 528 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp8_ = main_window;
#line 528 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp9_ = application_main_window_get_conversation_list_view (_tmp8_);
#line 528 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp10_ = _tmp9_;
#line 528 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 528 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list = _tmp11_;
#line 529 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp12_ = self->priv->selection_while_composing;
#line 529 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp13_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 529 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp14_ = _tmp13_;
#line 529 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (_tmp14_) {
#line 2428 "conversation-viewer.c"
					ConversationListView* _tmp15_;
					GeeSet* _tmp16_;
#line 530 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp15_ = conversation_list;
#line 530 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp16_ = self->priv->selection_while_composing;
#line 530 "../src/client/conversation-viewer/conversation-viewer.vala"
					g_signal_emit_by_name (_tmp15_, "conversations-selected", _tmp16_);
#line 2437 "conversation-viewer.c"
				} else {
					ConversationListView* _tmp17_;
					GeeSet* _tmp18_;
#line 534 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp17_ = conversation_list;
#line 534 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp18_ = self->priv->selection_while_composing;
#line 534 "../src/client/conversation-viewer/conversation-viewer.vala"
					conversation_list_view_select_conversations (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2447 "conversation-viewer.c"
				}
#line 539 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (self->priv->selection_while_composing);
#line 539 "../src/client/conversation-viewer/conversation-viewer.vala"
				self->priv->selection_while_composing = NULL;
#line 527 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (conversation_list);
#line 2455 "conversation-viewer.c"
			}
		}
#line 519 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (main_window);
#line 2460 "conversation-viewer.c"
	}
}

static void
conversation_viewer_class_init (ConversationViewerClass * klass,
                                gpointer klass_data)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_type_class_adjust_private_offset (klass, &ConversationViewer_private_offset);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) conversation_viewer_real_get_preferred_width;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_conversation_viewer_get_property;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_conversation_viewer_set_property;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->finalize = conversation_viewer_finalize;
#line 2480 "conversation-viewer.c"
	/**
	     * The current conversation listbox, if any.
	     */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY] = g_param_spec_object ("current-list", "current-list", "current-list", TYPE_CONVERSATION_LIST_BOX, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2486 "conversation-viewer.c"
	/** Returns the currently displayed composer if any. */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY] = g_param_spec_object ("current-composer", "current-composer", "current-composer", COMPOSER_TYPE_WIDGET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2490 "conversation-viewer.c"
	/**
	     * The most recent web view created in this viewer.
	     *
	     * Keep the last created web view around so others can share the
	     * same WebKitGTK WebProcess.
	     */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY] = g_param_spec_object ("previous-web-view", "previous-web-view", "previous-web-view", TYPE_CONVERSATION_WEB_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/conversation-viewer.ui");
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL] = g_signal_new ("conversation-added", TYPE_CONVERSATION_VIEWER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_CONVERSATION_LIST_BOX);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL] = g_signal_new ("conversation-removed", TYPE_CONVERSATION_VIEWER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_CONVERSATION_LIST_BOX);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "loading_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, loading_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "no_conversations_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, no_conversations_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "multiple_conversations_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, multiple_conversations_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "empty_folder_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, empty_folder_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "empty_search_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, empty_search_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "composer_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, composer_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_bar", FALSE, G_STRUCT_OFFSET (ConversationViewer, conversation_find_bar));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_entry", FALSE, G_STRUCT_OFFSET (ConversationViewer, conversation_find_entry));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_next", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_find_next));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_prev", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_find_prev));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_mode_changed", G_CALLBACK(_conversation_viewer_on_find_mode_changed_g_object_notify));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_text_changed", G_CALLBACK(_conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_next", G_CALLBACK(_conversation_viewer_on_find_next_gtk_button_activate));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_prev", G_CALLBACK(_conversation_viewer_on_find_prev_gtk_button_clicked));
#line 69 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "geary-conversation-viewer");
#line 2537 "conversation-viewer.c"
}

static void
conversation_viewer_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface,
                                                         gpointer iface_data)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 2546 "conversation-viewer.c"
}

static void
conversation_viewer_instance_init (ConversationViewer * self,
                                   gpointer klass)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv = conversation_viewer_get_instance_private (self);
#line 18 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_current_list = NULL;
#line 23 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_current_composer = NULL;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_previous_web_view = NULL;
#line 37 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->selection_while_composing = NULL;
#line 38 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->find_cancellable = NULL;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2567 "conversation-viewer.c"
}

static void
conversation_viewer_finalize (GObject * obj)
{
	ConversationViewer * self;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 155 "../src/client/conversation-viewer/conversation-viewer.vala"
	geary_base_interface_base_unref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 18 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_current_list);
#line 23 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_current_composer);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_previous_web_view);
#line 35 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->config);
#line 37 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->selection_while_composing);
#line 38 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->find_cancellable);
#line 49 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_scroller);
#line 54 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_find_undo);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (conversation_viewer_parent_class)->finalize (obj);
#line 2596 "conversation-viewer.c"
}

/**
 * Displays the messages in a conversation and in-window composers.
 */
static GType
conversation_viewer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConversationViewerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conversation_viewer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConversationViewer), 0, (GInstanceInitFunc) conversation_viewer_instance_init, NULL };
	static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) conversation_viewer_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType conversation_viewer_type_id;
	conversation_viewer_type_id = g_type_register_static (gtk_stack_get_type (), "ConversationViewer", &g_define_type_info, 0);
	g_type_add_interface_static (conversation_viewer_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
	ConversationViewer_private_offset = g_type_add_instance_private (conversation_viewer_type_id, sizeof (ConversationViewerPrivate));
	return conversation_viewer_type_id;
}

GType
conversation_viewer_get_type (void)
{
	static volatile gsize conversation_viewer_type_id__once = 0;
	if (g_once_init_enter (&conversation_viewer_type_id__once)) {
		GType conversation_viewer_type_id;
		conversation_viewer_type_id = conversation_viewer_get_type_once ();
		g_once_init_leave (&conversation_viewer_type_id__once, conversation_viewer_type_id);
	}
	return conversation_viewer_type_id__once;
}

static void
_vala_conversation_viewer_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	ConversationViewer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (property_id) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_current_list (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_current_composer (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_previous_web_view (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2654 "conversation-viewer.c"
		default:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2660 "conversation-viewer.c"
	}
}

static void
_vala_conversation_viewer_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	ConversationViewer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (property_id) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_list (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_composer (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_previous_web_view (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2692 "conversation-viewer.c"
		default:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2698 "conversation-viewer.c"
	}
}

