/* util-i18n.c generated by valac 0.56.14, the Vala compiler
 * generated from util-i18n.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "geary-client-44.1.h"
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <enchant.h>
#include <gio/gio.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include "geary-engine.h"

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block103Data Block103Data;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _enchant_broker_free0(var) ((var == NULL) ? NULL : (var = (enchant_broker_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Block103Data {
	int _ref_count_;
	gchar** dictionaries;
	gint dictionaries_length1;
	gint _dictionaries_size_;
};

VALA_EXTERN GHashTable* util_i18n_language_names;
GHashTable* util_i18n_language_names = NULL;
VALA_EXTERN GHashTable* util_i18n_country_names;
GHashTable* util_i18n_country_names = NULL;

VALA_EXTERN void util_i18n_init (const gchar* package_name,
                     const gchar* program_path,
                     const gchar* locale);
VALA_EXTERN gchar* util_i18n_get_langpack_dir_path (const gchar* program_path);
static Block103Data* block103_data_ref (Block103Data* _data103_);
static void block103_data_unref (void * _userdata_);
static void __lambda163_ (Block103Data* _data103_,
                   const gchar* lang_tag,
                   const gchar* provider_name,
                   const gchar* provider_desc,
                   const gchar* provider_file);
static void _vala_array_add19 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda163__enchant_dict_describe_fn (const gchar* lang_tag,
                                             const gchar* provider_name,
                                             const gchar* provider_desc,
                                             const gchar* provider_file,
                                             gpointer self);
static void _g_free0_ (gpointer var);
static gint __lambda164_ (const gchar* dic_a,
                   const gchar* dic_b);
static gint ___lambda164__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
static inline void _g_list_free__g_free0_ (GList* self);
static void _vala_array_add21 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add22 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

void
util_i18n_init (const gchar* package_name,
                const gchar* program_path,
                const gchar* locale)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 23 "../src/client/util/util-i18n.vala"
	g_return_if_fail (package_name != NULL);
#line 23 "../src/client/util/util-i18n.vala"
	g_return_if_fail (program_path != NULL);
#line 23 "../src/client/util/util-i18n.vala"
	g_return_if_fail (locale != NULL);
#line 24 "../src/client/util/util-i18n.vala"
	setlocale (LC_ALL, locale);
#line 25 "../src/client/util/util-i18n.vala"
	_tmp0_ = util_i18n_get_langpack_dir_path (program_path);
#line 25 "../src/client/util/util-i18n.vala"
	_tmp1_ = _tmp0_;
#line 25 "../src/client/util/util-i18n.vala"
	bindtextdomain (package_name, _tmp1_);
#line 25 "../src/client/util/util-i18n.vala"
	_g_free0 (_tmp1_);
#line 26 "../src/client/util/util-i18n.vala"
	bind_textdomain_codeset (package_name, "UTF-8");
#line 27 "../src/client/util/util-i18n.vala"
	textdomain (package_name);
#line 124 "util-i18n.c"
}

gchar*
util_i18n_get_langpack_dir_path (const gchar* program_path)
{
	gchar* _tmp0_;
	gchar* result;
#line 31 "../src/client/util/util-i18n.vala"
	g_return_val_if_fail (program_path != NULL, NULL);
#line 32 "../src/client/util/util-i18n.vala"
	_tmp0_ = g_strdup (_LANGUAGE_SUPPORT_DIRECTORY);
#line 32 "../src/client/util/util-i18n.vala"
	result = _tmp0_;
#line 32 "../src/client/util/util-i18n.vala"
	return result;
#line 140 "util-i18n.c"
}

/**
     * Returns a sorted list of installed spell-check dictionary languages.
     *
     * Each language is a POSIX-style locale name (ISO/IEC 15897).
     * The list is generated by obtaining the list from Enchant via
     * {@link Enchant.Broker.list_dicts}, discarding generic languages
     * if a regional variant exists (for example, discard "en" if
     * "en_US" is included), then sorted.
     */
static Block103Data*
block103_data_ref (Block103Data* _data103_)
{
#line 44 "../src/client/util/util-i18n.vala"
	g_atomic_int_inc (&_data103_->_ref_count_);
#line 44 "../src/client/util/util-i18n.vala"
	return _data103_;
#line 159 "util-i18n.c"
}

static void
block103_data_unref (void * _userdata_)
{
	Block103Data* _data103_;
	_data103_ = (Block103Data*) _userdata_;
#line 44 "../src/client/util/util-i18n.vala"
	if (g_atomic_int_dec_and_test (&_data103_->_ref_count_)) {
#line 44 "../src/client/util/util-i18n.vala"
		_data103_->dictionaries = (_vala_array_free (_data103_->dictionaries, _data103_->dictionaries_length1, (GDestroyNotify) g_free), NULL);
#line 44 "../src/client/util/util-i18n.vala"
		g_slice_free (Block103Data, _data103_);
#line 173 "util-i18n.c"
	}
}

static void
_vala_array_add19 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 49 "../src/client/util/util-i18n.vala"
	if ((*length) == (*size)) {
#line 49 "../src/client/util/util-i18n.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 49 "../src/client/util/util-i18n.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 189 "util-i18n.c"
	}
#line 49 "../src/client/util/util-i18n.vala"
	(*array)[(*length)++] = value;
#line 49 "../src/client/util/util-i18n.vala"
	(*array)[*length] = NULL;
#line 195 "util-i18n.c"
}

static void
__lambda163_ (Block103Data* _data103_,
              const gchar* lang_tag,
              const gchar* provider_name,
              const gchar* provider_desc,
              const gchar* provider_file)
{
	gchar* _tmp0_;
#line 48 "../src/client/util/util-i18n.vala"
	g_return_if_fail (lang_tag != NULL);
#line 48 "../src/client/util/util-i18n.vala"
	g_return_if_fail (provider_name != NULL);
#line 48 "../src/client/util/util-i18n.vala"
	g_return_if_fail (provider_desc != NULL);
#line 48 "../src/client/util/util-i18n.vala"
	g_return_if_fail (provider_file != NULL);
#line 49 "../src/client/util/util-i18n.vala"
	_tmp0_ = g_strdup (lang_tag);
#line 49 "../src/client/util/util-i18n.vala"
	_vala_array_add19 (&_data103_->dictionaries, &_data103_->dictionaries_length1, &_data103_->_dictionaries_size_, _tmp0_);
#line 218 "util-i18n.c"
}

static void
___lambda163__enchant_dict_describe_fn (const gchar* lang_tag,
                                        const gchar* provider_name,
                                        const gchar* provider_desc,
                                        const gchar* provider_file,
                                        gpointer self)
{
#line 48 "../src/client/util/util-i18n.vala"
	__lambda163_ (self, lang_tag, provider_name, provider_desc, provider_file);
#line 230 "util-i18n.c"
}

static void
_g_free0_ (gpointer var)
{
#line 55 "../src/client/util/util-i18n.vala"
	var = (g_free (var), NULL);
#line 238 "util-i18n.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 257 "util-i18n.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 279 "util-i18n.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 287 "util-i18n.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 293 "util-i18n.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 317 "util-i18n.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 326 "util-i18n.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 345 "util-i18n.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 349 "util-i18n.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 355 "util-i18n.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 365 "util-i18n.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 373 "util-i18n.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 377 "util-i18n.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 383 "util-i18n.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 393 "util-i18n.c"
}

static gint
__lambda164_ (const gchar* dic_a,
              const gchar* dic_b)
{
	gint _tmp0_ = 0;
	gint result;
#line 70 "../src/client/util/util-i18n.vala"
	g_return_val_if_fail (dic_a != NULL, 0);
#line 70 "../src/client/util/util-i18n.vala"
	g_return_val_if_fail (dic_b != NULL, 0);
#line 70 "../src/client/util/util-i18n.vala"
	if (g_strcmp0 (dic_a, dic_b) < 0) {
#line 70 "../src/client/util/util-i18n.vala"
		_tmp0_ = -1;
#line 410 "util-i18n.c"
	} else {
#line 70 "../src/client/util/util-i18n.vala"
		_tmp0_ = 1;
#line 414 "util-i18n.c"
	}
#line 70 "../src/client/util/util-i18n.vala"
	result = _tmp0_;
#line 70 "../src/client/util/util-i18n.vala"
	return result;
#line 420 "util-i18n.c"
}

static gint
___lambda164__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = __lambda164_ ((const gchar*) a, (const gchar*) b);
#line 70 "../src/client/util/util-i18n.vala"
	return result;
#line 431 "util-i18n.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 74 "../src/client/util/util-i18n.vala"
	if ((*length) == (*size)) {
#line 74 "../src/client/util/util-i18n.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 74 "../src/client/util/util-i18n.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 446 "util-i18n.c"
	}
#line 74 "../src/client/util/util-i18n.vala"
	(*array)[(*length)++] = value;
#line 74 "../src/client/util/util-i18n.vala"
	(*array)[*length] = NULL;
#line 452 "util-i18n.c"
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
#line 77 "../src/client/util/util-i18n.vala"
	if (length >= 0) {
#line 461 "util-i18n.c"
		gchar** result;
		gssize i;
#line 77 "../src/client/util/util-i18n.vala"
		result = g_new0 (gchar*, length + 1);
#line 77 "../src/client/util/util-i18n.vala"
		for (i = 0; i < length; i++) {
#line 468 "util-i18n.c"
			gchar* _tmp0_;
#line 77 "../src/client/util/util-i18n.vala"
			_tmp0_ = g_strdup (self[i]);
#line 77 "../src/client/util/util-i18n.vala"
			result[i] = _tmp0_;
#line 474 "util-i18n.c"
		}
#line 77 "../src/client/util/util-i18n.vala"
		return result;
#line 478 "util-i18n.c"
	}
#line 77 "../src/client/util/util-i18n.vala"
	return NULL;
#line 482 "util-i18n.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 77 "../src/client/util/util-i18n.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 490 "util-i18n.c"
}

gchar**
util_i18n_get_available_dictionaries (gint* result_length1)
{
	Block103Data* _data103_;
	gchar** _tmp0_;
	EnchantBroker* broker = NULL;
	EnchantBroker* _tmp1_;
	EnchantBroker* _tmp2_;
	GHashTable* regional_dictionaries = NULL;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GList* filtered_dictionaries = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar** _tmp21_;
	GList* _tmp22_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar** _tmp28_;
	gint _tmp28__length1;
	gchar** result;
#line 44 "../src/client/util/util-i18n.vala"
	_data103_ = g_slice_new0 (Block103Data);
#line 44 "../src/client/util/util-i18n.vala"
	_data103_->_ref_count_ = 1;
#line 45 "../src/client/util/util-i18n.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 45 "../src/client/util/util-i18n.vala"
	_data103_->dictionaries = _tmp0_;
#line 45 "../src/client/util/util-i18n.vala"
	_data103_->dictionaries_length1 = 0;
#line 45 "../src/client/util/util-i18n.vala"
	_data103_->_dictionaries_size_ = _data103_->dictionaries_length1;
#line 47 "../src/client/util/util-i18n.vala"
	_tmp1_ = enchant_broker_init ();
#line 47 "../src/client/util/util-i18n.vala"
	broker = _tmp1_;
#line 48 "../src/client/util/util-i18n.vala"
	_tmp2_ = broker;
#line 48 "../src/client/util/util-i18n.vala"
	enchant_broker_list_dicts (_tmp2_, ___lambda163__enchant_dict_describe_fn, _data103_);
#line 55 "../src/client/util/util-i18n.vala"
	_tmp3_ = g_str_hash;
#line 55 "../src/client/util/util-i18n.vala"
	_tmp4_ = g_str_equal;
#line 55 "../src/client/util/util-i18n.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, NULL, _g_free0_);
#line 55 "../src/client/util/util-i18n.vala"
	regional_dictionaries = _tmp5_;
#line 57 "../src/client/util/util-i18n.vala"
	_tmp6_ = _data103_->dictionaries;
#line 57 "../src/client/util/util-i18n.vala"
	_tmp6__length1 = _data103_->dictionaries_length1;
#line 551 "util-i18n.c"
	{
		gchar** dic_collection = NULL;
		gint dic_collection_length1 = 0;
		gint _dic_collection_size_ = 0;
		gint dic_it = 0;
#line 57 "../src/client/util/util-i18n.vala"
		dic_collection = _tmp6_;
#line 57 "../src/client/util/util-i18n.vala"
		dic_collection_length1 = _tmp6__length1;
#line 57 "../src/client/util/util-i18n.vala"
		for (dic_it = 0; dic_it < dic_collection_length1; dic_it = dic_it + 1) {
#line 563 "util-i18n.c"
			gchar* _tmp7_;
			gchar* dic = NULL;
#line 57 "../src/client/util/util-i18n.vala"
			_tmp7_ = g_strdup (dic_collection[dic_it]);
#line 57 "../src/client/util/util-i18n.vala"
			dic = _tmp7_;
#line 570 "util-i18n.c"
			{
				const gchar* _tmp8_;
#line 58 "../src/client/util/util-i18n.vala"
				_tmp8_ = dic;
#line 58 "../src/client/util/util-i18n.vala"
				if (string_contains (_tmp8_, "_")) {
#line 577 "util-i18n.c"
					gint underscore = 0;
					const gchar* _tmp9_;
					GHashTable* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
#line 59 "../src/client/util/util-i18n.vala"
					_tmp9_ = dic;
#line 59 "../src/client/util/util-i18n.vala"
					underscore = string_index_of_char (_tmp9_, (gunichar) '_', 0);
#line 60 "../src/client/util/util-i18n.vala"
					_tmp10_ = regional_dictionaries;
#line 60 "../src/client/util/util-i18n.vala"
					_tmp11_ = dic;
#line 60 "../src/client/util/util-i18n.vala"
					_tmp12_ = string_substring (_tmp11_, (glong) 0, (glong) underscore);
#line 60 "../src/client/util/util-i18n.vala"
					g_hash_table_add (_tmp10_, _tmp12_);
#line 595 "util-i18n.c"
				}
#line 57 "../src/client/util/util-i18n.vala"
				_g_free0 (dic);
#line 599 "util-i18n.c"
			}
		}
	}
#line 64 "../src/client/util/util-i18n.vala"
	filtered_dictionaries = NULL;
#line 65 "../src/client/util/util-i18n.vala"
	_tmp13_ = _data103_->dictionaries;
#line 65 "../src/client/util/util-i18n.vala"
	_tmp13__length1 = _data103_->dictionaries_length1;
#line 609 "util-i18n.c"
	{
		gchar** dic_collection = NULL;
		gint dic_collection_length1 = 0;
		gint _dic_collection_size_ = 0;
		gint dic_it = 0;
#line 65 "../src/client/util/util-i18n.vala"
		dic_collection = _tmp13_;
#line 65 "../src/client/util/util-i18n.vala"
		dic_collection_length1 = _tmp13__length1;
#line 65 "../src/client/util/util-i18n.vala"
		for (dic_it = 0; dic_it < dic_collection_length1; dic_it = dic_it + 1) {
#line 621 "util-i18n.c"
			gchar* _tmp14_;
			gchar* dic = NULL;
#line 65 "../src/client/util/util-i18n.vala"
			_tmp14_ = g_strdup (dic_collection[dic_it]);
#line 65 "../src/client/util/util-i18n.vala"
			dic = _tmp14_;
#line 628 "util-i18n.c"
			{
				gboolean _tmp15_ = FALSE;
				const gchar* _tmp16_;
#line 66 "../src/client/util/util-i18n.vala"
				_tmp16_ = dic;
#line 66 "../src/client/util/util-i18n.vala"
				if (string_contains (_tmp16_, "_")) {
#line 66 "../src/client/util/util-i18n.vala"
					_tmp15_ = TRUE;
#line 638 "util-i18n.c"
				} else {
					GHashTable* _tmp17_;
					const gchar* _tmp18_;
#line 66 "../src/client/util/util-i18n.vala"
					_tmp17_ = regional_dictionaries;
#line 66 "../src/client/util/util-i18n.vala"
					_tmp18_ = dic;
#line 66 "../src/client/util/util-i18n.vala"
					_tmp15_ = !g_hash_table_contains (_tmp17_, _tmp18_);
#line 648 "util-i18n.c"
				}
#line 66 "../src/client/util/util-i18n.vala"
				if (_tmp15_) {
#line 652 "util-i18n.c"
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 67 "../src/client/util/util-i18n.vala"
					_tmp19_ = dic;
#line 67 "../src/client/util/util-i18n.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 67 "../src/client/util/util-i18n.vala"
					filtered_dictionaries = g_list_append (filtered_dictionaries, _tmp20_);
#line 661 "util-i18n.c"
				}
#line 65 "../src/client/util/util-i18n.vala"
				_g_free0 (dic);
#line 665 "util-i18n.c"
			}
		}
	}
#line 70 "../src/client/util/util-i18n.vala"
	filtered_dictionaries = g_list_sort (filtered_dictionaries, ___lambda164__gcompare_func);
#line 72 "../src/client/util/util-i18n.vala"
	_tmp21_ = g_new0 (gchar*, 0 + 1);
#line 72 "../src/client/util/util-i18n.vala"
	_data103_->dictionaries = (_vala_array_free (_data103_->dictionaries, _data103_->dictionaries_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/client/util/util-i18n.vala"
	_data103_->dictionaries = _tmp21_;
#line 72 "../src/client/util/util-i18n.vala"
	_data103_->dictionaries_length1 = 0;
#line 72 "../src/client/util/util-i18n.vala"
	_data103_->_dictionaries_size_ = _data103_->dictionaries_length1;
#line 73 "../src/client/util/util-i18n.vala"
	_tmp22_ = filtered_dictionaries;
#line 683 "util-i18n.c"
	{
		GList* dic_collection = NULL;
		GList* dic_it = NULL;
#line 73 "../src/client/util/util-i18n.vala"
		dic_collection = _tmp22_;
#line 73 "../src/client/util/util-i18n.vala"
		for (dic_it = dic_collection; dic_it != NULL; dic_it = dic_it->next) {
#line 691 "util-i18n.c"
			gchar* _tmp23_;
			gchar* dic = NULL;
#line 73 "../src/client/util/util-i18n.vala"
			_tmp23_ = g_strdup ((const gchar*) dic_it->data);
#line 73 "../src/client/util/util-i18n.vala"
			dic = _tmp23_;
#line 698 "util-i18n.c"
			{
				const gchar* _tmp24_;
				gchar* _tmp25_;
#line 74 "../src/client/util/util-i18n.vala"
				_tmp24_ = dic;
#line 74 "../src/client/util/util-i18n.vala"
				_tmp25_ = g_strdup (_tmp24_);
#line 74 "../src/client/util/util-i18n.vala"
				_vala_array_add20 (&_data103_->dictionaries, &_data103_->dictionaries_length1, &_data103_->_dictionaries_size_, _tmp25_);
#line 73 "../src/client/util/util-i18n.vala"
				_g_free0 (dic);
#line 710 "util-i18n.c"
			}
		}
	}
#line 77 "../src/client/util/util-i18n.vala"
	_tmp26_ = _data103_->dictionaries;
#line 77 "../src/client/util/util-i18n.vala"
	_tmp26__length1 = _data103_->dictionaries_length1;
#line 77 "../src/client/util/util-i18n.vala"
	_tmp27_ = (_tmp26_ != NULL) ? _vala_array_dup7 (_tmp26_, _tmp26__length1) : _tmp26_;
#line 77 "../src/client/util/util-i18n.vala"
	_tmp27__length1 = _tmp26__length1;
#line 77 "../src/client/util/util-i18n.vala"
	_tmp28_ = _tmp27_;
#line 77 "../src/client/util/util-i18n.vala"
	_tmp28__length1 = _tmp27__length1;
#line 77 "../src/client/util/util-i18n.vala"
	if (result_length1) {
#line 77 "../src/client/util/util-i18n.vala"
		*result_length1 = _tmp28__length1;
#line 730 "util-i18n.c"
	}
#line 77 "../src/client/util/util-i18n.vala"
	result = _tmp28_;
#line 77 "../src/client/util/util-i18n.vala"
	(filtered_dictionaries == NULL) ? NULL : (filtered_dictionaries = (_g_list_free__g_free0_ (filtered_dictionaries), NULL));
#line 77 "../src/client/util/util-i18n.vala"
	_g_hash_table_unref0 (regional_dictionaries);
#line 77 "../src/client/util/util-i18n.vala"
	_enchant_broker_free0 (broker);
#line 77 "../src/client/util/util-i18n.vala"
	block103_data_unref (_data103_);
#line 77 "../src/client/util/util-i18n.vala"
	_data103_ = NULL;
#line 77 "../src/client/util/util-i18n.vala"
	return result;
#line 746 "util-i18n.c"
}

/**
     * Returns a list of installed locale languages.
     *
     * Each language is a POSIX-style locale name (ISO/IEC 15897).
     * The list is generated by executing `locale -a`.
     */
static void
_vala_array_add21 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 96 "../src/client/util/util-i18n.vala"
	if ((*length) == (*size)) {
#line 96 "../src/client/util/util-i18n.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 96 "../src/client/util/util-i18n.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 767 "util-i18n.c"
	}
#line 96 "../src/client/util/util-i18n.vala"
	(*array)[(*length)++] = value;
#line 96 "../src/client/util/util-i18n.vala"
	(*array)[*length] = NULL;
#line 773 "util-i18n.c"
}

gchar**
util_i18n_get_available_locales (gint* result_length1)
{
	gchar** locales = NULL;
	gchar** _tmp0_;
	gint locales_length1;
	gint _locales_size_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 87 "../src/client/util/util-i18n.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 87 "../src/client/util/util-i18n.vala"
	locales = _tmp0_;
#line 87 "../src/client/util/util-i18n.vala"
	locales_length1 = 0;
#line 87 "../src/client/util/util-i18n.vala"
	_locales_size_ = locales_length1;
#line 795 "util-i18n.c"
	{
		gchar* output = NULL;
		GSubprocess* p = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		GSubprocess* _tmp5_;
		GSubprocess* _tmp6_;
		GSubprocess* _tmp7_;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
#line 90 "../src/client/util/util-i18n.vala"
		output = NULL;
#line 91 "../src/client/util/util-i18n.vala"
		_tmp1_ = g_strdup ("locale");
#line 91 "../src/client/util/util-i18n.vala"
		_tmp2_ = g_strdup ("-a");
#line 91 "../src/client/util/util-i18n.vala"
		_tmp3_ = g_new0 (gchar*, 2 + 1);
#line 91 "../src/client/util/util-i18n.vala"
		_tmp3_[0] = _tmp1_;
#line 91 "../src/client/util/util-i18n.vala"
		_tmp3_[1] = _tmp2_;
#line 91 "../src/client/util/util-i18n.vala"
		_tmp4_ = _tmp3_;
#line 91 "../src/client/util/util-i18n.vala"
		_tmp4__length1 = 2;
#line 91 "../src/client/util/util-i18n.vala"
		_tmp5_ = g_subprocess_newv (_tmp4_, G_SUBPROCESS_FLAGS_STDOUT_PIPE, &_inner_error0_);
#line 91 "../src/client/util/util-i18n.vala"
		_tmp6_ = _tmp5_;
#line 91 "../src/client/util/util-i18n.vala"
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 91 "../src/client/util/util-i18n.vala"
		p = _tmp6_;
#line 91 "../src/client/util/util-i18n.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/client/util/util-i18n.vala"
			_g_free0 (output);
#line 839 "util-i18n.c"
			goto __catch0_g_error;
		}
#line 93 "../src/client/util/util-i18n.vala"
		_tmp7_ = p;
#line 93 "../src/client/util/util-i18n.vala"
		g_subprocess_communicate_utf8 (_tmp7_, NULL, NULL, &_tmp8_, NULL, &_inner_error0_);
#line 93 "../src/client/util/util-i18n.vala"
		_g_free0 (output);
#line 93 "../src/client/util/util-i18n.vala"
		output = _tmp8_;
#line 93 "../src/client/util/util-i18n.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../src/client/util/util-i18n.vala"
			_g_object_unref0 (p);
#line 93 "../src/client/util/util-i18n.vala"
			_g_free0 (output);
#line 856 "util-i18n.c"
			goto __catch0_g_error;
		}
#line 95 "../src/client/util/util-i18n.vala"
		_tmp9_ = output;
#line 95 "../src/client/util/util-i18n.vala"
		_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, "\n", 0);
#line 863 "util-i18n.c"
		{
			gchar** l_collection = NULL;
			gint l_collection_length1 = 0;
			gint _l_collection_size_ = 0;
			gint l_it = 0;
#line 95 "../src/client/util/util-i18n.vala"
			l_collection = _tmp11_;
#line 95 "../src/client/util/util-i18n.vala"
			l_collection_length1 = _vala_array_length (_tmp10_);
#line 95 "../src/client/util/util-i18n.vala"
			for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
#line 875 "util-i18n.c"
				gchar* _tmp12_;
				gchar* l = NULL;
#line 95 "../src/client/util/util-i18n.vala"
				_tmp12_ = g_strdup (l_collection[l_it]);
#line 95 "../src/client/util/util-i18n.vala"
				l = _tmp12_;
#line 882 "util-i18n.c"
				{
					const gchar* _tmp13_;
					gchar* _tmp14_;
#line 96 "../src/client/util/util-i18n.vala"
					_tmp13_ = l;
#line 96 "../src/client/util/util-i18n.vala"
					_tmp14_ = g_strdup (_tmp13_);
#line 96 "../src/client/util/util-i18n.vala"
					_vala_array_add21 (&locales, &locales_length1, &_locales_size_, _tmp14_);
#line 95 "../src/client/util/util-i18n.vala"
					_g_free0 (l);
#line 894 "util-i18n.c"
				}
			}
#line 95 "../src/client/util/util-i18n.vala"
			l_collection = (_vala_array_free (l_collection, l_collection_length1, (GDestroyNotify) g_free), NULL);
#line 899 "util-i18n.c"
		}
#line 89 "../src/client/util/util-i18n.vala"
		_g_object_unref0 (p);
#line 89 "../src/client/util/util-i18n.vala"
		_g_free0 (output);
#line 905 "util-i18n.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		gchar** _tmp15_;
		gint _tmp15__length1;
#line 89 "../src/client/util/util-i18n.vala"
		g_clear_error (&_inner_error0_);
#line 99 "../src/client/util/util-i18n.vala"
		_tmp15_ = locales;
#line 99 "../src/client/util/util-i18n.vala"
		_tmp15__length1 = locales_length1;
#line 99 "../src/client/util/util-i18n.vala"
		if (result_length1) {
#line 99 "../src/client/util/util-i18n.vala"
			*result_length1 = _tmp15__length1;
#line 922 "util-i18n.c"
		}
#line 99 "../src/client/util/util-i18n.vala"
		result = _tmp15_;
#line 99 "../src/client/util/util-i18n.vala"
		return result;
#line 928 "util-i18n.c"
	}
	__finally0:
#line 89 "../src/client/util/util-i18n.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "../src/client/util/util-i18n.vala"
		locales = (_vala_array_free (locales, locales_length1, (GDestroyNotify) g_free), NULL);
#line 89 "../src/client/util/util-i18n.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 89 "../src/client/util/util-i18n.vala"
		g_clear_error (&_inner_error0_);
#line 89 "../src/client/util/util-i18n.vala"
		return NULL;
#line 941 "util-i18n.c"
	}
#line 102 "../src/client/util/util-i18n.vala"
	_tmp16_ = locales;
#line 102 "../src/client/util/util-i18n.vala"
	_tmp16__length1 = locales_length1;
#line 102 "../src/client/util/util-i18n.vala"
	if (result_length1) {
#line 102 "../src/client/util/util-i18n.vala"
		*result_length1 = _tmp16__length1;
#line 951 "util-i18n.c"
	}
#line 102 "../src/client/util/util-i18n.vala"
	result = _tmp16_;
#line 102 "../src/client/util/util-i18n.vala"
	return result;
#line 957 "util-i18n.c"
}

gchar*
util_i18n_strip_encoding (const gchar* locale)
{
	gint dot = 0;
	gchar* _tmp0_;
	gchar* result;
#line 111 "../src/client/util/util-i18n.vala"
	g_return_val_if_fail (locale != NULL, NULL);
#line 112 "../src/client/util/util-i18n.vala"
	dot = string_index_of_char (locale, (gunichar) '.', 0);
#line 113 "../src/client/util/util-i18n.vala"
	_tmp0_ = string_substring (locale, (glong) 0, (glong) dot);
#line 113 "../src/client/util/util-i18n.vala"
	result = _tmp0_;
#line 113 "../src/client/util/util-i18n.vala"
	return result;
#line 976 "util-i18n.c"
}

/**
     * Returns a list of preferred spell-check languages.
     *
     * Each language is a POSIX-style locale name (ISO/IEC 15897).
     * The list is generated by obtaining the list of POSIX locales
     * specified by the `LANGUAGE` environment variable, and including
     * each that has both an available dictionary and locale.
     *
     * @see get_available_dictionaries
     * @see get_available_locales
     */
static void
_vala_array_add22 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 144 "../src/client/util/util-i18n.vala"
	if ((*length) == (*size)) {
#line 144 "../src/client/util/util-i18n.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 144 "../src/client/util/util-i18n.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1002 "util-i18n.c"
	}
#line 144 "../src/client/util/util-i18n.vala"
	(*array)[(*length)++] = value;
#line 144 "../src/client/util/util-i18n.vala"
	(*array)[*length] = NULL;
#line 1008 "util-i18n.c"
}

gchar**
util_i18n_get_user_preferred_languages (gint* result_length1)
{
	GHashTable* dicts = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	GHashTable* locales = NULL;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	GHashTable* _tmp11_;
	gint _tmp12_ = 0;
	gchar** _tmp13_;
	gchar** output = NULL;
	gchar** _tmp18_;
	gint output_length1;
	gint _output_size_;
	gchar** language_names = NULL;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint language_names_length1;
	gint _language_names_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gchar** _tmp32_;
	gint _tmp32__length1;
	gchar** result;
#line 128 "../src/client/util/util-i18n.vala"
	_tmp0_ = g_str_hash;
#line 128 "../src/client/util/util-i18n.vala"
	_tmp1_ = g_str_equal;
#line 128 "../src/client/util/util-i18n.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_free0_);
#line 128 "../src/client/util/util-i18n.vala"
	dicts = _tmp2_;
#line 129 "../src/client/util/util-i18n.vala"
	_tmp4_ = util_i18n_get_available_dictionaries (&_tmp3_);
#line 1050 "util-i18n.c"
	{
		gchar** dict_collection = NULL;
		gint dict_collection_length1 = 0;
		gint _dict_collection_size_ = 0;
		gint dict_it = 0;
#line 129 "../src/client/util/util-i18n.vala"
		dict_collection = _tmp4_;
#line 129 "../src/client/util/util-i18n.vala"
		dict_collection_length1 = _tmp3_;
#line 129 "../src/client/util/util-i18n.vala"
		for (dict_it = 0; dict_it < dict_collection_length1; dict_it = dict_it + 1) {
#line 1062 "util-i18n.c"
			gchar* _tmp5_;
			gchar* dict = NULL;
#line 129 "../src/client/util/util-i18n.vala"
			_tmp5_ = g_strdup (dict_collection[dict_it]);
#line 129 "../src/client/util/util-i18n.vala"
			dict = _tmp5_;
#line 1069 "util-i18n.c"
			{
				GHashTable* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
#line 130 "../src/client/util/util-i18n.vala"
				_tmp6_ = dicts;
#line 130 "../src/client/util/util-i18n.vala"
				_tmp7_ = dict;
#line 130 "../src/client/util/util-i18n.vala"
				_tmp8_ = g_strdup (_tmp7_);
#line 130 "../src/client/util/util-i18n.vala"
				g_hash_table_add (_tmp6_, _tmp8_);
#line 129 "../src/client/util/util-i18n.vala"
				_g_free0 (dict);
#line 1084 "util-i18n.c"
			}
		}
#line 129 "../src/client/util/util-i18n.vala"
		dict_collection = (_vala_array_free (dict_collection, dict_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1089 "util-i18n.c"
	}
#line 133 "../src/client/util/util-i18n.vala"
	_tmp9_ = g_str_hash;
#line 133 "../src/client/util/util-i18n.vala"
	_tmp10_ = g_str_equal;
#line 133 "../src/client/util/util-i18n.vala"
	_tmp11_ = g_hash_table_new_full (_tmp9_, _tmp10_, NULL, _g_free0_);
#line 133 "../src/client/util/util-i18n.vala"
	locales = _tmp11_;
#line 134 "../src/client/util/util-i18n.vala"
	_tmp13_ = util_i18n_get_available_locales (&_tmp12_);
#line 1101 "util-i18n.c"
	{
		gchar** locale_collection = NULL;
		gint locale_collection_length1 = 0;
		gint _locale_collection_size_ = 0;
		gint locale_it = 0;
#line 134 "../src/client/util/util-i18n.vala"
		locale_collection = _tmp13_;
#line 134 "../src/client/util/util-i18n.vala"
		locale_collection_length1 = _tmp12_;
#line 134 "../src/client/util/util-i18n.vala"
		for (locale_it = 0; locale_it < locale_collection_length1; locale_it = locale_it + 1) {
#line 1113 "util-i18n.c"
			gchar* _tmp14_;
			gchar* locale = NULL;
#line 134 "../src/client/util/util-i18n.vala"
			_tmp14_ = g_strdup (locale_collection[locale_it]);
#line 134 "../src/client/util/util-i18n.vala"
			locale = _tmp14_;
#line 1120 "util-i18n.c"
			{
				GHashTable* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 135 "../src/client/util/util-i18n.vala"
				_tmp15_ = locales;
#line 135 "../src/client/util/util-i18n.vala"
				_tmp16_ = locale;
#line 135 "../src/client/util/util-i18n.vala"
				_tmp17_ = util_i18n_strip_encoding (_tmp16_);
#line 135 "../src/client/util/util-i18n.vala"
				g_hash_table_add (_tmp15_, _tmp17_);
#line 134 "../src/client/util/util-i18n.vala"
				_g_free0 (locale);
#line 1135 "util-i18n.c"
			}
		}
#line 134 "../src/client/util/util-i18n.vala"
		locale_collection = (_vala_array_free (locale_collection, locale_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1140 "util-i18n.c"
	}
#line 138 "../src/client/util/util-i18n.vala"
	_tmp18_ = g_new0 (gchar*, 0 + 1);
#line 138 "../src/client/util/util-i18n.vala"
	output = _tmp18_;
#line 138 "../src/client/util/util-i18n.vala"
	output_length1 = 0;
#line 138 "../src/client/util/util-i18n.vala"
	_output_size_ = output_length1;
#line 139 "../src/client/util/util-i18n.vala"
	_tmp20_ = _tmp19_ = g_get_language_names ();
#line 139 "../src/client/util/util-i18n.vala"
	language_names = _tmp20_;
#line 139 "../src/client/util/util-i18n.vala"
	language_names_length1 = _vala_array_length (_tmp19_);
#line 139 "../src/client/util/util-i18n.vala"
	_language_names_size_ = language_names_length1;
#line 140 "../src/client/util/util-i18n.vala"
	_tmp21_ = language_names;
#line 140 "../src/client/util/util-i18n.vala"
	_tmp21__length1 = language_names_length1;
#line 1162 "util-i18n.c"
	{
		gchar** lang_collection = NULL;
		gint lang_collection_length1 = 0;
		gint _lang_collection_size_ = 0;
		gint lang_it = 0;
#line 140 "../src/client/util/util-i18n.vala"
		lang_collection = _tmp21_;
#line 140 "../src/client/util/util-i18n.vala"
		lang_collection_length1 = _tmp21__length1;
#line 140 "../src/client/util/util-i18n.vala"
		for (lang_it = 0; lang_it < lang_collection_length1; lang_it = lang_it + 1) {
#line 1174 "util-i18n.c"
			gchar* _tmp22_;
			gchar* lang = NULL;
#line 140 "../src/client/util/util-i18n.vala"
			_tmp22_ = g_strdup (lang_collection[lang_it]);
#line 140 "../src/client/util/util-i18n.vala"
			lang = _tmp22_;
#line 1181 "util-i18n.c"
			{
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				const gchar* _tmp25_;
#line 143 "../src/client/util/util-i18n.vala"
				_tmp25_ = lang;
#line 143 "../src/client/util/util-i18n.vala"
				if (g_strcmp0 (_tmp25_, "C") != 0) {
#line 1190 "util-i18n.c"
					GHashTable* _tmp26_;
					const gchar* _tmp27_;
#line 143 "../src/client/util/util-i18n.vala"
					_tmp26_ = dicts;
#line 143 "../src/client/util/util-i18n.vala"
					_tmp27_ = lang;
#line 143 "../src/client/util/util-i18n.vala"
					_tmp24_ = g_hash_table_contains (_tmp26_, _tmp27_);
#line 1199 "util-i18n.c"
				} else {
#line 143 "../src/client/util/util-i18n.vala"
					_tmp24_ = FALSE;
#line 1203 "util-i18n.c"
				}
#line 143 "../src/client/util/util-i18n.vala"
				if (_tmp24_) {
#line 1207 "util-i18n.c"
					GHashTable* _tmp28_;
					const gchar* _tmp29_;
#line 143 "../src/client/util/util-i18n.vala"
					_tmp28_ = locales;
#line 143 "../src/client/util/util-i18n.vala"
					_tmp29_ = lang;
#line 143 "../src/client/util/util-i18n.vala"
					_tmp23_ = g_hash_table_contains (_tmp28_, _tmp29_);
#line 1216 "util-i18n.c"
				} else {
#line 143 "../src/client/util/util-i18n.vala"
					_tmp23_ = FALSE;
#line 1220 "util-i18n.c"
				}
#line 143 "../src/client/util/util-i18n.vala"
				if (_tmp23_) {
#line 1224 "util-i18n.c"
					const gchar* _tmp30_;
					gchar* _tmp31_;
#line 144 "../src/client/util/util-i18n.vala"
					_tmp30_ = lang;
#line 144 "../src/client/util/util-i18n.vala"
					_tmp31_ = g_strdup (_tmp30_);
#line 144 "../src/client/util/util-i18n.vala"
					_vala_array_add22 (&output, &output_length1, &_output_size_, _tmp31_);
#line 1233 "util-i18n.c"
				}
#line 140 "../src/client/util/util-i18n.vala"
				_g_free0 (lang);
#line 1237 "util-i18n.c"
			}
		}
	}
#line 147 "../src/client/util/util-i18n.vala"
	_tmp32_ = output;
#line 147 "../src/client/util/util-i18n.vala"
	_tmp32__length1 = output_length1;
#line 147 "../src/client/util/util-i18n.vala"
	if (result_length1) {
#line 147 "../src/client/util/util-i18n.vala"
		*result_length1 = _tmp32__length1;
#line 1249 "util-i18n.c"
	}
#line 147 "../src/client/util/util-i18n.vala"
	result = _tmp32_;
#line 147 "../src/client/util/util-i18n.vala"
	_g_hash_table_unref0 (locales);
#line 147 "../src/client/util/util-i18n.vala"
	_g_hash_table_unref0 (dicts);
#line 147 "../src/client/util/util-i18n.vala"
	return result;
#line 1259 "util-i18n.c"
}

gchar*
util_i18n_language_name_from_locale (const gchar* locale)
{
	GHashTable* _tmp0_;
	gint pos = 0;
	gchar* language_name = NULL;
	GHashTable* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gconstpointer _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* result;
#line 150 "../src/client/util/util-i18n.vala"
	g_return_val_if_fail (locale != NULL, NULL);
#line 151 "../src/client/util/util-i18n.vala"
	_tmp0_ = util_i18n_language_names;
#line 151 "../src/client/util/util-i18n.vala"
	if (_tmp0_ == NULL) {
#line 1281 "util-i18n.c"
		GHashFunc _tmp1_;
		GEqualFunc _tmp2_;
		GHashTable* _tmp3_;
		xmlDoc* doc = NULL;
		xmlDoc* _tmp4_;
		xmlDoc* _tmp5_;
#line 152 "../src/client/util/util-i18n.vala"
		_tmp1_ = g_str_hash;
#line 152 "../src/client/util/util-i18n.vala"
		_tmp2_ = g_str_equal;
#line 152 "../src/client/util/util-i18n.vala"
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_free0_);
#line 152 "../src/client/util/util-i18n.vala"
		_g_hash_table_unref0 (util_i18n_language_names);
#line 152 "../src/client/util/util-i18n.vala"
		util_i18n_language_names = _tmp3_;
#line 154 "../src/client/util/util-i18n.vala"
		_tmp4_ = xmlParseFile (_ISO_CODE_639_XML);
#line 154 "../src/client/util/util-i18n.vala"
		doc = _tmp4_;
#line 155 "../src/client/util/util-i18n.vala"
		_tmp5_ = doc;
#line 155 "../src/client/util/util-i18n.vala"
		if (_tmp5_ == NULL) {
#line 156 "../src/client/util/util-i18n.vala"
			result = NULL;
#line 156 "../src/client/util/util-i18n.vala"
			return result;
#line 1310 "util-i18n.c"
		} else {
			xmlNode* root = NULL;
			xmlDoc* _tmp6_;
			xmlNode* _tmp7_;
#line 159 "../src/client/util/util-i18n.vala"
			_tmp6_ = doc;
#line 159 "../src/client/util/util-i18n.vala"
			_tmp7_ = xmlDocGetRootElement (_tmp6_);
#line 159 "../src/client/util/util-i18n.vala"
			root = _tmp7_;
#line 1321 "util-i18n.c"
			{
				xmlNode* entry = NULL;
				xmlNode* _tmp8_;
				xmlNode* _tmp9_;
#line 160 "../src/client/util/util-i18n.vala"
				_tmp8_ = root;
#line 160 "../src/client/util/util-i18n.vala"
				_tmp9_ = _tmp8_->children;
#line 160 "../src/client/util/util-i18n.vala"
				entry = _tmp9_;
#line 1332 "util-i18n.c"
				{
					gboolean _tmp10_ = FALSE;
#line 160 "../src/client/util/util-i18n.vala"
					_tmp10_ = TRUE;
#line 160 "../src/client/util/util-i18n.vala"
					while (TRUE) {
#line 1339 "util-i18n.c"
						xmlNode* _tmp13_;
						xmlNode* _tmp14_;
#line 160 "../src/client/util/util-i18n.vala"
						if (!_tmp10_) {
#line 1344 "util-i18n.c"
							xmlNode* _tmp11_;
							xmlNode* _tmp12_;
#line 160 "../src/client/util/util-i18n.vala"
							_tmp11_ = entry;
#line 160 "../src/client/util/util-i18n.vala"
							_tmp12_ = _tmp11_->next;
#line 160 "../src/client/util/util-i18n.vala"
							entry = _tmp12_;
#line 1353 "util-i18n.c"
						}
#line 160 "../src/client/util/util-i18n.vala"
						_tmp10_ = FALSE;
#line 160 "../src/client/util/util-i18n.vala"
						_tmp13_ = entry;
#line 160 "../src/client/util/util-i18n.vala"
						if (!(_tmp13_ != NULL)) {
#line 160 "../src/client/util/util-i18n.vala"
							break;
#line 1363 "util-i18n.c"
						}
#line 161 "../src/client/util/util-i18n.vala"
						_tmp14_ = entry;
#line 161 "../src/client/util/util-i18n.vala"
						if (_tmp14_->type == XML_ELEMENT_NODE) {
#line 1369 "util-i18n.c"
							gchar* iso_639_1 = NULL;
							gchar* language_name = NULL;
#line 162 "../src/client/util/util-i18n.vala"
							iso_639_1 = NULL;
#line 163 "../src/client/util/util-i18n.vala"
							language_name = NULL;
#line 1376 "util-i18n.c"
							{
								xmlAttr* a = NULL;
								xmlNode* _tmp15_;
								xmlAttr* _tmp16_;
#line 165 "../src/client/util/util-i18n.vala"
								_tmp15_ = entry;
#line 165 "../src/client/util/util-i18n.vala"
								_tmp16_ = _tmp15_->properties;
#line 165 "../src/client/util/util-i18n.vala"
								a = _tmp16_;
#line 1387 "util-i18n.c"
								{
									gboolean _tmp17_ = FALSE;
#line 165 "../src/client/util/util-i18n.vala"
									_tmp17_ = TRUE;
#line 165 "../src/client/util/util-i18n.vala"
									while (TRUE) {
#line 1394 "util-i18n.c"
										xmlAttr* _tmp20_;
										xmlAttr* _tmp21_;
										const gchar* _tmp22_;
										const gchar* _tmp23_;
										GQuark _tmp25_ = 0U;
#line 166 "../src/client/util/util-i18n.vala"
										static GQuark _tmp24_label0 = 0;
#line 166 "../src/client/util/util-i18n.vala"
										static GQuark _tmp24_label1 = 0;
#line 1404 "util-i18n.c"
										const gchar* _tmp34_;
#line 165 "../src/client/util/util-i18n.vala"
										if (!_tmp17_) {
#line 1408 "util-i18n.c"
											xmlAttr* _tmp18_;
											xmlAttr* _tmp19_;
#line 165 "../src/client/util/util-i18n.vala"
											_tmp18_ = a;
#line 165 "../src/client/util/util-i18n.vala"
											_tmp19_ = _tmp18_->next;
#line 165 "../src/client/util/util-i18n.vala"
											a = _tmp19_;
#line 1417 "util-i18n.c"
										}
#line 165 "../src/client/util/util-i18n.vala"
										_tmp17_ = FALSE;
#line 165 "../src/client/util/util-i18n.vala"
										_tmp20_ = a;
#line 165 "../src/client/util/util-i18n.vala"
										if (!(_tmp20_ != NULL)) {
#line 165 "../src/client/util/util-i18n.vala"
											break;
#line 1427 "util-i18n.c"
										}
#line 166 "../src/client/util/util-i18n.vala"
										_tmp21_ = a;
#line 166 "../src/client/util/util-i18n.vala"
										_tmp22_ = _tmp21_->name;
#line 166 "../src/client/util/util-i18n.vala"
										_tmp23_ = _tmp22_;
#line 166 "../src/client/util/util-i18n.vala"
										_tmp25_ = (NULL == _tmp23_) ? 0 : g_quark_from_string (_tmp23_);
#line 166 "../src/client/util/util-i18n.vala"
										if (_tmp25_ == ((0 != _tmp24_label0) ? _tmp24_label0 : (_tmp24_label0 = g_quark_from_static_string ("iso_639_1_code")))) {
#line 166 "../src/client/util/util-i18n.vala"
											switch (0) {
#line 1441 "util-i18n.c"
												default:
												{
													xmlAttr* _tmp26_;
													xmlNode* _tmp27_;
													const gchar* _tmp28_;
													gchar* _tmp29_;
#line 168 "../src/client/util/util-i18n.vala"
													_tmp26_ = a;
#line 168 "../src/client/util/util-i18n.vala"
													_tmp27_ = _tmp26_->children;
#line 168 "../src/client/util/util-i18n.vala"
													_tmp28_ = _tmp27_->content;
#line 168 "../src/client/util/util-i18n.vala"
													_tmp29_ = g_strdup (_tmp28_);
#line 168 "../src/client/util/util-i18n.vala"
													_g_free0 (iso_639_1);
#line 168 "../src/client/util/util-i18n.vala"
													iso_639_1 = _tmp29_;
#line 169 "../src/client/util/util-i18n.vala"
													break;
#line 1462 "util-i18n.c"
												}
											}
										} else if (_tmp25_ == ((0 != _tmp24_label1) ? _tmp24_label1 : (_tmp24_label1 = g_quark_from_static_string ("name")))) {
#line 166 "../src/client/util/util-i18n.vala"
											switch (0) {
#line 1468 "util-i18n.c"
												default:
												{
													xmlAttr* _tmp30_;
													xmlNode* _tmp31_;
													const gchar* _tmp32_;
													gchar* _tmp33_;
#line 171 "../src/client/util/util-i18n.vala"
													_tmp30_ = a;
#line 171 "../src/client/util/util-i18n.vala"
													_tmp31_ = _tmp30_->children;
#line 171 "../src/client/util/util-i18n.vala"
													_tmp32_ = _tmp31_->content;
#line 171 "../src/client/util/util-i18n.vala"
													_tmp33_ = g_strdup (_tmp32_);
#line 171 "../src/client/util/util-i18n.vala"
													_g_free0 (language_name);
#line 171 "../src/client/util/util-i18n.vala"
													language_name = _tmp33_;
#line 172 "../src/client/util/util-i18n.vala"
													break;
#line 1489 "util-i18n.c"
												}
											}
										} else {
#line 166 "../src/client/util/util-i18n.vala"
											switch (0) {
#line 1495 "util-i18n.c"
												default:
												{
#line 174 "../src/client/util/util-i18n.vala"
													break;
#line 1500 "util-i18n.c"
												}
											}
										}
#line 177 "../src/client/util/util-i18n.vala"
										_tmp34_ = language_name;
#line 177 "../src/client/util/util-i18n.vala"
										if (_tmp34_ != NULL) {
#line 1508 "util-i18n.c"
											const gchar* _tmp35_;
#line 178 "../src/client/util/util-i18n.vala"
											_tmp35_ = iso_639_1;
#line 178 "../src/client/util/util-i18n.vala"
											if (_tmp35_ != NULL) {
#line 1514 "util-i18n.c"
												GHashTable* _tmp36_;
												const gchar* _tmp37_;
												gchar* _tmp38_;
												const gchar* _tmp39_;
												gchar* _tmp40_;
#line 179 "../src/client/util/util-i18n.vala"
												_tmp36_ = util_i18n_language_names;
#line 179 "../src/client/util/util-i18n.vala"
												_tmp37_ = iso_639_1;
#line 179 "../src/client/util/util-i18n.vala"
												_tmp38_ = g_strdup (_tmp37_);
#line 179 "../src/client/util/util-i18n.vala"
												_tmp39_ = language_name;
#line 179 "../src/client/util/util-i18n.vala"
												_tmp40_ = g_strdup (_tmp39_);
#line 179 "../src/client/util/util-i18n.vala"
												g_hash_table_insert (_tmp36_, _tmp38_, _tmp40_);
#line 1532 "util-i18n.c"
											}
										}
									}
								}
							}
#line 161 "../src/client/util/util-i18n.vala"
							_g_free0 (language_name);
#line 161 "../src/client/util/util-i18n.vala"
							_g_free0 (iso_639_1);
#line 1542 "util-i18n.c"
						}
					}
				}
			}
		}
	}
#line 189 "../src/client/util/util-i18n.vala"
	pos = -1;
#line 190 "../src/client/util/util-i18n.vala"
	if (string_contains (locale, "_")) {
#line 191 "../src/client/util/util-i18n.vala"
		pos = string_index_of_char (locale, (gunichar) '_', 0);
#line 1555 "util-i18n.c"
	}
#line 195 "../src/client/util/util-i18n.vala"
	_tmp41_ = util_i18n_language_names;
#line 195 "../src/client/util/util-i18n.vala"
	_tmp42_ = string_substring (locale, (glong) 0, (glong) pos);
#line 195 "../src/client/util/util-i18n.vala"
	_tmp43_ = _tmp42_;
#line 195 "../src/client/util/util-i18n.vala"
	_tmp44_ = g_hash_table_lookup (_tmp41_, _tmp43_);
#line 195 "../src/client/util/util-i18n.vala"
	_tmp45_ = g_strdup (g_dgettext ("iso_639", (const gchar*) _tmp44_));
#line 195 "../src/client/util/util-i18n.vala"
	_tmp46_ = _tmp45_;
#line 195 "../src/client/util/util-i18n.vala"
	_g_free0 (_tmp43_);
#line 195 "../src/client/util/util-i18n.vala"
	language_name = _tmp46_;
#line 197 "../src/client/util/util-i18n.vala"
	result = language_name;
#line 197 "../src/client/util/util-i18n.vala"
	return result;
#line 1577 "util-i18n.c"
}

gchar*
util_i18n_country_name_from_locale (const gchar* locale)
{
	GHashTable* _tmp0_;
	gint pos = 0;
	gchar* country_name = NULL;
	GHashTable* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gconstpointer _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* result;
#line 200 "../src/client/util/util-i18n.vala"
	g_return_val_if_fail (locale != NULL, NULL);
#line 201 "../src/client/util/util-i18n.vala"
	_tmp0_ = util_i18n_country_names;
#line 201 "../src/client/util/util-i18n.vala"
	if (_tmp0_ == NULL) {
#line 1599 "util-i18n.c"
		GHashFunc _tmp1_;
		GEqualFunc _tmp2_;
		GHashTable* _tmp3_;
		xmlDoc* doc = NULL;
		xmlDoc* _tmp4_;
		xmlDoc* _tmp5_;
#line 202 "../src/client/util/util-i18n.vala"
		_tmp1_ = g_str_hash;
#line 202 "../src/client/util/util-i18n.vala"
		_tmp2_ = g_str_equal;
#line 202 "../src/client/util/util-i18n.vala"
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_free0_);
#line 202 "../src/client/util/util-i18n.vala"
		_g_hash_table_unref0 (util_i18n_country_names);
#line 202 "../src/client/util/util-i18n.vala"
		util_i18n_country_names = _tmp3_;
#line 204 "../src/client/util/util-i18n.vala"
		_tmp4_ = xmlParseFile (_ISO_CODE_3166_XML);
#line 204 "../src/client/util/util-i18n.vala"
		doc = _tmp4_;
#line 206 "../src/client/util/util-i18n.vala"
		_tmp5_ = doc;
#line 206 "../src/client/util/util-i18n.vala"
		if (_tmp5_ == NULL) {
#line 207 "../src/client/util/util-i18n.vala"
			result = NULL;
#line 207 "../src/client/util/util-i18n.vala"
			return result;
#line 1628 "util-i18n.c"
		} else {
			xmlNode* root = NULL;
			xmlDoc* _tmp6_;
			xmlNode* _tmp7_;
#line 210 "../src/client/util/util-i18n.vala"
			_tmp6_ = doc;
#line 210 "../src/client/util/util-i18n.vala"
			_tmp7_ = xmlDocGetRootElement (_tmp6_);
#line 210 "../src/client/util/util-i18n.vala"
			root = _tmp7_;
#line 1639 "util-i18n.c"
			{
				xmlNode* entry = NULL;
				xmlNode* _tmp8_;
				xmlNode* _tmp9_;
#line 211 "../src/client/util/util-i18n.vala"
				_tmp8_ = root;
#line 211 "../src/client/util/util-i18n.vala"
				_tmp9_ = _tmp8_->children;
#line 211 "../src/client/util/util-i18n.vala"
				entry = _tmp9_;
#line 1650 "util-i18n.c"
				{
					gboolean _tmp10_ = FALSE;
#line 211 "../src/client/util/util-i18n.vala"
					_tmp10_ = TRUE;
#line 211 "../src/client/util/util-i18n.vala"
					while (TRUE) {
#line 1657 "util-i18n.c"
						xmlNode* _tmp13_;
						xmlNode* _tmp14_;
#line 211 "../src/client/util/util-i18n.vala"
						if (!_tmp10_) {
#line 1662 "util-i18n.c"
							xmlNode* _tmp11_;
							xmlNode* _tmp12_;
#line 211 "../src/client/util/util-i18n.vala"
							_tmp11_ = entry;
#line 211 "../src/client/util/util-i18n.vala"
							_tmp12_ = _tmp11_->next;
#line 211 "../src/client/util/util-i18n.vala"
							entry = _tmp12_;
#line 1671 "util-i18n.c"
						}
#line 211 "../src/client/util/util-i18n.vala"
						_tmp10_ = FALSE;
#line 211 "../src/client/util/util-i18n.vala"
						_tmp13_ = entry;
#line 211 "../src/client/util/util-i18n.vala"
						if (!(_tmp13_ != NULL)) {
#line 211 "../src/client/util/util-i18n.vala"
							break;
#line 1681 "util-i18n.c"
						}
#line 212 "../src/client/util/util-i18n.vala"
						_tmp14_ = entry;
#line 212 "../src/client/util/util-i18n.vala"
						if (_tmp14_->type == XML_ELEMENT_NODE) {
#line 1687 "util-i18n.c"
							gchar* iso_3166 = NULL;
							gchar* country_name = NULL;
#line 213 "../src/client/util/util-i18n.vala"
							iso_3166 = NULL;
#line 214 "../src/client/util/util-i18n.vala"
							country_name = NULL;
#line 1694 "util-i18n.c"
							{
								xmlAttr* a = NULL;
								xmlNode* _tmp15_;
								xmlAttr* _tmp16_;
#line 216 "../src/client/util/util-i18n.vala"
								_tmp15_ = entry;
#line 216 "../src/client/util/util-i18n.vala"
								_tmp16_ = _tmp15_->properties;
#line 216 "../src/client/util/util-i18n.vala"
								a = _tmp16_;
#line 1705 "util-i18n.c"
								{
									gboolean _tmp17_ = FALSE;
#line 216 "../src/client/util/util-i18n.vala"
									_tmp17_ = TRUE;
#line 216 "../src/client/util/util-i18n.vala"
									while (TRUE) {
#line 1712 "util-i18n.c"
										xmlAttr* _tmp20_;
										xmlAttr* _tmp21_;
										const gchar* _tmp22_;
										const gchar* _tmp23_;
										GQuark _tmp25_ = 0U;
#line 217 "../src/client/util/util-i18n.vala"
										static GQuark _tmp24_label0 = 0;
#line 217 "../src/client/util/util-i18n.vala"
										static GQuark _tmp24_label1 = 0;
#line 1722 "util-i18n.c"
										const gchar* _tmp34_;
#line 216 "../src/client/util/util-i18n.vala"
										if (!_tmp17_) {
#line 1726 "util-i18n.c"
											xmlAttr* _tmp18_;
											xmlAttr* _tmp19_;
#line 216 "../src/client/util/util-i18n.vala"
											_tmp18_ = a;
#line 216 "../src/client/util/util-i18n.vala"
											_tmp19_ = _tmp18_->next;
#line 216 "../src/client/util/util-i18n.vala"
											a = _tmp19_;
#line 1735 "util-i18n.c"
										}
#line 216 "../src/client/util/util-i18n.vala"
										_tmp17_ = FALSE;
#line 216 "../src/client/util/util-i18n.vala"
										_tmp20_ = a;
#line 216 "../src/client/util/util-i18n.vala"
										if (!(_tmp20_ != NULL)) {
#line 216 "../src/client/util/util-i18n.vala"
											break;
#line 1745 "util-i18n.c"
										}
#line 217 "../src/client/util/util-i18n.vala"
										_tmp21_ = a;
#line 217 "../src/client/util/util-i18n.vala"
										_tmp22_ = _tmp21_->name;
#line 217 "../src/client/util/util-i18n.vala"
										_tmp23_ = _tmp22_;
#line 217 "../src/client/util/util-i18n.vala"
										_tmp25_ = (NULL == _tmp23_) ? 0 : g_quark_from_string (_tmp23_);
#line 217 "../src/client/util/util-i18n.vala"
										if (_tmp25_ == ((0 != _tmp24_label0) ? _tmp24_label0 : (_tmp24_label0 = g_quark_from_static_string ("alpha_2_code")))) {
#line 217 "../src/client/util/util-i18n.vala"
											switch (0) {
#line 1759 "util-i18n.c"
												default:
												{
													xmlAttr* _tmp26_;
													xmlNode* _tmp27_;
													const gchar* _tmp28_;
													gchar* _tmp29_;
#line 219 "../src/client/util/util-i18n.vala"
													_tmp26_ = a;
#line 219 "../src/client/util/util-i18n.vala"
													_tmp27_ = _tmp26_->children;
#line 219 "../src/client/util/util-i18n.vala"
													_tmp28_ = _tmp27_->content;
#line 219 "../src/client/util/util-i18n.vala"
													_tmp29_ = g_strdup (_tmp28_);
#line 219 "../src/client/util/util-i18n.vala"
													_g_free0 (iso_3166);
#line 219 "../src/client/util/util-i18n.vala"
													iso_3166 = _tmp29_;
#line 220 "../src/client/util/util-i18n.vala"
													break;
#line 1780 "util-i18n.c"
												}
											}
										} else if (_tmp25_ == ((0 != _tmp24_label1) ? _tmp24_label1 : (_tmp24_label1 = g_quark_from_static_string ("name")))) {
#line 217 "../src/client/util/util-i18n.vala"
											switch (0) {
#line 1786 "util-i18n.c"
												default:
												{
													xmlAttr* _tmp30_;
													xmlNode* _tmp31_;
													const gchar* _tmp32_;
													gchar* _tmp33_;
#line 222 "../src/client/util/util-i18n.vala"
													_tmp30_ = a;
#line 222 "../src/client/util/util-i18n.vala"
													_tmp31_ = _tmp30_->children;
#line 222 "../src/client/util/util-i18n.vala"
													_tmp32_ = _tmp31_->content;
#line 222 "../src/client/util/util-i18n.vala"
													_tmp33_ = g_strdup (_tmp32_);
#line 222 "../src/client/util/util-i18n.vala"
													_g_free0 (country_name);
#line 222 "../src/client/util/util-i18n.vala"
													country_name = _tmp33_;
#line 223 "../src/client/util/util-i18n.vala"
													break;
#line 1807 "util-i18n.c"
												}
											}
										} else {
#line 217 "../src/client/util/util-i18n.vala"
											switch (0) {
#line 1813 "util-i18n.c"
												default:
												{
#line 225 "../src/client/util/util-i18n.vala"
													break;
#line 1818 "util-i18n.c"
												}
											}
										}
#line 228 "../src/client/util/util-i18n.vala"
										_tmp34_ = country_name;
#line 228 "../src/client/util/util-i18n.vala"
										if (_tmp34_ != NULL) {
#line 1826 "util-i18n.c"
											const gchar* _tmp35_;
#line 229 "../src/client/util/util-i18n.vala"
											_tmp35_ = iso_3166;
#line 229 "../src/client/util/util-i18n.vala"
											if (_tmp35_ != NULL) {
#line 1832 "util-i18n.c"
												GHashTable* _tmp36_;
												const gchar* _tmp37_;
												gchar* _tmp38_;
												const gchar* _tmp39_;
												gchar* _tmp40_;
#line 230 "../src/client/util/util-i18n.vala"
												_tmp36_ = util_i18n_country_names;
#line 230 "../src/client/util/util-i18n.vala"
												_tmp37_ = iso_3166;
#line 230 "../src/client/util/util-i18n.vala"
												_tmp38_ = g_strdup (_tmp37_);
#line 230 "../src/client/util/util-i18n.vala"
												_tmp39_ = country_name;
#line 230 "../src/client/util/util-i18n.vala"
												_tmp40_ = g_strdup (_tmp39_);
#line 230 "../src/client/util/util-i18n.vala"
												g_hash_table_insert (_tmp36_, _tmp38_, _tmp40_);
#line 1850 "util-i18n.c"
											}
										}
									}
								}
							}
#line 212 "../src/client/util/util-i18n.vala"
							_g_free0 (country_name);
#line 212 "../src/client/util/util-i18n.vala"
							_g_free0 (iso_3166);
#line 1860 "util-i18n.c"
						}
					}
				}
			}
		}
	}
#line 240 "../src/client/util/util-i18n.vala"
	pos = -1;
#line 241 "../src/client/util/util-i18n.vala"
	if (string_contains (locale, "_")) {
#line 242 "../src/client/util/util-i18n.vala"
		pos = string_index_of_char (locale, (gunichar) '_', 0);
#line 1873 "util-i18n.c"
	}
#line 245 "../src/client/util/util-i18n.vala"
	_tmp41_ = util_i18n_country_names;
#line 245 "../src/client/util/util-i18n.vala"
	_tmp42_ = string_substring (locale, (glong) (pos + 1), (glong) -1);
#line 245 "../src/client/util/util-i18n.vala"
	_tmp43_ = _tmp42_;
#line 245 "../src/client/util/util-i18n.vala"
	_tmp44_ = g_hash_table_lookup (_tmp41_, _tmp43_);
#line 245 "../src/client/util/util-i18n.vala"
	_tmp45_ = g_strdup (g_dgettext ("iso_3166", (const gchar*) _tmp44_));
#line 245 "../src/client/util/util-i18n.vala"
	_tmp46_ = _tmp45_;
#line 245 "../src/client/util/util-i18n.vala"
	_g_free0 (_tmp43_);
#line 245 "../src/client/util/util-i18n.vala"
	country_name = _tmp46_;
#line 247 "../src/client/util/util-i18n.vala"
	result = country_name;
#line 247 "../src/client/util/util-i18n.vala"
	return result;
#line 1895 "util-i18n.c"
}

/**
     * Returns the localised display name name for specific folder.
     *
     * If the folder has a special type, the result of {@link
     * to_folder_type_display_name} is returned, otherwise the last
     * folder path step is returned.
     */
gchar*
util_i18n_to_folder_display_name (GearyFolder* folder)
{
	gchar* name = NULL;
	GearyFolderSpecialUse _tmp0_;
	GearyFolderSpecialUse _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* result;
#line 257 "../src/client/util/util-i18n.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER), NULL);
#line 258 "../src/client/util/util-i18n.vala"
	_tmp0_ = geary_folder_get_used_as (folder);
#line 258 "../src/client/util/util-i18n.vala"
	_tmp1_ = _tmp0_;
#line 258 "../src/client/util/util-i18n.vala"
	_tmp2_ = util_i18n_to_folder_type_display_name (_tmp1_);
#line 258 "../src/client/util/util-i18n.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 258 "../src/client/util/util-i18n.vala"
	name = _tmp3_;
#line 259 "../src/client/util/util-i18n.vala"
	_tmp4_ = name;
#line 259 "../src/client/util/util-i18n.vala"
	if (geary_string_is_empty_or_whitespace (_tmp4_)) {
#line 1931 "util-i18n.c"
		GearyFolderPath* _tmp5_;
		GearyFolderPath* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 260 "../src/client/util/util-i18n.vala"
		_tmp5_ = geary_folder_get_path (folder);
#line 260 "../src/client/util/util-i18n.vala"
		_tmp6_ = _tmp5_;
#line 260 "../src/client/util/util-i18n.vala"
		_tmp7_ = geary_folder_path_get_name (_tmp6_);
#line 260 "../src/client/util/util-i18n.vala"
		_tmp8_ = _tmp7_;
#line 260 "../src/client/util/util-i18n.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 260 "../src/client/util/util-i18n.vala"
		_g_free0 (name);
#line 260 "../src/client/util/util-i18n.vala"
		name = _tmp9_;
#line 1951 "util-i18n.c"
	}
#line 262 "../src/client/util/util-i18n.vala"
	result = name;
#line 262 "../src/client/util/util-i18n.vala"
	return result;
#line 1957 "util-i18n.c"
}

/**
     * Returns the localised name for a specific folder type, if any.
     */
const gchar*
util_i18n_to_folder_type_display_name (GearyFolderSpecialUse use)
{
	const gchar* result;
#line 269 "../src/client/util/util-i18n.vala"
	switch (use) {
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_INBOX:
#line 1971 "util-i18n.c"
		{
#line 271 "../src/client/util/util-i18n.vala"
			result = _ ("Inbox");
#line 271 "../src/client/util/util-i18n.vala"
			return result;
#line 1977 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_DRAFTS:
#line 1981 "util-i18n.c"
		{
#line 274 "../src/client/util/util-i18n.vala"
			result = _ ("Drafts");
#line 274 "../src/client/util/util-i18n.vala"
			return result;
#line 1987 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_SENT:
#line 1991 "util-i18n.c"
		{
#line 277 "../src/client/util/util-i18n.vala"
			result = _ ("Sent");
#line 277 "../src/client/util/util-i18n.vala"
			return result;
#line 1997 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_FLAGGED:
#line 2001 "util-i18n.c"
		{
#line 280 "../src/client/util/util-i18n.vala"
			result = _ ("Starred");
#line 280 "../src/client/util/util-i18n.vala"
			return result;
#line 2007 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_IMPORTANT:
#line 2011 "util-i18n.c"
		{
#line 283 "../src/client/util/util-i18n.vala"
			result = _ ("Important");
#line 283 "../src/client/util/util-i18n.vala"
			return result;
#line 2017 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_ALL_MAIL:
#line 2021 "util-i18n.c"
		{
#line 286 "../src/client/util/util-i18n.vala"
			result = _ ("All Mail");
#line 286 "../src/client/util/util-i18n.vala"
			return result;
#line 2027 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_JUNK:
#line 2031 "util-i18n.c"
		{
#line 289 "../src/client/util/util-i18n.vala"
			result = _ ("Junk");
#line 289 "../src/client/util/util-i18n.vala"
			return result;
#line 2037 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_TRASH:
#line 2041 "util-i18n.c"
		{
#line 292 "../src/client/util/util-i18n.vala"
			result = _ ("Trash");
#line 292 "../src/client/util/util-i18n.vala"
			return result;
#line 2047 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_OUTBOX:
#line 2051 "util-i18n.c"
		{
#line 295 "../src/client/util/util-i18n.vala"
			result = _ ("Outbox");
#line 295 "../src/client/util/util-i18n.vala"
			return result;
#line 2057 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_SEARCH:
#line 2061 "util-i18n.c"
		{
#line 298 "../src/client/util/util-i18n.vala"
			result = _ ("Search");
#line 298 "../src/client/util/util-i18n.vala"
			return result;
#line 2067 "util-i18n.c"
		}
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_ARCHIVE:
#line 2071 "util-i18n.c"
		{
#line 301 "../src/client/util/util-i18n.vala"
			result = _ ("Archive");
#line 301 "../src/client/util/util-i18n.vala"
			return result;
#line 2077 "util-i18n.c"
		}
		default:
#line 269 "../src/client/util/util-i18n.vala"
		case GEARY_FOLDER_SPECIAL_USE_NONE:
#line 2082 "util-i18n.c"
		{
#line 305 "../src/client/util/util-i18n.vala"
			result = NULL;
#line 305 "../src/client/util/util-i18n.vala"
			return result;
#line 2088 "util-i18n.c"
		}
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

