/* mail-merge-csv.c generated by valac 0.56.14, the Vala compiler
 * generated from mail-merge-csv.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "util.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include "geary-engine.h"

#define MAIL_MERGE_CSV_READER_UTF8_DOUBLE ((guint8) 0x06)
#define MAIL_MERGE_CSV_READER_UTF8_TRIPLE ((guint8) 0x0E)
#define MAIL_MERGE_CSV_READER_UTF8_QUADRUPLE ((guint8) 0x1E)
#define MAIL_MERGE_CSV_READER_UTF8_TRAILER ((guint8) 0x02)
#define MAIL_MERGE_CSV_READER_UNICODE_REPLACEMENT_CHAR ((gunichar) 0xFFFD)

enum  {
	MAIL_MERGE_CSV_READER_0_PROPERTY,
	MAIL_MERGE_CSV_READER_LINE_ENDING_PROPERTY,
	MAIL_MERGE_CSV_READER_FIELD_SEPARATOR_PROPERTY,
	MAIL_MERGE_CSV_READER_NUM_PROPERTIES
};
static GParamSpec* mail_merge_csv_reader_properties[MAIL_MERGE_CSV_READER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _MailMergeCsvReaderNewData MailMergeCsvReaderNewData;
typedef struct _MailMergeCsvReaderReadRecordData MailMergeCsvReaderReadRecordData;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _MailMergeCsvReaderReadFieldData MailMergeCsvReaderReadFieldData;
typedef struct _MailMergeCsvReaderReadEolData MailMergeCsvReaderReadEolData;
typedef struct _MailMergeCsvReaderReadCharData MailMergeCsvReaderReadCharData;

/** Denotes CSV-specific error conditions. */
struct _MailMergeCsvReaderPrivate {
	gchar* _line_ending;
	gchar _field_separator;
	GInputStream* input;
	GCancellable* cancellable;
	gunichar next_char;
	guint last_record_length;
};

struct _MailMergeCsvReaderNewData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GType object_type;
	MailMergeCsvReader* self;
	GInputStream* input;
	GCancellable* cancellable;
	GBufferedInputStream* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	GError* _inner_error0_;
};

struct _MailMergeCsvReaderReadRecordData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailMergeCsvReader* self;
	gchar** result;
	gint result_length1;
	gchar** record;
	gint record_length1;
	gint _record_size_;
	GInputStream* _tmp0_;
	gchar** _tmp1_;
	gint next_field;
	gchar* field;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gint _tmp9_;
	gchar _tmp10_;
	GInputStream* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GError* _inner_error0_;
};

struct _MailMergeCsvReaderReadFieldData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailMergeCsvReader* self;
	gchar* result;
	gboolean quoted;
	GString* buf;
	GString* _tmp0_;
	gboolean _tmp1_;
	GInputStream* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gchar _tmp5_;
	gunichar c;
	gboolean _tmp6_;
	GString* _tmp7_;
	GString* _tmp8_;
	GString* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GError* _inner_error0_;
};

struct _MailMergeCsvReaderReadEolData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailMergeCsvReader* self;
	gboolean _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gunichar c;
	GError* _tmp3_;
	gunichar _vala1_c;
	gint i;
	gboolean _tmp4_;
	gint _tmp5_;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gunichar _tmp9_;
	const gchar* _tmp10_;
	GError* _tmp11_;
	GError* _inner_error0_;
};

struct _MailMergeCsvReaderReadCharData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailMergeCsvReader* self;
	gunichar result;
	gunichar c;
	guint8 buf[1];
	gsize bytes_read;
	GInputStream* _tmp0_;
	GCancellable* _tmp1_;
	gsize _tmp2_;
	guint8 next;
	guint8 _tmp3_;
	GError* _tmp4_;
	guint to_read;
	GError* _tmp5_;
	guint8 utf[5];
	gint i;
	gboolean _tmp6_;
	gint _tmp7_;
	GInputStream* _tmp8_;
	GCancellable* _tmp9_;
	gsize _tmp10_;
	gboolean _tmp11_;
	guint8 _tmp12_;
	guint8 _tmp13_;
	GInputStream* _tmp14_;
	GError* _inner_error0_;
};

static gint MailMergeCsvReader_private_offset;
static gpointer mail_merge_csv_reader_parent_class = NULL;

static inline gboolean mail_merge_csv_reader_is_text_char (gunichar c);
static void mail_merge_csv_reader_construct_data_free (gpointer _data);
static gboolean mail_merge_csv_reader_construct_co (MailMergeCsvReaderNewData* _data_);
static void mail_merge_csv_reader_read_char (MailMergeCsvReader* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static gunichar mail_merge_csv_reader_read_char_finish (MailMergeCsvReader* self,
                                                 GAsyncResult* _res_,
                                                 GError** error);
static void mail_merge_csv_reader_new_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void mail_merge_csv_reader_read_record_data_free (gpointer _data);
static gboolean mail_merge_csv_reader_read_record_co (MailMergeCsvReaderReadRecordData* _data_);
static void mail_merge_csv_reader_read_field (MailMergeCsvReader* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static gchar* mail_merge_csv_reader_read_field_finish (MailMergeCsvReader* self,
                                                GAsyncResult* _res_,
                                                GError** error);
static void mail_merge_csv_reader_read_record_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void mail_merge_csv_reader_read_eol (MailMergeCsvReader* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void mail_merge_csv_reader_read_eol_finish (MailMergeCsvReader* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static void mail_merge_csv_reader_read_field_data_free (gpointer _data);
static gboolean mail_merge_csv_reader_read_field_co (MailMergeCsvReaderReadFieldData* _data_);
static void mail_merge_csv_reader_read_field_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void mail_merge_csv_reader_read_eol_data_free (gpointer _data);
static gboolean mail_merge_csv_reader_read_eol_co (MailMergeCsvReaderReadEolData* _data_);
static void mail_merge_csv_reader_read_eol_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void mail_merge_csv_reader_read_char_data_free (gpointer _data);
static gboolean mail_merge_csv_reader_read_char_co (MailMergeCsvReaderReadCharData* _data_);
static void mail_merge_csv_reader_read_char_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void mail_merge_csv_reader_finalize (GObject * obj);
static GType mail_merge_csv_reader_get_type_once (void);
static void _vala_mail_merge_csv_reader_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_mail_merge_csv_reader_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

GQuark
mail_merge_csv_data_error_quark (void)
{
	return g_quark_from_static_string ("mail-merge-csv-data-error-quark");
}

static GType
mail_merge_csv_data_error_get_type_once (void)
{
	static const GEnumValue values[] = {{MAIL_MERGE_CSV_DATA_ERROR_NON_TEXT_DATA, "MAIL_MERGE_CSV_DATA_ERROR_NON_TEXT_DATA", "non-text-data"}, {MAIL_MERGE_CSV_DATA_ERROR_UNKNOWN_EOL, "MAIL_MERGE_CSV_DATA_ERROR_UNKNOWN_EOL", "unknown-eol"}, {MAIL_MERGE_CSV_DATA_ERROR_EOL_NOT_FOUND, "MAIL_MERGE_CSV_DATA_ERROR_EOL_NOT_FOUND", "eol-not-found"}, {0, NULL, NULL}};
	GType mail_merge_csv_data_error_type_id;
	mail_merge_csv_data_error_type_id = g_enum_register_static ("MailMergeCsvDataError", values);
	return mail_merge_csv_data_error_type_id;
}

GType
mail_merge_csv_data_error_get_type (void)
{
	static volatile gsize mail_merge_csv_data_error_type_id__once = 0;
	if (g_once_init_enter (&mail_merge_csv_data_error_type_id__once)) {
		GType mail_merge_csv_data_error_type_id;
		mail_merge_csv_data_error_type_id = mail_merge_csv_data_error_get_type_once ();
		g_once_init_leave (&mail_merge_csv_data_error_type_id__once, mail_merge_csv_data_error_type_id);
	}
	return mail_merge_csv_data_error_type_id__once;
}

static inline gpointer
mail_merge_csv_reader_get_instance_private (MailMergeCsvReader* self)
{
	return G_STRUCT_MEMBER_P (self, MailMergeCsvReader_private_offset);
}

static inline gboolean
mail_merge_csv_reader_is_text_char (gunichar c)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 42 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (c == ((gunichar) 0x20)) {
#line 42 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp3_ = TRUE;
#line 303 "mail-merge-csv.c"
	} else {
#line 43 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp3_ = c == ((gunichar) 0x21);
#line 307 "mail-merge-csv.c"
	}
#line 42 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_tmp3_) {
#line 42 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp2_ = TRUE;
#line 313 "mail-merge-csv.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 44 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (c >= ((gunichar) 0x23)) {
#line 44 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_tmp4_ = c <= ((gunichar) 0x2B);
#line 320 "mail-merge-csv.c"
		} else {
#line 44 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_tmp4_ = FALSE;
#line 324 "mail-merge-csv.c"
		}
#line 44 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp2_ = _tmp4_;
#line 328 "mail-merge-csv.c"
	}
#line 42 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_tmp2_) {
#line 42 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp1_ = TRUE;
#line 334 "mail-merge-csv.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 45 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (c >= ((gunichar) 0x2D)) {
#line 45 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_tmp5_ = c <= ((gunichar) 0x7E);
#line 341 "mail-merge-csv.c"
		} else {
#line 45 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_tmp5_ = FALSE;
#line 345 "mail-merge-csv.c"
		}
#line 45 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp1_ = _tmp5_;
#line 349 "mail-merge-csv.c"
	}
#line 41 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_tmp1_) {
#line 42 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp0_ = TRUE;
#line 355 "mail-merge-csv.c"
	} else {
#line 46 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp0_ = c >= ((gunichar) 0x80);
#line 359 "mail-merge-csv.c"
	}
#line 41 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	result = _tmp0_;
#line 41 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return result;
#line 365 "mail-merge-csv.c"
}

const gchar*
mail_merge_csv_reader_get_line_ending (MailMergeCsvReader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_val_if_fail (MAIL_MERGE_CSV_IS_READER (self), NULL);
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_tmp0_ = self->priv->_line_ending;
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	result = _tmp0_;
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return result;
#line 381 "mail-merge-csv.c"
}

void
mail_merge_csv_reader_set_line_ending (MailMergeCsvReader* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_if_fail (MAIL_MERGE_CSV_IS_READER (self));
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	old_value = mail_merge_csv_reader_get_line_ending (self);
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 395 "mail-merge-csv.c"
		gchar* _tmp0_;
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_tmp0_ = g_strdup (value);
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_g_free0 (self->priv->_line_ending);
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		self->priv->_line_ending = _tmp0_;
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_merge_csv_reader_properties[MAIL_MERGE_CSV_READER_LINE_ENDING_PROPERTY]);
#line 405 "mail-merge-csv.c"
	}
}

gchar
mail_merge_csv_reader_get_field_separator (MailMergeCsvReader* self)
{
	gchar result;
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_val_if_fail (MAIL_MERGE_CSV_IS_READER (self), '\0');
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	result = self->priv->_field_separator;
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return result;
#line 419 "mail-merge-csv.c"
}

void
mail_merge_csv_reader_set_field_separator (MailMergeCsvReader* self,
                                           gchar value)
{
	gchar old_value;
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_if_fail (MAIL_MERGE_CSV_IS_READER (self));
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	old_value = mail_merge_csv_reader_get_field_separator (self);
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (old_value != value) {
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		self->priv->_field_separator = value;
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_merge_csv_reader_properties[MAIL_MERGE_CSV_READER_FIELD_SEPARATOR_PROPERTY]);
#line 437 "mail-merge-csv.c"
	}
}

static void
mail_merge_csv_reader_construct_data_free (gpointer _data)
{
	MailMergeCsvReaderNewData* _data_;
	_data_ = _data;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->input);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->cancellable);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->self);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_slice_free (MailMergeCsvReaderNewData, _data_);
#line 454 "mail-merge-csv.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return self ? g_object_ref (self) : NULL;
#line 462 "mail-merge-csv.c"
}

void
mail_merge_csv_reader_construct (GType object_type,
                                 GInputStream* input,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	MailMergeCsvReaderNewData* _data_;
	GInputStream* _tmp0_;
	GCancellable* _tmp1_;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (input, g_input_stream_get_type ()));
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_slice_new0 (MailMergeCsvReaderNewData);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_merge_csv_reader_construct_data_free);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->object_type = object_type;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_tmp0_ = _g_object_ref0 (input);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->input);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->input = _tmp0_;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->cancellable);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->cancellable = _tmp1_;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_construct_co (_data_);
#line 501 "mail-merge-csv.c"
}

MailMergeCsvReader*
mail_merge_csv_reader_construct_finish (GAsyncResult* _res_,
                                        GError** error)
{
	MailMergeCsvReader* result;
	MailMergeCsvReaderNewData* _data_;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (NULL == _data_) {
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return NULL;
#line 516 "mail-merge-csv.c"
	}
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	result = _data_->self;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self = NULL;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return result;
#line 524 "mail-merge-csv.c"
}

/**
     * Constructs a new CSV file reader.
     *
     * The reader is primed during construction, so the given stream
     * will be read from. As such, an IOError or other error may occur
     * during construction.
     *
     * If the given cancellable is not null, it will be used when
     * performing I/O operations on the given input stream.
     */
static void
mail_merge_csv_reader_new_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	MailMergeCsvReaderNewData* _data_;
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = _user_data_;
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_source_object_ = source_object;
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_res_ = _res_;
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_construct_co (_data_);
#line 551 "mail-merge-csv.c"
}

static gboolean
mail_merge_csv_reader_construct_co (MailMergeCsvReaderNewData* _data_)
{
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	switch (_data_->_state_) {
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 0:
#line 561 "mail-merge-csv.c"
		goto _state_0;
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 1:
#line 565 "mail-merge-csv.c"
		goto _state_1;
		default:
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_assert_not_reached ();
#line 570 "mail-merge-csv.c"
	}
	_state_0:
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self = (MailMergeCsvReader*) geary_base_object_construct (_data_->object_type);
#line 74 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp0_ = (GBufferedInputStream*) g_buffered_input_stream_new (_data_->input);
#line 74 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->self->priv->input);
#line 74 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self->priv->input = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, g_input_stream_get_type (), GInputStream);
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->cancellable);
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp1_ = _data_->_tmp2_;
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->_tmp1_ == NULL) {
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp3_ = g_cancellable_new ();
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp1_ = _data_->_tmp3_;
#line 593 "mail-merge-csv.c"
	}
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp4_ = _data_->_tmp1_;
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp1_ = NULL;
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->self->priv->cancellable);
#line 75 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self->priv->cancellable = _data_->_tmp4_;
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_state_ = 1;
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_char (_data_->self, mail_merge_csv_reader_new_ready, _data_);
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return FALSE;
#line 609 "mail-merge-csv.c"
	_state_1:
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_char_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_object_unref (_data_->_async_result);
#line 78 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return FALSE;
#line 623 "mail-merge-csv.c"
	}
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->_state_ != 0) {
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 635 "mail-merge-csv.c"
		}
	}
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_object_unref (_data_->_async_result);
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return FALSE;
#line 642 "mail-merge-csv.c"
}

void
mail_merge_csv_reader_new (GInputStream* input,
                           GCancellable* cancellable,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_construct (MAIL_MERGE_CSV_TYPE_READER, input, cancellable, _callback_, _user_data_);
#line 653 "mail-merge-csv.c"
}

MailMergeCsvReader*
mail_merge_csv_reader_new_finish (GAsyncResult* _res_,
                                  GError** error)
{
#line 71 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return mail_merge_csv_reader_construct_finish (_res_, error);
#line 662 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_record_data_free (gpointer _data)
{
	MailMergeCsvReaderReadRecordData* _data_;
	_data_ = _data;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->result = (_vala_array_free (_data_->result, _data_->result_length1, (GDestroyNotify) g_free), NULL);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_slice_free (MailMergeCsvReaderReadRecordData, _data_);
#line 676 "mail-merge-csv.c"
}

void
mail_merge_csv_reader_read_record (MailMergeCsvReader* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	MailMergeCsvReaderReadRecordData* _data_;
	MailMergeCsvReader* _tmp0_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_if_fail (MAIL_MERGE_CSV_IS_READER (self));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_slice_new0 (MailMergeCsvReaderReadRecordData);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_merge_csv_reader_read_record_data_free);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self = _tmp0_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_record_co (_data_);
#line 700 "mail-merge-csv.c"
}

gchar**
mail_merge_csv_reader_read_record_finish (MailMergeCsvReader* self,
                                          GAsyncResult* _res_,
                                          gint* result_length1,
                                          GError** error)
{
	gchar** result;
	MailMergeCsvReaderReadRecordData* _data_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (NULL == _data_) {
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return NULL;
#line 717 "mail-merge-csv.c"
	}
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	result = _data_->result;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	*result_length1 = _data_->result_length1;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->result = NULL;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return result;
#line 727 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_record_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	MailMergeCsvReaderReadRecordData* _data_;
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = _user_data_;
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_source_object_ = source_object;
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_res_ = _res_;
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_record_co (_data_);
#line 744 "mail-merge-csv.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 91 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if ((*length) == (*size)) {
#line 91 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 91 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 759 "mail-merge-csv.c"
	}
#line 91 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	(*array)[(*length)++] = value;
#line 91 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	(*array)[*length] = NULL;
#line 765 "mail-merge-csv.c"
}

static gboolean
mail_merge_csv_reader_read_record_co (MailMergeCsvReaderReadRecordData* _data_)
{
#line 81 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	switch (_data_->_state_) {
#line 81 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 0:
#line 775 "mail-merge-csv.c"
		goto _state_0;
#line 81 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 1:
#line 779 "mail-merge-csv.c"
		goto _state_1;
#line 81 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 2:
#line 783 "mail-merge-csv.c"
		goto _state_2;
#line 81 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 3:
#line 787 "mail-merge-csv.c"
		goto _state_3;
		default:
#line 81 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_assert_not_reached ();
#line 792 "mail-merge-csv.c"
	}
	_state_0:
#line 82 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->record = NULL;
#line 82 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->record_length1 = 0;
#line 82 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_record_size_ = _data_->record_length1;
#line 83 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp0_ = _data_->self->priv->input;
#line 83 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (!g_input_stream_is_closed (_data_->_tmp0_)) {
#line 84 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp1_ = g_new0 (gchar*, _data_->self->priv->last_record_length + 1);
#line 84 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->record = (_vala_array_free (_data_->record, _data_->record_length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->record = _data_->_tmp1_;
#line 84 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->record_length1 = _data_->self->priv->last_record_length;
#line 84 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_record_size_ = _data_->record_length1;
#line 85 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->next_field = 0;
#line 86 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		while (TRUE) {
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_state_ = 1;
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			mail_merge_csv_reader_read_field (_data_->self, mail_merge_csv_reader_read_record_ready, _data_);
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			return FALSE;
#line 825 "mail-merge-csv.c"
			_state_1:
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp2_ = mail_merge_csv_reader_read_field_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->field = _data_->_tmp2_;
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->record = (_vala_array_free (_data_->record, _data_->record_length1, (GDestroyNotify) g_free), NULL);
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				g_object_unref (_data_->_async_result);
#line 87 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				return FALSE;
#line 841 "mail-merge-csv.c"
			}
#line 88 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp3_ = _data_->record;
#line 88 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp3__length1 = _data_->record_length1;
#line 88 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if (_data_->next_field < _data_->_tmp3__length1) {
#line 89 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp4_ = _data_->record;
#line 89 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp4__length1 = _data_->record_length1;
#line 89 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp5_ = _data_->field;
#line 89 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp6_ = g_strdup (_data_->_tmp5_);
#line 89 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_g_free0 (_data_->_tmp4_[_data_->next_field]);
#line 89 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp4_[_data_->next_field] = _data_->_tmp6_;
#line 861 "mail-merge-csv.c"
			} else {
#line 91 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp7_ = _data_->field;
#line 91 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp8_ = g_strdup (_data_->_tmp7_);
#line 91 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_vala_array_add1 (&_data_->record, &_data_->record_length1, &_data_->_record_size_, _data_->_tmp8_);
#line 869 "mail-merge-csv.c"
			}
#line 93 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->next_field = _data_->next_field + 1;
#line 93 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp9_ = _data_->next_field;
#line 94 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp10_ = _data_->self->priv->_field_separator;
#line 94 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if (_data_->self->priv->next_char == ((gunichar) _data_->_tmp10_)) {
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_state_ = 2;
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				mail_merge_csv_reader_read_char (_data_->self, mail_merge_csv_reader_read_record_ready, _data_);
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				return FALSE;
#line 885 "mail-merge-csv.c"
				_state_2:
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				mail_merge_csv_reader_read_char_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_g_free0 (_data_->field);
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->record = (_vala_array_free (_data_->record, _data_->record_length1, (GDestroyNotify) g_free), NULL);
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					g_object_unref (_data_->_async_result);
#line 96 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					return FALSE;
#line 901 "mail-merge-csv.c"
				}
			} else {
#line 98 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_g_free0 (_data_->field);
#line 98 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				break;
#line 908 "mail-merge-csv.c"
			}
#line 86 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_g_free0 (_data_->field);
#line 912 "mail-merge-csv.c"
		}
#line 101 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp11_ = _data_->self->priv->input;
#line 101 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (!g_input_stream_is_closed (_data_->_tmp11_)) {
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_state_ = 3;
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			mail_merge_csv_reader_read_eol (_data_->self, mail_merge_csv_reader_read_record_ready, _data_);
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			return FALSE;
#line 924 "mail-merge-csv.c"
			_state_3:
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			mail_merge_csv_reader_read_eol_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->record = (_vala_array_free (_data_->record, _data_->record_length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				g_object_unref (_data_->_async_result);
#line 102 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				return FALSE;
#line 938 "mail-merge-csv.c"
			}
		}
	}
#line 105 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp12_ = _data_->record;
#line 105 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp12__length1 = _data_->record_length1;
#line 105 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self->priv->last_record_length = (guint) _data_->_tmp12__length1;
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp13_ = _data_->record;
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp13__length1 = _data_->record_length1;
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->result_length1 = _data_->_tmp13__length1;
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->result = _data_->_tmp13_;
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->_state_ != 0) {
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 964 "mail-merge-csv.c"
		}
	}
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_object_unref (_data_->_async_result);
#line 106 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return FALSE;
#line 971 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_field_data_free (gpointer _data)
{
	MailMergeCsvReaderReadFieldData* _data_;
	_data_ = _data;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_free0 (_data_->result);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_slice_free (MailMergeCsvReaderReadFieldData, _data_);
#line 985 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_field (MailMergeCsvReader* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	MailMergeCsvReaderReadFieldData* _data_;
	MailMergeCsvReader* _tmp0_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_if_fail (MAIL_MERGE_CSV_IS_READER (self));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_slice_new0 (MailMergeCsvReaderReadFieldData);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_merge_csv_reader_read_field_data_free);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self = _tmp0_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_field_co (_data_);
#line 1009 "mail-merge-csv.c"
}

static gchar*
mail_merge_csv_reader_read_field_finish (MailMergeCsvReader* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	gchar* result;
	MailMergeCsvReaderReadFieldData* _data_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (NULL == _data_) {
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return NULL;
#line 1025 "mail-merge-csv.c"
	}
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	result = _data_->result;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->result = NULL;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return result;
#line 1033 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_field_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	MailMergeCsvReaderReadFieldData* _data_;
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = _user_data_;
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_source_object_ = source_object;
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_res_ = _res_;
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_field_co (_data_);
#line 1050 "mail-merge-csv.c"
}

static gboolean
mail_merge_csv_reader_read_field_co (MailMergeCsvReaderReadFieldData* _data_)
{
#line 109 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	switch (_data_->_state_) {
#line 109 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 0:
#line 1060 "mail-merge-csv.c"
		goto _state_0;
#line 109 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 1:
#line 1064 "mail-merge-csv.c"
		goto _state_1;
#line 109 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 2:
#line 1068 "mail-merge-csv.c"
		goto _state_2;
#line 109 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 3:
#line 1072 "mail-merge-csv.c"
		goto _state_3;
		default:
#line 109 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_assert_not_reached ();
#line 1077 "mail-merge-csv.c"
	}
	_state_0:
#line 110 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->quoted = _data_->self->priv->next_char == ((gunichar) '"');
#line 111 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->quoted) {
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_state_ = 1;
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		mail_merge_csv_reader_read_char (_data_->self, mail_merge_csv_reader_read_field_ready, _data_);
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return FALSE;
#line 1090 "mail-merge-csv.c"
		_state_1:
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		mail_merge_csv_reader_read_char_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_object_unref (_data_->_async_result);
#line 113 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			return FALSE;
#line 1102 "mail-merge-csv.c"
		}
	}
#line 116 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp0_ = g_string_new ("");
#line 116 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->buf = _data_->_tmp0_;
#line 117 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	while (TRUE) {
#line 117 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp2_ = _data_->self->priv->input;
#line 117 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (!g_input_stream_is_closed (_data_->_tmp2_)) {
#line 118 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if (_data_->quoted) {
#line 118 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp3_ = TRUE;
#line 1119 "mail-merge-csv.c"
			} else {
#line 118 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp5_ = _data_->self->priv->_field_separator;
#line 118 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				if (_data_->self->priv->next_char != ((gunichar) _data_->_tmp5_)) {
#line 120 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp4_ = mail_merge_csv_reader_is_text_char (_data_->self->priv->next_char);
#line 1127 "mail-merge-csv.c"
				} else {
#line 119 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp4_ = FALSE;
#line 1131 "mail-merge-csv.c"
				}
#line 118 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp3_ = _data_->_tmp4_;
#line 1135 "mail-merge-csv.c"
			}
#line 118 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp1_ = _data_->_tmp3_;
#line 1139 "mail-merge-csv.c"
		} else {
#line 117 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp1_ = FALSE;
#line 1143 "mail-merge-csv.c"
		}
#line 117 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (!_data_->_tmp1_) {
#line 117 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			break;
#line 1149 "mail-merge-csv.c"
		}
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_state_ = 2;
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		mail_merge_csv_reader_read_char (_data_->self, mail_merge_csv_reader_read_field_ready, _data_);
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return FALSE;
#line 1157 "mail-merge-csv.c"
		_state_2:
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->c = mail_merge_csv_reader_read_char_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_g_string_free0 (_data_->buf);
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_object_unref (_data_->_async_result);
#line 121 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			return FALSE;
#line 1171 "mail-merge-csv.c"
		}
#line 122 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (_data_->quoted) {
#line 122 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp6_ = _data_->c == ((gunichar) '"');
#line 1177 "mail-merge-csv.c"
		} else {
#line 122 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp6_ = FALSE;
#line 1181 "mail-merge-csv.c"
		}
#line 122 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (_data_->_tmp6_) {
#line 123 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if (_data_->self->priv->next_char == ((gunichar) '"')) {
#line 124 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp7_ = _data_->buf;
#line 124 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				g_string_append_c (_data_->_tmp7_, '"');
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_state_ = 3;
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				mail_merge_csv_reader_read_char (_data_->self, mail_merge_csv_reader_read_field_ready, _data_);
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				return FALSE;
#line 1197 "mail-merge-csv.c"
				_state_3:
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				mail_merge_csv_reader_read_char_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_g_string_free0 (_data_->buf);
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					g_object_unref (_data_->_async_result);
#line 125 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					return FALSE;
#line 1211 "mail-merge-csv.c"
				}
			} else {
#line 127 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->quoted = FALSE;
#line 1216 "mail-merge-csv.c"
			}
		} else {
#line 130 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp8_ = _data_->buf;
#line 130 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_string_append_unichar (_data_->_tmp8_, _data_->c);
#line 1223 "mail-merge-csv.c"
		}
	}
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp9_ = _data_->buf;
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp10_ = _data_->_tmp9_->str;
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp11_ = g_strdup (_data_->_tmp10_);
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->result = _data_->_tmp11_;
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_string_free0 (_data_->buf);
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->_state_ != 0) {
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1244 "mail-merge-csv.c"
		}
	}
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_object_unref (_data_->_async_result);
#line 133 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return FALSE;
#line 1251 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_eol_data_free (gpointer _data)
{
	MailMergeCsvReaderReadEolData* _data_;
	_data_ = _data;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_slice_free (MailMergeCsvReaderReadEolData, _data_);
#line 1263 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_eol (MailMergeCsvReader* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	MailMergeCsvReaderReadEolData* _data_;
	MailMergeCsvReader* _tmp0_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_if_fail (MAIL_MERGE_CSV_IS_READER (self));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_slice_new0 (MailMergeCsvReaderReadEolData);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_merge_csv_reader_read_eol_data_free);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self = _tmp0_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_eol_co (_data_);
#line 1287 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_eol_finish (MailMergeCsvReader* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	MailMergeCsvReaderReadEolData* _data_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (NULL == _data_) {
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return;
#line 1302 "mail-merge-csv.c"
	}
}

static void
mail_merge_csv_reader_read_eol_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	MailMergeCsvReaderReadEolData* _data_;
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = _user_data_;
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_source_object_ = source_object;
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_res_ = _res_;
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_eol_co (_data_);
#line 1320 "mail-merge-csv.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 1337 "mail-merge-csv.c"
}

static gboolean
mail_merge_csv_reader_read_eol_co (MailMergeCsvReaderReadEolData* _data_)
{
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	switch (_data_->_state_) {
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 0:
#line 1347 "mail-merge-csv.c"
		goto _state_0;
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 1:
#line 1351 "mail-merge-csv.c"
		goto _state_1;
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 2:
#line 1355 "mail-merge-csv.c"
		goto _state_2;
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 3:
#line 1359 "mail-merge-csv.c"
		goto _state_3;
		default:
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_assert_not_reached ();
#line 1364 "mail-merge-csv.c"
	}
	_state_0:
#line 137 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp1_ = _data_->self->priv->_line_ending;
#line 137 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->_tmp1_ == NULL) {
#line 137 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp0_ = TRUE;
#line 1373 "mail-merge-csv.c"
	} else {
#line 137 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp2_ = _data_->self->priv->_line_ending;
#line 137 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp0_ = g_strcmp0 (_data_->_tmp2_, "") == 0;
#line 1379 "mail-merge-csv.c"
	}
#line 137 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->_tmp0_) {
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_state_ = 1;
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		mail_merge_csv_reader_read_char (_data_->self, mail_merge_csv_reader_read_eol_ready, _data_);
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return FALSE;
#line 1389 "mail-merge-csv.c"
		_state_1:
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->c = mail_merge_csv_reader_read_char_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_object_unref (_data_->_async_result);
#line 140 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			return FALSE;
#line 1401 "mail-merge-csv.c"
		}
#line 141 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (_data_->c == ((gunichar) '\n')) {
#line 142 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			mail_merge_csv_reader_set_line_ending (_data_->self, "\n");
#line 1407 "mail-merge-csv.c"
		} else {
#line 143 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if (_data_->c == ((gunichar) '\r')) {
#line 144 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				if (_data_->self->priv->next_char == ((gunichar) '\n')) {
#line 146 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_state_ = 2;
#line 146 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					mail_merge_csv_reader_read_char (_data_->self, mail_merge_csv_reader_read_eol_ready, _data_);
#line 146 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					return FALSE;
#line 1419 "mail-merge-csv.c"
					_state_2:
#line 146 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					mail_merge_csv_reader_read_char_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 146 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 146 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 146 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_object_unref (_data_->_async_result);
#line 146 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						return FALSE;
#line 1431 "mail-merge-csv.c"
					}
#line 147 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					mail_merge_csv_reader_set_line_ending (_data_->self, "\r\n");
#line 1435 "mail-merge-csv.c"
				} else {
#line 149 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					mail_merge_csv_reader_set_line_ending (_data_->self, "\r");
#line 1439 "mail-merge-csv.c"
				}
			} else {
#line 152 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp3_ = g_error_new (MAIL_MERGE_CSV_DATA_ERROR, MAIL_MERGE_CSV_DATA_ERROR_UNKNOWN_EOL, "Unable to determine end of line character 0x%02x", (guint) _data_->c);
#line 152 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_inner_error0_ = _data_->_tmp3_;
#line 152 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 152 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				g_object_unref (_data_->_async_result);
#line 152 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				return FALSE;
#line 1452 "mail-merge-csv.c"
			}
		}
	} else {
		{
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->i = 0;
#line 1459 "mail-merge-csv.c"
			{
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->_tmp4_ = TRUE;
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				while (TRUE) {
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					if (!_data_->_tmp4_) {
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_tmp5_ = _data_->i;
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->i = _data_->_tmp5_ + 1;
#line 1471 "mail-merge-csv.c"
					}
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp4_ = FALSE;
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp6_ = _data_->self->priv->_line_ending;
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp7_ = strlen (_data_->_tmp6_);
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp8_ = _data_->_tmp7_;
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					if (!(_data_->i < _data_->_tmp8_)) {
#line 159 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						break;
#line 1485 "mail-merge-csv.c"
					}
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_state_ = 3;
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					mail_merge_csv_reader_read_char (_data_->self, mail_merge_csv_reader_read_eol_ready, _data_);
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					return FALSE;
#line 1493 "mail-merge-csv.c"
					_state_3:
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp9_ = mail_merge_csv_reader_read_char_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_object_unref (_data_->_async_result);
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						return FALSE;
#line 1505 "mail-merge-csv.c"
					}
#line 160 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_vala1_c = _data_->_tmp9_;
#line 161 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp10_ = _data_->self->priv->_line_ending;
#line 161 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					if (((gunichar) string_get (_data_->_tmp10_, (glong) _data_->i)) != _data_->_vala1_c) {
#line 162 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_tmp11_ = g_error_new (MAIL_MERGE_CSV_DATA_ERROR, MAIL_MERGE_CSV_DATA_ERROR_EOL_NOT_FOUND, "Unexpected end of line character: 0x%02X", (guint) _data_->_vala1_c);
#line 162 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_inner_error0_ = _data_->_tmp11_;
#line 162 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 162 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_object_unref (_data_->_async_result);
#line 162 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						return FALSE;
#line 1523 "mail-merge-csv.c"
					}
				}
			}
		}
	}
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->_state_ != 0) {
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1537 "mail-merge-csv.c"
		}
	}
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_object_unref (_data_->_async_result);
#line 136 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return FALSE;
#line 1544 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_char_data_free (gpointer _data)
{
	MailMergeCsvReaderReadCharData* _data_;
	_data_ = _data;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_slice_free (MailMergeCsvReaderReadCharData, _data_);
#line 1556 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_char (MailMergeCsvReader* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	MailMergeCsvReaderReadCharData* _data_;
	MailMergeCsvReader* _tmp0_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_return_if_fail (MAIL_MERGE_CSV_IS_READER (self));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_slice_new0 (MailMergeCsvReaderReadCharData);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_merge_csv_reader_read_char_data_free);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->self = _tmp0_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_char_co (_data_);
#line 1580 "mail-merge-csv.c"
}

static gunichar
mail_merge_csv_reader_read_char_finish (MailMergeCsvReader* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	gunichar result;
	MailMergeCsvReaderReadCharData* _data_;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (NULL == _data_) {
#line 1594 "mail-merge-csv.c"
		gunichar _tmp0_ = 0U;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return _tmp0_;
#line 1598 "mail-merge-csv.c"
	}
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	result = _data_->result;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return result;
#line 1604 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_read_char_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	MailMergeCsvReaderReadCharData* _data_;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_ = _user_data_;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_source_object_ = source_object;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_res_ = _res_;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_read_char_co (_data_);
#line 1621 "mail-merge-csv.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1270 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1271 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1271 "glib-2.0.vapi"
	return result;
#line 1635 "mail-merge-csv.c"
}

static gboolean
mail_merge_csv_reader_read_char_co (MailMergeCsvReaderReadCharData* _data_)
{
#line 170 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	switch (_data_->_state_) {
#line 170 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 0:
#line 1645 "mail-merge-csv.c"
		goto _state_0;
#line 170 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 1:
#line 1649 "mail-merge-csv.c"
		goto _state_1;
#line 170 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 2:
#line 1653 "mail-merge-csv.c"
		goto _state_2;
#line 170 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case 3:
#line 1657 "mail-merge-csv.c"
		goto _state_3;
		default:
#line 170 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_assert_not_reached ();
#line 1662 "mail-merge-csv.c"
	}
	_state_0:
#line 171 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->c = _data_->self->priv->next_char;
#line 175 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->bytes_read = (gsize) 0;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp0_ = _data_->self->priv->input;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp1_ = _data_->self->priv->cancellable;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_tmp2_ = 0UL;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->_state_ = 1;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_input_stream_read_all_async (_data_->_tmp0_, _data_->buf, (gsize) 1, G_PRIORITY_DEFAULT, _data_->_tmp1_, mail_merge_csv_reader_read_char_ready, _data_);
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return FALSE;
#line 1681 "mail-merge-csv.c"
	_state_1:
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_input_stream_read_all_finish (_data_->_tmp0_, _data_->_res_, &_data_->_tmp2_, &_data_->_inner_error0_);
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->bytes_read = _data_->_tmp2_;
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_object_unref (_data_->_async_result);
#line 176 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return FALSE;
#line 1695 "mail-merge-csv.c"
	}
#line 179 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->bytes_read > ((gsize) 0)) {
#line 180 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp3_ = _data_->buf[0];
#line 180 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->next = _data_->_tmp3_;
#line 181 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (((gint) _data_->next) == 0x00) {
#line 182 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_tmp4_ = g_error_new_literal (MAIL_MERGE_CSV_DATA_ERROR, MAIL_MERGE_CSV_DATA_ERROR_NON_TEXT_DATA, "Read null byte");
#line 182 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->_inner_error0_ = _data_->_tmp4_;
#line 182 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 182 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_object_unref (_data_->_async_result);
#line 182 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			return FALSE;
#line 1715 "mail-merge-csv.c"
		}
#line 184 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (((gint) _data_->next) <= 0x7F) {
#line 185 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->self->priv->next_char = (gunichar) _data_->next;
#line 1721 "mail-merge-csv.c"
		} else {
#line 187 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->to_read = (guint) 0;
#line 188 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if ((_data_->next >> 5) == ((gint) MAIL_MERGE_CSV_READER_UTF8_DOUBLE)) {
#line 189 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->to_read = (guint) 1;
#line 1729 "mail-merge-csv.c"
			} else {
#line 190 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				if ((_data_->next >> 4) == ((gint) MAIL_MERGE_CSV_READER_UTF8_TRIPLE)) {
#line 191 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->to_read = (guint) 2;
#line 1735 "mail-merge-csv.c"
				} else {
#line 192 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					if ((_data_->next >> 3) == ((gint) MAIL_MERGE_CSV_READER_UTF8_QUADRUPLE)) {
#line 193 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->to_read = (guint) 3;
#line 1741 "mail-merge-csv.c"
					} else {
#line 195 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_tmp5_ = g_error_new_literal (MAIL_MERGE_CSV_DATA_ERROR, MAIL_MERGE_CSV_DATA_ERROR_NON_TEXT_DATA, "Invalid UTF-8 data");
#line 195 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_inner_error0_ = _data_->_tmp5_;
#line 195 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 195 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_object_unref (_data_->_async_result);
#line 195 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						return FALSE;
#line 1753 "mail-merge-csv.c"
					}
				}
			}
#line 199 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->utf[0] = _data_->next;
#line 200 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->utf[_data_->to_read + 1] = (guint8) 0x00;
#line 1761 "mail-merge-csv.c"
			{
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->i = 0;
#line 1765 "mail-merge-csv.c"
				{
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					_data_->_tmp6_ = TRUE;
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
					while (TRUE) {
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						if (!_data_->_tmp6_) {
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							_data_->_tmp7_ = _data_->i;
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							_data_->i = _data_->_tmp7_ + 1;
#line 1777 "mail-merge-csv.c"
						}
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_tmp6_ = FALSE;
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						if (!(((guint) _data_->i) < _data_->to_read)) {
#line 201 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							break;
#line 1785 "mail-merge-csv.c"
						}
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_tmp8_ = _data_->self->priv->input;
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_tmp9_ = _data_->self->priv->cancellable;
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_tmp10_ = 0UL;
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->_state_ = 2;
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_input_stream_read_all_async (_data_->_tmp8_, _data_->buf, (gsize) 1, G_PRIORITY_DEFAULT, _data_->_tmp9_, mail_merge_csv_reader_read_char_ready, _data_);
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						return FALSE;
#line 1799 "mail-merge-csv.c"
						_state_2:
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						g_input_stream_read_all_finish (_data_->_tmp8_, _data_->_res_, &_data_->_tmp10_, &_data_->_inner_error0_);
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						_data_->bytes_read = _data_->_tmp10_;
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							g_object_unref (_data_->_async_result);
#line 202 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							return FALSE;
#line 1813 "mail-merge-csv.c"
						}
#line 208 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						if (_data_->bytes_read == ((gsize) 1)) {
#line 208 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							_data_->_tmp12_ = _data_->buf[0];
#line 208 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							_data_->_tmp11_ = (_data_->_tmp12_ >> 6) == ((gint) MAIL_MERGE_CSV_READER_UTF8_TRAILER);
#line 1821 "mail-merge-csv.c"
						} else {
#line 208 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							_data_->_tmp11_ = FALSE;
#line 1825 "mail-merge-csv.c"
						}
#line 208 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
						if (_data_->_tmp11_) {
#line 209 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							_data_->_tmp13_ = _data_->buf[0];
#line 209 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							_data_->utf[_data_->i + 1] = _data_->_tmp13_;
#line 1833 "mail-merge-csv.c"
						} else {
#line 211 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							_data_->utf[_data_->i + 1] = (guint8) 0x00;
#line 212 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
							break;
#line 1839 "mail-merge-csv.c"
						}
					}
				}
			}
#line 216 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			_data_->self->priv->next_char = string_get_char ((const gchar*) _data_->utf, (glong) 0);
#line 217 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			if (!g_unichar_validate (_data_->self->priv->next_char)) {
#line 218 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
				_data_->self->priv->next_char = MAIL_MERGE_CSV_READER_UNICODE_REPLACEMENT_CHAR;
#line 1850 "mail-merge-csv.c"
			}
		}
	} else {
#line 222 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->self->priv->next_char = (gunichar) '\0';
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_tmp14_ = _data_->self->priv->input;
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		_data_->_state_ = 3;
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_input_stream_close_async (_data_->_tmp14_, G_PRIORITY_DEFAULT, NULL, mail_merge_csv_reader_read_char_ready, _data_);
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		return FALSE;
#line 1864 "mail-merge-csv.c"
		_state_3:
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_input_stream_close_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_object_unref (_data_->_async_result);
#line 223 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			return FALSE;
#line 1876 "mail-merge-csv.c"
		}
	}
#line 225 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_data_->result = _data_->c;
#line 225 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 225 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	if (_data_->_state_ != 0) {
#line 225 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 225 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1889 "mail-merge-csv.c"
		}
	}
#line 225 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_object_unref (_data_->_async_result);
#line 225 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	return FALSE;
#line 1896 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_class_init (MailMergeCsvReaderClass * klass,
                                  gpointer klass_data)
{
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	mail_merge_csv_reader_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_type_class_adjust_private_offset (klass, &MailMergeCsvReader_private_offset);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_mail_merge_csv_reader_get_property;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_mail_merge_csv_reader_set_property;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	G_OBJECT_CLASS (klass)->finalize = mail_merge_csv_reader_finalize;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_MERGE_CSV_READER_LINE_ENDING_PROPERTY, mail_merge_csv_reader_properties[MAIL_MERGE_CSV_READER_LINE_ENDING_PROPERTY] = g_param_spec_string ("line-ending", "line-ending", "line-ending", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_MERGE_CSV_READER_FIELD_SEPARATOR_PROPERTY, mail_merge_csv_reader_properties[MAIL_MERGE_CSV_READER_FIELD_SEPARATOR_PROPERTY] = g_param_spec_char ("field-separator", "field-separator", "field-separator", G_MININT8, G_MAXINT8, ',', G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1917 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_instance_init (MailMergeCsvReader * self,
                                     gpointer klass)
{
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	self->priv = mail_merge_csv_reader_get_instance_private (self);
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	self->priv->_line_ending = NULL;
#line 52 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	self->priv->_field_separator = ',';
#line 57 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	self->priv->next_char = (gunichar) '\0';
#line 58 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	self->priv->last_record_length = (guint) 0;
#line 1934 "mail-merge-csv.c"
}

static void
mail_merge_csv_reader_finalize (GObject * obj)
{
	MailMergeCsvReader * self;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_MERGE_CSV_TYPE_READER, MailMergeCsvReader);
#line 51 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_free0 (self->priv->_line_ending);
#line 54 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (self->priv->input);
#line 55 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	G_OBJECT_CLASS (mail_merge_csv_reader_parent_class)->finalize (obj);
#line 1951 "mail-merge-csv.c"
}

/**
 * A simple comma-separated value (CSV) reader.
 *
 * To use this class, simply construct an instance start calling
 * {@link read_record}.
 */
static GType
mail_merge_csv_reader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailMergeCsvReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_merge_csv_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailMergeCsvReader), 0, (GInstanceInitFunc) mail_merge_csv_reader_instance_init, NULL };
	GType mail_merge_csv_reader_type_id;
	mail_merge_csv_reader_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "MailMergeCsvReader", &g_define_type_info, 0);
	MailMergeCsvReader_private_offset = g_type_add_instance_private (mail_merge_csv_reader_type_id, sizeof (MailMergeCsvReaderPrivate));
	return mail_merge_csv_reader_type_id;
}

GType
mail_merge_csv_reader_get_type (void)
{
	static volatile gsize mail_merge_csv_reader_type_id__once = 0;
	if (g_once_init_enter (&mail_merge_csv_reader_type_id__once)) {
		GType mail_merge_csv_reader_type_id;
		mail_merge_csv_reader_type_id = mail_merge_csv_reader_get_type_once ();
		g_once_init_leave (&mail_merge_csv_reader_type_id__once, mail_merge_csv_reader_type_id);
	}
	return mail_merge_csv_reader_type_id__once;
}

static void
_vala_mail_merge_csv_reader_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	MailMergeCsvReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_MERGE_CSV_TYPE_READER, MailMergeCsvReader);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	switch (property_id) {
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case MAIL_MERGE_CSV_READER_LINE_ENDING_PROPERTY:
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_value_set_string (value, mail_merge_csv_reader_get_line_ending (self));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		break;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case MAIL_MERGE_CSV_READER_FIELD_SEPARATOR_PROPERTY:
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		g_value_set_schar (value, mail_merge_csv_reader_get_field_separator (self));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		break;
#line 2004 "mail-merge-csv.c"
		default:
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		break;
#line 2010 "mail-merge-csv.c"
	}
}

static void
_vala_mail_merge_csv_reader_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	MailMergeCsvReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_MERGE_CSV_TYPE_READER, MailMergeCsvReader);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
	switch (property_id) {
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case MAIL_MERGE_CSV_READER_LINE_ENDING_PROPERTY:
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		mail_merge_csv_reader_set_line_ending (self, g_value_get_string (value));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		break;
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		case MAIL_MERGE_CSV_READER_FIELD_SEPARATOR_PROPERTY:
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		mail_merge_csv_reader_set_field_separator (self, g_value_get_schar (value));
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		break;
#line 2036 "mail-merge-csv.c"
		default:
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/client/plugin/mail-merge/mail-merge-csv.vala"
		break;
#line 2042 "mail-merge-csv.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

