/* nonblocking-mutex.c generated by valac 0.56.14, the Vala compiler
 * generated from nonblocking-mutex.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "geary-engine.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

enum  {
	GEARY_NONBLOCKING_MUTEX_0_PROPERTY,
	GEARY_NONBLOCKING_MUTEX_NUM_PROPERTIES
};
static GParamSpec* geary_nonblocking_mutex_properties[GEARY_NONBLOCKING_MUTEX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearyNonblockingMutexExecuteLockedData GearyNonblockingMutexExecuteLockedData;
typedef struct _GearyNonblockingMutexClaimAsyncData GearyNonblockingMutexClaimAsyncData;

struct _GearyNonblockingMutexPrivate {
	GearyNonblockingSpinlock* spinlock;
	gboolean locked;
	gint next_token;
	gint locked_token;
};

struct _GearyNonblockingMutexExecuteLockedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyNonblockingMutex* self;
	GearyNonblockingMutexCriticalSection target;
	gpointer target_target;
	GCancellable* cancellable;
	gint token;
	GError* _inner_error1_;
	GError* err;
	GError* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_;
};

struct _GearyNonblockingMutexClaimAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyNonblockingMutex* self;
	GCancellable* cancellable;
	gint result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	GearyNonblockingSpinlock* _tmp3_;
	GError* _inner_error0_;
};

static gint GearyNonblockingMutex_private_offset;
static gpointer geary_nonblocking_mutex_parent_class = NULL;

static void geary_nonblocking_mutex_execute_locked_data_free (gpointer _data);
static gboolean geary_nonblocking_mutex_execute_locked_co (GearyNonblockingMutexExecuteLockedData* _data_);
static void geary_nonblocking_mutex_execute_locked_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void geary_nonblocking_mutex_claim_async_data_free (gpointer _data);
static gboolean geary_nonblocking_mutex_claim_async_co (GearyNonblockingMutexClaimAsyncData* _data_);
static void geary_nonblocking_mutex_claim_async_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void geary_nonblocking_mutex_finalize (GObject * obj);
static GType geary_nonblocking_mutex_get_type_once (void);

static inline gpointer
geary_nonblocking_mutex_get_instance_private (GearyNonblockingMutex* self)
{
	return G_STRUCT_MEMBER_P (self, GearyNonblockingMutex_private_offset);
}

/**
     * Returns true if the {@link Mutex} has been claimed by a task.
     */
gboolean
geary_nonblocking_mutex_is_locked (GearyNonblockingMutex* self)
{
	gboolean result;
#line 38 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_MUTEX (self), FALSE);
#line 39 "../src/engine/nonblocking/nonblocking-mutex.vala"
	result = self->priv->locked;
#line 39 "../src/engine/nonblocking/nonblocking-mutex.vala"
	return result;
#line 110 "nonblocking-mutex.c"
}

static void
geary_nonblocking_mutex_execute_locked_data_free (gpointer _data)
{
	GearyNonblockingMutexExecuteLockedData* _data_;
	_data_ = _data;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_slice_free (GearyNonblockingMutexExecuteLockedData, _data_);
#line 124 "nonblocking-mutex.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	return self ? g_object_ref (self) : NULL;
#line 132 "nonblocking-mutex.c"
}

void
geary_nonblocking_mutex_execute_locked (GearyNonblockingMutex* self,
                                        GearyNonblockingMutexCriticalSection target,
                                        gpointer target_target,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GearyNonblockingMutexExecuteLockedData* _data_;
	GearyNonblockingMutex* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_return_if_fail (GEARY_NONBLOCKING_IS_MUTEX (self));
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_ = g_slice_new0 (GearyNonblockingMutexExecuteLockedData);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_nonblocking_mutex_execute_locked_data_free);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->target = target;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->target_target = target_target;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	geary_nonblocking_mutex_execute_locked_co (_data_);
#line 172 "nonblocking-mutex.c"
}

void
geary_nonblocking_mutex_execute_locked_finish (GearyNonblockingMutex* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	GearyNonblockingMutexExecuteLockedData* _data_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
		return;
#line 187 "nonblocking-mutex.c"
	}
}

/**
     * Executes a critical section while protected by this mutex.
     *
     * This high-level method takes care of claiming, executing, then
     * releasing the mutex, without requiring the caller to manage any
     * this.
     *
     * @throws GLib.IOError.CANCELLED thrown if the caller's
     * cancellable is cancelled before execution is completed
     * @throws GLib.Error if an error occurred during execution of
     * //target//.
     */
static void
geary_nonblocking_mutex_execute_locked_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	GearyNonblockingMutexExecuteLockedData* _data_;
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_ = _user_data_;
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->_source_object_ = source_object;
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->_res_ = _res_;
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	geary_nonblocking_mutex_execute_locked_co (_data_);
#line 217 "nonblocking-mutex.c"
}

static gboolean
geary_nonblocking_mutex_execute_locked_co (GearyNonblockingMutexExecuteLockedData* _data_)
{
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
	switch (_data_->_state_) {
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
		case 0:
#line 227 "nonblocking-mutex.c"
		goto _state_0;
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
		case 1:
#line 231 "nonblocking-mutex.c"
		goto _state_1;
		default:
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
		g_assert_not_reached ();
#line 236 "nonblocking-mutex.c"
	}
	_state_0:
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->_state_ = 1;
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	geary_nonblocking_mutex_claim_async (_data_->self, _data_->cancellable, geary_nonblocking_mutex_execute_locked_ready, _data_);
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	return FALSE;
#line 245 "nonblocking-mutex.c"
	_state_1:
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->token = geary_nonblocking_mutex_claim_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
		g_object_unref (_data_->_async_result);
#line 57 "../src/engine/nonblocking/nonblocking-mutex.vala"
		return FALSE;
#line 257 "nonblocking-mutex.c"
	}
	{
#line 59 "../src/engine/nonblocking/nonblocking-mutex.vala"
		_data_->target (_data_->target_target, &_data_->_inner_error0_);
#line 59 "../src/engine/nonblocking/nonblocking-mutex.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 264 "nonblocking-mutex.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		{
#line 62 "../src/engine/nonblocking/nonblocking-mutex.vala"
			geary_nonblocking_mutex_release (_data_->self, &_data_->token, &_data_->_inner_error1_);
#line 62 "../src/engine/nonblocking/nonblocking-mutex.vala"
			if (G_UNLIKELY (_data_->_inner_error1_ != NULL)) {
#line 275 "nonblocking-mutex.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 61 "../src/engine/nonblocking/nonblocking-mutex.vala"
			_data_->err = _data_->_inner_error1_;
#line 61 "../src/engine/nonblocking/nonblocking-mutex.vala"
			_data_->_inner_error1_ = NULL;
#line 64 "../src/engine/nonblocking/nonblocking-mutex.vala"
			_data_->_tmp0_ = _data_->err;
#line 64 "../src/engine/nonblocking/nonblocking-mutex.vala"
			_data_->_tmp1_ = _data_->_tmp0_->message;
#line 64 "../src/engine/nonblocking/nonblocking-mutex.vala"
			g_debug ("nonblocking-mutex.vala:64: Mutex error releasing token: %s", _data_->_tmp1_);
#line 61 "../src/engine/nonblocking/nonblocking-mutex.vala"
			_g_error_free0 (_data_->err);
#line 294 "nonblocking-mutex.c"
		}
		__finally1:
#line 61 "../src/engine/nonblocking/nonblocking-mutex.vala"
		if (G_UNLIKELY (_data_->_inner_error1_ != NULL)) {
#line 61 "../src/engine/nonblocking/nonblocking-mutex.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error1_);
#line 61 "../src/engine/nonblocking/nonblocking-mutex.vala"
			g_object_unref (_data_->_async_result);
#line 61 "../src/engine/nonblocking/nonblocking-mutex.vala"
			return FALSE;
#line 305 "nonblocking-mutex.c"
		}
	}
#line 58 "../src/engine/nonblocking/nonblocking-mutex.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 58 "../src/engine/nonblocking/nonblocking-mutex.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 58 "../src/engine/nonblocking/nonblocking-mutex.vala"
		g_object_unref (_data_->_async_result);
#line 58 "../src/engine/nonblocking/nonblocking-mutex.vala"
		return FALSE;
#line 316 "nonblocking-mutex.c"
	}
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
	if (_data_->_state_ != 0) {
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 326 "nonblocking-mutex.c"
		}
	}
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_object_unref (_data_->_async_result);
#line 54 "../src/engine/nonblocking/nonblocking-mutex.vala"
	return FALSE;
#line 333 "nonblocking-mutex.c"
}

static void
geary_nonblocking_mutex_claim_async_data_free (gpointer _data)
{
	GearyNonblockingMutexClaimAsyncData* _data_;
	_data_ = _data;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_slice_free (GearyNonblockingMutexClaimAsyncData, _data_);
#line 347 "nonblocking-mutex.c"
}

void
geary_nonblocking_mutex_claim_async (GearyNonblockingMutex* self,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	GearyNonblockingMutexClaimAsyncData* _data_;
	GearyNonblockingMutex* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_return_if_fail (GEARY_NONBLOCKING_IS_MUTEX (self));
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_ = g_slice_new0 (GearyNonblockingMutexClaimAsyncData);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_nonblocking_mutex_claim_async_data_free);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	geary_nonblocking_mutex_claim_async_co (_data_);
#line 381 "nonblocking-mutex.c"
}

gint
geary_nonblocking_mutex_claim_finish (GearyNonblockingMutex* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	gint result;
	GearyNonblockingMutexClaimAsyncData* _data_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	if (NULL == _data_) {
#line 395 "nonblocking-mutex.c"
		gint _tmp0_ = 0;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
		return _tmp0_;
#line 399 "nonblocking-mutex.c"
	}
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	result = _data_->result;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	return result;
#line 405 "nonblocking-mutex.c"
}

/**
     * Locks the mutex for execution inside a critical section.
     *
     * If already claimed, this call will block asynchronously waiting
     * for the mutex to be released.
     *
     * @return A token which must be passed to {@link release} when
     * the critical section has completed executing.
     */
static void
geary_nonblocking_mutex_claim_async_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	GearyNonblockingMutexClaimAsyncData* _data_;
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_ = _user_data_;
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->_source_object_ = source_object;
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_data_->_res_ = _res_;
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
	geary_nonblocking_mutex_claim_async_co (_data_);
#line 431 "nonblocking-mutex.c"
}

static gboolean
geary_nonblocking_mutex_claim_async_co (GearyNonblockingMutexClaimAsyncData* _data_)
{
#line 78 "../src/engine/nonblocking/nonblocking-mutex.vala"
	switch (_data_->_state_) {
#line 78 "../src/engine/nonblocking/nonblocking-mutex.vala"
		case 0:
#line 441 "nonblocking-mutex.c"
		goto _state_0;
#line 78 "../src/engine/nonblocking/nonblocking-mutex.vala"
		case 1:
#line 445 "nonblocking-mutex.c"
		goto _state_1;
		default:
#line 78 "../src/engine/nonblocking/nonblocking-mutex.vala"
		g_assert_not_reached ();
#line 450 "nonblocking-mutex.c"
	}
	_state_0:
	{
#line 79 "../src/engine/nonblocking/nonblocking-mutex.vala"
		_data_->_tmp0_ = TRUE;
#line 79 "../src/engine/nonblocking/nonblocking-mutex.vala"
		while (TRUE) {
#line 79 "../src/engine/nonblocking/nonblocking-mutex.vala"
			if (!_data_->_tmp0_) {
#line 460 "nonblocking-mutex.c"
			}
#line 79 "../src/engine/nonblocking/nonblocking-mutex.vala"
			_data_->_tmp0_ = FALSE;
#line 80 "../src/engine/nonblocking/nonblocking-mutex.vala"
			if (!_data_->self->priv->locked) {
#line 81 "../src/engine/nonblocking/nonblocking-mutex.vala"
				_data_->self->priv->locked = TRUE;
#line 468 "nonblocking-mutex.c"
				{
#line 82 "../src/engine/nonblocking/nonblocking-mutex.vala"
					_data_->_tmp1_ = TRUE;
#line 82 "../src/engine/nonblocking/nonblocking-mutex.vala"
					while (TRUE) {
#line 82 "../src/engine/nonblocking/nonblocking-mutex.vala"
						if (!_data_->_tmp1_) {
#line 84 "../src/engine/nonblocking/nonblocking-mutex.vala"
							if (!(_data_->self->priv->locked_token == GEARY_NONBLOCKING_MUTEX_INVALID_TOKEN)) {
#line 84 "../src/engine/nonblocking/nonblocking-mutex.vala"
								break;
#line 480 "nonblocking-mutex.c"
							}
						}
#line 82 "../src/engine/nonblocking/nonblocking-mutex.vala"
						_data_->_tmp1_ = FALSE;
#line 83 "../src/engine/nonblocking/nonblocking-mutex.vala"
						_data_->_tmp2_ = _data_->self->priv->next_token;
#line 83 "../src/engine/nonblocking/nonblocking-mutex.vala"
						_data_->self->priv->next_token = _data_->_tmp2_ + 1;
#line 83 "../src/engine/nonblocking/nonblocking-mutex.vala"
						_data_->self->priv->locked_token = _data_->_tmp2_;
#line 491 "nonblocking-mutex.c"
					}
				}
#line 86 "../src/engine/nonblocking/nonblocking-mutex.vala"
				_data_->result = _data_->self->priv->locked_token;
#line 86 "../src/engine/nonblocking/nonblocking-mutex.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 86 "../src/engine/nonblocking/nonblocking-mutex.vala"
				if (_data_->_state_ != 0) {
#line 86 "../src/engine/nonblocking/nonblocking-mutex.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 86 "../src/engine/nonblocking/nonblocking-mutex.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 504 "nonblocking-mutex.c"
					}
				}
#line 86 "../src/engine/nonblocking/nonblocking-mutex.vala"
				g_object_unref (_data_->_async_result);
#line 86 "../src/engine/nonblocking/nonblocking-mutex.vala"
				return FALSE;
#line 511 "nonblocking-mutex.c"
			}
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
			_data_->_tmp3_ = _data_->self->priv->spinlock;
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
			_data_->_state_ = 1;
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
			geary_nonblocking_lock_wait_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->cancellable, geary_nonblocking_mutex_claim_async_ready, _data_);
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
			return FALSE;
#line 521 "nonblocking-mutex.c"
			_state_1:
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
			geary_nonblocking_lock_wait_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_res_, &_data_->_inner_error0_);
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
				g_object_unref (_data_->_async_result);
#line 89 "../src/engine/nonblocking/nonblocking-mutex.vala"
				return FALSE;
#line 533 "nonblocking-mutex.c"
			}
		}
	}
}

/**
     * Releases the lock at the end of executing a critical section.
     *
     * The token returned by {@link claim_async} must be supplied as a
     * parameter.  It will be modified by this call so it can't be
     * reused.
     *
     * Throws IOError.INVALID_ARGUMENT if the token was not the one
     * returned by claim_async.
     */
void
geary_nonblocking_mutex_release (GearyNonblockingMutex* self,
                                 gint* token,
                                 GError** error)
{
	gboolean _tmp0_ = FALSE;
	GearyNonblockingSpinlock* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 103 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_return_if_fail (GEARY_NONBLOCKING_IS_MUTEX (self));
#line 104 "../src/engine/nonblocking/nonblocking-mutex.vala"
	if ((*token) != self->priv->locked_token) {
#line 104 "../src/engine/nonblocking/nonblocking-mutex.vala"
		_tmp0_ = TRUE;
#line 563 "nonblocking-mutex.c"
	} else {
#line 104 "../src/engine/nonblocking/nonblocking-mutex.vala"
		_tmp0_ = (*token) == GEARY_NONBLOCKING_MUTEX_INVALID_TOKEN;
#line 567 "nonblocking-mutex.c"
	}
#line 104 "../src/engine/nonblocking/nonblocking-mutex.vala"
	if (_tmp0_) {
#line 571 "nonblocking-mutex.c"
		GError* _tmp1_;
#line 105 "../src/engine/nonblocking/nonblocking-mutex.vala"
		_tmp1_ = g_error_new (G_IO_ERROR, G_IO_ERROR_INVALID_ARGUMENT, "Token %d is not the lock token", *token);
#line 105 "../src/engine/nonblocking/nonblocking-mutex.vala"
		_inner_error0_ = _tmp1_;
#line 105 "../src/engine/nonblocking/nonblocking-mutex.vala"
		g_propagate_error (error, _inner_error0_);
#line 105 "../src/engine/nonblocking/nonblocking-mutex.vala"
		return;
#line 581 "nonblocking-mutex.c"
	}
#line 107 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self->priv->locked = FALSE;
#line 108 "../src/engine/nonblocking/nonblocking-mutex.vala"
	*token = GEARY_NONBLOCKING_MUTEX_INVALID_TOKEN;
#line 109 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self->priv->locked_token = GEARY_NONBLOCKING_MUTEX_INVALID_TOKEN;
#line 111 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_tmp2_ = self->priv->spinlock;
#line 111 "../src/engine/nonblocking/nonblocking-mutex.vala"
	geary_nonblocking_lock_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), &_inner_error0_);
#line 111 "../src/engine/nonblocking/nonblocking-mutex.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/engine/nonblocking/nonblocking-mutex.vala"
		g_propagate_error (error, _inner_error0_);
#line 111 "../src/engine/nonblocking/nonblocking-mutex.vala"
		return;
#line 599 "nonblocking-mutex.c"
	}
}

GearyNonblockingMutex*
geary_nonblocking_mutex_construct (GType object_type)
{
	GearyNonblockingMutex * self = NULL;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self = (GearyNonblockingMutex*) geary_base_object_construct (object_type);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	return self;
#line 611 "nonblocking-mutex.c"
}

GearyNonblockingMutex*
geary_nonblocking_mutex_new (void)
{
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	return geary_nonblocking_mutex_construct (GEARY_NONBLOCKING_TYPE_MUTEX);
#line 619 "nonblocking-mutex.c"
}

static void
geary_nonblocking_mutex_class_init (GearyNonblockingMutexClass * klass,
                                    gpointer klass_data)
{
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	geary_nonblocking_mutex_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	g_type_class_adjust_private_offset (klass, &GearyNonblockingMutex_private_offset);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_nonblocking_mutex_finalize;
#line 632 "nonblocking-mutex.c"
}

static void
geary_nonblocking_mutex_instance_init (GearyNonblockingMutex * self,
                                       gpointer klass)
{
	GearyNonblockingSpinlock* _tmp0_;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self->priv = geary_nonblocking_mutex_get_instance_private (self);
#line 29 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_tmp0_ = geary_nonblocking_spinlock_new (NULL);
#line 29 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self->priv->spinlock = _tmp0_;
#line 30 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self->priv->locked = FALSE;
#line 31 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self->priv->next_token = GEARY_NONBLOCKING_MUTEX_INVALID_TOKEN + 1;
#line 32 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self->priv->locked_token = GEARY_NONBLOCKING_MUTEX_INVALID_TOKEN;
#line 652 "nonblocking-mutex.c"
}

static void
geary_nonblocking_mutex_finalize (GObject * obj)
{
	GearyNonblockingMutex * self;
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_NONBLOCKING_TYPE_MUTEX, GearyNonblockingMutex);
#line 29 "../src/engine/nonblocking/nonblocking-mutex.vala"
	_g_object_unref0 (self->priv->spinlock);
#line 22 "../src/engine/nonblocking/nonblocking-mutex.vala"
	G_OBJECT_CLASS (geary_nonblocking_mutex_parent_class)->finalize (obj);
#line 665 "nonblocking-mutex.c"
}

/**
 * A primitive for creating critical sections inside of asynchronous tasks.
 *
 * Two methods can be used for executing code protected by this
 * mutex. The easiest is to create a {@link CriticalSection} delegate
 * and pass it to {@link execute_locked}. This will manage acquiring
 * the lock as needed. The lower-level method is to call {@link
 * claim_async}, execute the critical section, then ensure {@link
 * release} is always called afterwards.
 *
 * This class is ''not'' thread safe and should only be used by
 * asynchronous tasks.
 */
 G_GNUC_NO_INLINE static GType
geary_nonblocking_mutex_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyNonblockingMutexClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_nonblocking_mutex_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyNonblockingMutex), 0, (GInstanceInitFunc) geary_nonblocking_mutex_instance_init, NULL };
	GType geary_nonblocking_mutex_type_id;
	geary_nonblocking_mutex_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyNonblockingMutex", &g_define_type_info, 0);
	GearyNonblockingMutex_private_offset = g_type_add_instance_private (geary_nonblocking_mutex_type_id, sizeof (GearyNonblockingMutexPrivate));
	return geary_nonblocking_mutex_type_id;
}

GType
geary_nonblocking_mutex_get_type (void)
{
	static gsize geary_nonblocking_mutex_type_id__once = 0;
	if (g_once_init_enter (&geary_nonblocking_mutex_type_id__once)) {
		GType geary_nonblocking_mutex_type_id;
		geary_nonblocking_mutex_type_id = geary_nonblocking_mutex_get_type_once ();
		g_once_init_leave (&geary_nonblocking_mutex_type_id__once, geary_nonblocking_mutex_type_id);
	}
	return geary_nonblocking_mutex_type_id__once;
}

