/* util-js.c generated by valac 0.56.14, the Vala compiler
 * generated from util-js.vala, do not modify */

/*
 * Copyright © 2017-2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "geary-web-process.h"
#include <jsc/jsc.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <webkit2/webkit-web-extension.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_dict_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_dict_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _UtilJSParamSpecCallable UtilJSParamSpecCallable;

/**
     * Errors produced by functions in {@link Util.JS}.
     */
struct _UtilJSCallablePrivate {
	gchar* name;
	GVariant** args;
	gint args_length1;
	gint _args_size_;
};

struct _UtilJSParamSpecCallable {
	GParamSpec parent_instance;
};

static gint UtilJSCallable_private_offset;
static gpointer util_js_callable_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void util_js_callable_add_param (UtilJSCallable* self,
                                 GVariant* value);
static void _vala_array_add1 (GVariant** * array,
                       gint* length,
                       gint* size,
                       GVariant* value);
static void util_js_callable_finalize (UtilJSCallable * obj);
static GType util_js_callable_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

GQuark
util_js_error_quark (void)
{
	return g_quark_from_static_string ("util-js-error-quark");
}

static GType
util_js_error_get_type_once (void)
{
	static const GEnumValue values[] = {{UTIL_JS_ERROR_EXCEPTION, "UTIL_JS_ERROR_EXCEPTION", "exception"}, {UTIL_JS_ERROR_TYPE, "UTIL_JS_ERROR_TYPE", "type"}, {0, NULL, NULL}};
	GType util_js_error_type_id;
	util_js_error_type_id = g_enum_register_static ("UtilJSError", values);
	return util_js_error_type_id;
}

GType
util_js_error_get_type (void)
{
	static volatile gsize util_js_error_type_id__once = 0;
	if (g_once_init_enter (&util_js_error_type_id__once)) {
		GType util_js_error_type_id;
		util_js_error_type_id = util_js_error_get_type_once ();
		g_once_init_leave (&util_js_error_type_id__once, util_js_error_type_id);
	}
	return util_js_error_type_id__once;
}

/** Supported types of JSC values. */
/**
         * Determines the type of a JSC value.
         *
         * Returns the type of the given value, or {@link UNKNOWN} if
         * it could not be determined.
         */
UtilJSJscType
util_js_jsc_type_to_type (JSCValue* value)
{
	UtilJSJscType result;
#line 53 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), 0);
#line 54 "../src/client/util/util-js.vala"
	if (jsc_value_is_undefined (value)) {
#line 55 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_UNDEFINED;
#line 55 "../src/client/util/util-js.vala"
		return result;
#line 116 "util-js.c"
	}
#line 57 "../src/client/util/util-js.vala"
	if (jsc_value_is_null (value)) {
#line 58 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_NULL;
#line 58 "../src/client/util/util-js.vala"
		return result;
#line 124 "util-js.c"
	}
#line 60 "../src/client/util/util-js.vala"
	if (jsc_value_is_string (value)) {
#line 61 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_STRING;
#line 61 "../src/client/util/util-js.vala"
		return result;
#line 132 "util-js.c"
	}
#line 63 "../src/client/util/util-js.vala"
	if (jsc_value_is_number (value)) {
#line 64 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_NUMBER;
#line 64 "../src/client/util/util-js.vala"
		return result;
#line 140 "util-js.c"
	}
#line 66 "../src/client/util/util-js.vala"
	if (jsc_value_is_boolean (value)) {
#line 67 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_BOOLEAN;
#line 67 "../src/client/util/util-js.vala"
		return result;
#line 148 "util-js.c"
	}
#line 69 "../src/client/util/util-js.vala"
	if (jsc_value_is_array (value)) {
#line 70 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_ARRAY;
#line 70 "../src/client/util/util-js.vala"
		return result;
#line 156 "util-js.c"
	}
#line 72 "../src/client/util/util-js.vala"
	if (jsc_value_is_object (value)) {
#line 73 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_OBJECT;
#line 73 "../src/client/util/util-js.vala"
		return result;
#line 164 "util-js.c"
	}
#line 75 "../src/client/util/util-js.vala"
	if (jsc_value_is_function (value)) {
#line 76 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_FUNCTION;
#line 76 "../src/client/util/util-js.vala"
		return result;
#line 172 "util-js.c"
	}
#line 78 "../src/client/util/util-js.vala"
	if (jsc_value_is_constructor (value)) {
#line 79 "../src/client/util/util-js.vala"
		result = UTIL_JS_JSC_TYPE_CONSTRUCTOR;
#line 79 "../src/client/util/util-js.vala"
		return result;
#line 180 "util-js.c"
	}
#line 81 "../src/client/util/util-js.vala"
	result = UTIL_JS_JSC_TYPE_UNKNOWN;
#line 81 "../src/client/util/util-js.vala"
	return result;
#line 186 "util-js.c"
}

static GType
util_js_jsc_type_get_type_once (void)
{
	static const GEnumValue values[] = {{UTIL_JS_JSC_TYPE_UNKNOWN, "UTIL_JS_JSC_TYPE_UNKNOWN", "unknown"}, {UTIL_JS_JSC_TYPE_UNDEFINED, "UTIL_JS_JSC_TYPE_UNDEFINED", "undefined"}, {UTIL_JS_JSC_TYPE_NULL, "UTIL_JS_JSC_TYPE_NULL", "null"}, {UTIL_JS_JSC_TYPE_FUNCTION, "UTIL_JS_JSC_TYPE_FUNCTION", "function"}, {UTIL_JS_JSC_TYPE_STRING, "UTIL_JS_JSC_TYPE_STRING", "string"}, {UTIL_JS_JSC_TYPE_NUMBER, "UTIL_JS_JSC_TYPE_NUMBER", "number"}, {UTIL_JS_JSC_TYPE_BOOLEAN, "UTIL_JS_JSC_TYPE_BOOLEAN", "boolean"}, {UTIL_JS_JSC_TYPE_ARRAY, "UTIL_JS_JSC_TYPE_ARRAY", "array"}, {UTIL_JS_JSC_TYPE_CONSTRUCTOR, "UTIL_JS_JSC_TYPE_CONSTRUCTOR", "constructor"}, {UTIL_JS_JSC_TYPE_OBJECT, "UTIL_JS_JSC_TYPE_OBJECT", "object"}, {0, NULL, NULL}};
	GType util_js_jsc_type_type_id;
	util_js_jsc_type_type_id = g_enum_register_static ("UtilJSJscType", values);
	return util_js_jsc_type_type_id;
}

GType
util_js_jsc_type_get_type (void)
{
	static volatile gsize util_js_jsc_type_type_id__once = 0;
	if (g_once_init_enter (&util_js_jsc_type_type_id__once)) {
		GType util_js_jsc_type_type_id;
		util_js_jsc_type_type_id = util_js_jsc_type_get_type_once ();
		g_once_init_leave (&util_js_jsc_type_type_id__once, util_js_jsc_type_type_id);
	}
	return util_js_jsc_type_type_id__once;
}

/**
     * Returns a JSC Value as a bool.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Boolean`.
     */
gboolean
util_js_to_bool (JSCValue* value,
                 GError** error)
{
	gboolean boolean = FALSE;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 92 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), FALSE);
#line 94 "../src/client/util/util-js.vala"
	if (!jsc_value_is_boolean (value)) {
#line 229 "util-js.c"
		GError* _tmp0_;
#line 95 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Boolean object");
#line 95 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 95 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 237 "util-js.c"
			gboolean _tmp1_ = FALSE;
#line 95 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 95 "../src/client/util/util-js.vala"
			return _tmp1_;
#line 243 "util-js.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 95 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 95 "../src/client/util/util-js.vala"
			return _tmp2_;
#line 252 "util-js.c"
		}
	}
#line 97 "../src/client/util/util-js.vala"
	boolean = jsc_value_to_boolean (value);
#line 98 "../src/client/util/util-js.vala"
	_tmp3_ = jsc_value_get_context (value);
#line 98 "../src/client/util/util-js.vala"
	_tmp4_ = _tmp3_;
#line 98 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp4_, &_inner_error0_);
#line 98 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 267 "util-js.c"
			gboolean _tmp5_ = FALSE;
#line 98 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 98 "../src/client/util/util-js.vala"
			return _tmp5_;
#line 273 "util-js.c"
		} else {
			gboolean _tmp6_ = FALSE;
#line 98 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 98 "../src/client/util/util-js.vala"
			return _tmp6_;
#line 282 "util-js.c"
		}
	}
#line 99 "../src/client/util/util-js.vala"
	result = boolean;
#line 99 "../src/client/util/util-js.vala"
	return result;
#line 289 "util-js.c"
}

/**
     * Returns a JSC Value as a double.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gdouble
util_js_to_double (JSCValue* value,
                   GError** error)
{
	gdouble number = 0.0;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gdouble result;
#line 108 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), 0.0);
#line 110 "../src/client/util/util-js.vala"
	if (!jsc_value_is_number (value)) {
#line 311 "util-js.c"
		GError* _tmp0_;
#line 111 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Number object");
#line 111 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 111 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 319 "util-js.c"
			gdouble _tmp1_ = -1.0;
#line 111 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 111 "../src/client/util/util-js.vala"
			return _tmp1_;
#line 325 "util-js.c"
		} else {
			gdouble _tmp2_ = -1.0;
#line 111 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 111 "../src/client/util/util-js.vala"
			return _tmp2_;
#line 334 "util-js.c"
		}
	}
#line 114 "../src/client/util/util-js.vala"
	number = jsc_value_to_double (value);
#line 115 "../src/client/util/util-js.vala"
	_tmp3_ = jsc_value_get_context (value);
#line 115 "../src/client/util/util-js.vala"
	_tmp4_ = _tmp3_;
#line 115 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp4_, &_inner_error0_);
#line 115 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 349 "util-js.c"
			gdouble _tmp5_ = -1.0;
#line 115 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 115 "../src/client/util/util-js.vala"
			return _tmp5_;
#line 355 "util-js.c"
		} else {
			gdouble _tmp6_ = -1.0;
#line 115 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 115 "../src/client/util/util-js.vala"
			return _tmp6_;
#line 364 "util-js.c"
		}
	}
#line 116 "../src/client/util/util-js.vala"
	result = number;
#line 116 "../src/client/util/util-js.vala"
	return result;
#line 371 "util-js.c"
}

/**
     * Returns a JSC Value as an int32.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gint32
util_js_to_int32 (JSCValue* value,
                  GError** error)
{
	gint32 number = 0;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gint32 result;
#line 125 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), 0);
#line 127 "../src/client/util/util-js.vala"
	if (!jsc_value_is_number (value)) {
#line 393 "util-js.c"
		GError* _tmp0_;
#line 128 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Number object");
#line 128 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 128 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 401 "util-js.c"
			gint32 _tmp1_ = -1;
#line 128 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 128 "../src/client/util/util-js.vala"
			return _tmp1_;
#line 407 "util-js.c"
		} else {
			gint32 _tmp2_ = -1;
#line 128 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 128 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 128 "../src/client/util/util-js.vala"
			return _tmp2_;
#line 416 "util-js.c"
		}
	}
#line 131 "../src/client/util/util-js.vala"
	number = jsc_value_to_int32 (value);
#line 132 "../src/client/util/util-js.vala"
	_tmp3_ = jsc_value_get_context (value);
#line 132 "../src/client/util/util-js.vala"
	_tmp4_ = _tmp3_;
#line 132 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp4_, &_inner_error0_);
#line 132 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 132 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 431 "util-js.c"
			gint32 _tmp5_ = -1;
#line 132 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 132 "../src/client/util/util-js.vala"
			return _tmp5_;
#line 437 "util-js.c"
		} else {
			gint32 _tmp6_ = -1;
#line 132 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 132 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 132 "../src/client/util/util-js.vala"
			return _tmp6_;
#line 446 "util-js.c"
		}
	}
#line 133 "../src/client/util/util-js.vala"
	result = number;
#line 133 "../src/client/util/util-js.vala"
	return result;
#line 453 "util-js.c"
}

/**
     * Returns a JSC Value as a string.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `String`.
     */
gchar*
util_js_to_string (JSCValue* value,
                   GError** error)
{
	gchar* str = NULL;
	gchar* _tmp1_;
	JSCContext* _tmp2_;
	JSCContext* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 142 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), NULL);
#line 144 "../src/client/util/util-js.vala"
	if (!jsc_value_is_string (value)) {
#line 476 "util-js.c"
		GError* _tmp0_;
#line 145 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS String object");
#line 145 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 145 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 145 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 145 "../src/client/util/util-js.vala"
			return NULL;
#line 488 "util-js.c"
		} else {
#line 145 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 145 "../src/client/util/util-js.vala"
			return NULL;
#line 496 "util-js.c"
		}
	}
#line 148 "../src/client/util/util-js.vala"
	_tmp1_ = jsc_value_to_string (value);
#line 148 "../src/client/util/util-js.vala"
	str = _tmp1_;
#line 149 "../src/client/util/util-js.vala"
	_tmp2_ = jsc_value_get_context (value);
#line 149 "../src/client/util/util-js.vala"
	_tmp3_ = _tmp2_;
#line 149 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp3_, &_inner_error0_);
#line 149 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 149 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 149 "../src/client/util/util-js.vala"
			_g_free0 (str);
#line 149 "../src/client/util/util-js.vala"
			return NULL;
#line 519 "util-js.c"
		} else {
#line 149 "../src/client/util/util-js.vala"
			_g_free0 (str);
#line 149 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 149 "../src/client/util/util-js.vala"
			return NULL;
#line 529 "util-js.c"
		}
	}
#line 150 "../src/client/util/util-js.vala"
	result = str;
#line 150 "../src/client/util/util-js.vala"
	return result;
#line 536 "util-js.c"
}

/**
     * Returns the value of an object property.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not an object or does not contain the named property.
     */
inline JSCValue*
util_js_get_property (JSCValue* value,
                      const gchar* name,
                      GError** error)
{
	JSCValue* property = NULL;
	JSCValue* _tmp1_;
	JSCContext* _tmp2_;
	JSCContext* _tmp3_;
	GError* _inner_error0_ = NULL;
	JSCValue* result;
#line 159 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), NULL);
#line 159 "../src/client/util/util-js.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 162 "../src/client/util/util-js.vala"
	if (!jsc_value_is_object (value)) {
#line 562 "util-js.c"
		GError* _tmp0_;
#line 163 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Object");
#line 163 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 163 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 163 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 163 "../src/client/util/util-js.vala"
			return NULL;
#line 574 "util-js.c"
		} else {
#line 163 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 163 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 163 "../src/client/util/util-js.vala"
			return NULL;
#line 582 "util-js.c"
		}
	}
#line 166 "../src/client/util/util-js.vala"
	_tmp1_ = jsc_value_object_get_property (value, name);
#line 166 "../src/client/util/util-js.vala"
	property = _tmp1_;
#line 167 "../src/client/util/util-js.vala"
	_tmp2_ = jsc_value_get_context (value);
#line 167 "../src/client/util/util-js.vala"
	_tmp3_ = _tmp2_;
#line 167 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp3_, &_inner_error0_);
#line 167 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 167 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 167 "../src/client/util/util-js.vala"
			_g_object_unref0 (property);
#line 167 "../src/client/util/util-js.vala"
			return NULL;
#line 605 "util-js.c"
		} else {
#line 167 "../src/client/util/util-js.vala"
			_g_object_unref0 (property);
#line 167 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 167 "../src/client/util/util-js.vala"
			return NULL;
#line 615 "util-js.c"
		}
	}
#line 168 "../src/client/util/util-js.vala"
	result = property;
#line 168 "../src/client/util/util-js.vala"
	return result;
#line 622 "util-js.c"
}

/**
     * Checks an JS exception returned from a JSC call.
     *
     * If the given context has a current exception, it will cleared
     * and a {@link Util.JS.Error} will be thrown.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 179 "../src/client/util/util-js.vala"
	return self ? g_object_ref (self) : NULL;
#line 636 "util-js.c"
}

inline void
util_js_check_exception (JSCContext* context,
                         GError** error)
{
	JSCException* exception = NULL;
	JSCException* _tmp0_;
	JSCException* _tmp1_;
	JSCException* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 177 "../src/client/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (context, jsc_context_get_type ()));
#line 179 "../src/client/util/util-js.vala"
	_tmp0_ = jsc_context_get_exception (context);
#line 179 "../src/client/util/util-js.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 179 "../src/client/util/util-js.vala"
	exception = _tmp1_;
#line 180 "../src/client/util/util-js.vala"
	_tmp2_ = exception;
#line 180 "../src/client/util/util-js.vala"
	if (_tmp2_ != NULL) {
#line 660 "util-js.c"
		JSCException* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
#line 181 "../src/client/util/util-js.vala"
		jsc_context_clear_exception (context);
#line 182 "../src/client/util/util-js.vala"
		_tmp3_ = exception;
#line 182 "../src/client/util/util-js.vala"
		_tmp4_ = jsc_exception_to_string (_tmp3_);
#line 182 "../src/client/util/util-js.vala"
		_tmp5_ = _tmp4_;
#line 182 "../src/client/util/util-js.vala"
		_tmp6_ = g_error_new (UTIL_JS_ERROR, UTIL_JS_ERROR_EXCEPTION, "JS exception thrown: %s", _tmp5_);
#line 182 "../src/client/util/util-js.vala"
		_tmp7_ = _tmp6_;
#line 182 "../src/client/util/util-js.vala"
		_g_free0 (_tmp5_);
#line 182 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp7_;
#line 182 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 182 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 182 "../src/client/util/util-js.vala"
			_g_object_unref0 (exception);
#line 182 "../src/client/util/util-js.vala"
			return;
#line 690 "util-js.c"
		} else {
#line 182 "../src/client/util/util-js.vala"
			_g_object_unref0 (exception);
#line 182 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 182 "../src/client/util/util-js.vala"
			return;
#line 700 "util-js.c"
		}
	}
#line 177 "../src/client/util/util-js.vala"
	_g_object_unref0 (exception);
#line 705 "util-js.c"
}

/**
     * Converts a JS value to a GLib variant.
     *
     * Simple value objects (string, number, and Boolean values),
     * arrays of these, and objects with these types as properties are
     * supported. Arrays containing objects of the same type are
     * converted to arrays, otherwise they are converted to tuples,
     * empty arrays are converted to the unit tuple, and objects are
     * converted to vardict containing property names as keys and
     * values. Null and undefined values are returned as an empty
     * maybe variant type, since it is not possible to determine the
     * actual type.
     *
     * Throws a type error if the given value's type is not supported.
     */
inline GVariant*
util_js_value_to_variant (JSCValue* value,
                          GError** error)
{
	GVariant* variant = NULL;
	GError* _inner_error0_ = NULL;
	GVariant* result;
#line 203 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), NULL);
#line 205 "../src/client/util/util-js.vala"
	variant = NULL;
#line 206 "../src/client/util/util-js.vala"
	switch (util_js_jsc_type_to_type (value)) {
#line 206 "../src/client/util/util-js.vala"
		case UTIL_JS_JSC_TYPE_UNDEFINED:
#line 206 "../src/client/util/util-js.vala"
		case UTIL_JS_JSC_TYPE_NULL:
#line 740 "util-js.c"
		{
			const GVariantType* _tmp0_;
			GVariant* _tmp1_;
#line 209 "../src/client/util/util-js.vala"
			_tmp0_ = G_VARIANT_TYPE_VARIANT;
#line 209 "../src/client/util/util-js.vala"
			_tmp1_ = g_variant_new_maybe (_tmp0_, NULL);
#line 209 "../src/client/util/util-js.vala"
			g_variant_ref_sink (_tmp1_);
#line 209 "../src/client/util/util-js.vala"
			_g_variant_unref0 (variant);
#line 209 "../src/client/util/util-js.vala"
			variant = _tmp1_;
#line 210 "../src/client/util/util-js.vala"
			break;
#line 756 "util-js.c"
		}
#line 206 "../src/client/util/util-js.vala"
		case UTIL_JS_JSC_TYPE_STRING:
#line 760 "util-js.c"
		{
			gchar* _tmp2_;
			gchar* _tmp3_;
			GVariant* _tmp4_;
#line 213 "../src/client/util/util-js.vala"
			_tmp2_ = jsc_value_to_string (value);
#line 213 "../src/client/util/util-js.vala"
			_tmp3_ = _tmp2_;
#line 213 "../src/client/util/util-js.vala"
			_tmp4_ = g_variant_new_string (_tmp3_);
#line 213 "../src/client/util/util-js.vala"
			g_variant_ref_sink (_tmp4_);
#line 213 "../src/client/util/util-js.vala"
			_g_variant_unref0 (variant);
#line 213 "../src/client/util/util-js.vala"
			variant = _tmp4_;
#line 213 "../src/client/util/util-js.vala"
			_g_free0 (_tmp3_);
#line 214 "../src/client/util/util-js.vala"
			break;
#line 781 "util-js.c"
		}
#line 206 "../src/client/util/util-js.vala"
		case UTIL_JS_JSC_TYPE_NUMBER:
#line 785 "util-js.c"
		{
			GVariant* _tmp5_;
#line 217 "../src/client/util/util-js.vala"
			_tmp5_ = g_variant_new_double (jsc_value_to_double (value));
#line 217 "../src/client/util/util-js.vala"
			g_variant_ref_sink (_tmp5_);
#line 217 "../src/client/util/util-js.vala"
			_g_variant_unref0 (variant);
#line 217 "../src/client/util/util-js.vala"
			variant = _tmp5_;
#line 218 "../src/client/util/util-js.vala"
			break;
#line 798 "util-js.c"
		}
#line 206 "../src/client/util/util-js.vala"
		case UTIL_JS_JSC_TYPE_BOOLEAN:
#line 802 "util-js.c"
		{
			GVariant* _tmp6_;
#line 221 "../src/client/util/util-js.vala"
			_tmp6_ = g_variant_new_boolean (jsc_value_to_boolean (value));
#line 221 "../src/client/util/util-js.vala"
			g_variant_ref_sink (_tmp6_);
#line 221 "../src/client/util/util-js.vala"
			_g_variant_unref0 (variant);
#line 221 "../src/client/util/util-js.vala"
			variant = _tmp6_;
#line 222 "../src/client/util/util-js.vala"
			break;
#line 815 "util-js.c"
		}
#line 206 "../src/client/util/util-js.vala"
		case UTIL_JS_JSC_TYPE_ARRAY:
#line 819 "util-js.c"
		{
			gint len = 0;
			JSCValue* _tmp7_;
			JSCValue* _tmp8_;
			gint _tmp9_;
#line 225 "../src/client/util/util-js.vala"
			_tmp7_ = jsc_value_object_get_property (value, "length");
#line 225 "../src/client/util/util-js.vala"
			_tmp8_ = _tmp7_;
#line 225 "../src/client/util/util-js.vala"
			_tmp9_ = (gint) util_js_to_int32 (_tmp8_, &_inner_error0_);
#line 225 "../src/client/util/util-js.vala"
			_g_object_unref0 (_tmp8_);
#line 225 "../src/client/util/util-js.vala"
			len = _tmp9_;
#line 225 "../src/client/util/util-js.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/client/util/util-js.vala"
				if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 225 "../src/client/util/util-js.vala"
					g_propagate_error (error, _inner_error0_);
#line 225 "../src/client/util/util-js.vala"
					_g_variant_unref0 (variant);
#line 225 "../src/client/util/util-js.vala"
					return NULL;
#line 845 "util-js.c"
				} else {
#line 225 "../src/client/util/util-js.vala"
					_g_variant_unref0 (variant);
#line 225 "../src/client/util/util-js.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 225 "../src/client/util/util-js.vala"
					g_clear_error (&_inner_error0_);
#line 225 "../src/client/util/util-js.vala"
					return NULL;
#line 855 "util-js.c"
				}
			}
#line 226 "../src/client/util/util-js.vala"
			if (len == 0) {
#line 860 "util-js.c"
				GVariant** _tmp10_;
				GVariant** _tmp11_;
				gint _tmp11__length1;
				GVariant* _tmp12_;
#line 227 "../src/client/util/util-js.vala"
				_tmp10_ = g_new0 (GVariant*, 0 + 1);
#line 227 "../src/client/util/util-js.vala"
				_tmp11_ = _tmp10_;
#line 227 "../src/client/util/util-js.vala"
				_tmp11__length1 = 0;
#line 227 "../src/client/util/util-js.vala"
				_tmp12_ = g_variant_new_tuple (_tmp11_, 0);
#line 227 "../src/client/util/util-js.vala"
				g_variant_ref_sink (_tmp12_);
#line 227 "../src/client/util/util-js.vala"
				_g_variant_unref0 (variant);
#line 227 "../src/client/util/util-js.vala"
				variant = _tmp12_;
#line 227 "../src/client/util/util-js.vala"
				_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 881 "util-js.c"
			} else {
				JSCValue* element = NULL;
				JSCValue* _tmp13_;
				UtilJSJscType first_type = 0;
				JSCValue* _tmp14_;
				gboolean all_same_type = FALSE;
				GVariant** values = NULL;
				GVariant** _tmp15_;
				gint values_length1;
				gint _values_size_;
				GVariant* _tmp16_ = NULL;
				JSCValue* _tmp17_;
				GVariant* _tmp18_;
				GVariant** _tmp19_;
				gint _tmp19__length1;
				GVariant* _tmp20_;
#line 229 "../src/client/util/util-js.vala"
				_tmp13_ = jsc_value_object_get_property_at_index (value, (guint) 0);
#line 229 "../src/client/util/util-js.vala"
				element = _tmp13_;
#line 230 "../src/client/util/util-js.vala"
				_tmp14_ = element;
#line 230 "../src/client/util/util-js.vala"
				first_type = util_js_jsc_type_to_type (_tmp14_);
#line 231 "../src/client/util/util-js.vala"
				all_same_type = TRUE;
#line 232 "../src/client/util/util-js.vala"
				_tmp15_ = g_new0 (GVariant*, len + 1);
#line 232 "../src/client/util/util-js.vala"
				values = _tmp15_;
#line 232 "../src/client/util/util-js.vala"
				values_length1 = len;
#line 232 "../src/client/util/util-js.vala"
				_values_size_ = values_length1;
#line 233 "../src/client/util/util-js.vala"
				_tmp17_ = element;
#line 233 "../src/client/util/util-js.vala"
				_tmp18_ = util_js_value_to_variant (_tmp17_, &_inner_error0_);
#line 233 "../src/client/util/util-js.vala"
				_tmp16_ = _tmp18_;
#line 233 "../src/client/util/util-js.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 233 "../src/client/util/util-js.vala"
					if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 233 "../src/client/util/util-js.vala"
						g_propagate_error (error, _inner_error0_);
#line 233 "../src/client/util/util-js.vala"
						values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 233 "../src/client/util/util-js.vala"
						_g_object_unref0 (element);
#line 233 "../src/client/util/util-js.vala"
						_g_variant_unref0 (variant);
#line 233 "../src/client/util/util-js.vala"
						return NULL;
#line 936 "util-js.c"
					} else {
#line 233 "../src/client/util/util-js.vala"
						values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 233 "../src/client/util/util-js.vala"
						_g_object_unref0 (element);
#line 233 "../src/client/util/util-js.vala"
						_g_variant_unref0 (variant);
#line 233 "../src/client/util/util-js.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "../src/client/util/util-js.vala"
						g_clear_error (&_inner_error0_);
#line 233 "../src/client/util/util-js.vala"
						return NULL;
#line 950 "util-js.c"
					}
				}
#line 233 "../src/client/util/util-js.vala"
				_tmp19_ = values;
#line 233 "../src/client/util/util-js.vala"
				_tmp19__length1 = values_length1;
#line 233 "../src/client/util/util-js.vala"
				_tmp20_ = _tmp16_;
#line 233 "../src/client/util/util-js.vala"
				_tmp16_ = NULL;
#line 233 "../src/client/util/util-js.vala"
				_g_variant_unref0 (_tmp19_[0]);
#line 233 "../src/client/util/util-js.vala"
				_tmp19_[0] = _tmp20_;
#line 965 "util-js.c"
				{
					gint i = 0;
#line 234 "../src/client/util/util-js.vala"
					i = 1;
#line 970 "util-js.c"
					{
						gboolean _tmp21_ = FALSE;
#line 234 "../src/client/util/util-js.vala"
						_tmp21_ = TRUE;
#line 234 "../src/client/util/util-js.vala"
						while (TRUE) {
#line 977 "util-js.c"
							JSCValue* _tmp23_;
							GVariant* _tmp24_ = NULL;
							JSCValue* _tmp25_;
							GVariant* _tmp26_;
							GVariant** _tmp27_;
							gint _tmp27__length1;
							GVariant* _tmp28_;
							JSCValue* _tmp29_;
#line 234 "../src/client/util/util-js.vala"
							if (!_tmp21_) {
#line 988 "util-js.c"
								gint _tmp22_;
#line 234 "../src/client/util/util-js.vala"
								_tmp22_ = i;
#line 234 "../src/client/util/util-js.vala"
								i = _tmp22_ + 1;
#line 994 "util-js.c"
							}
#line 234 "../src/client/util/util-js.vala"
							_tmp21_ = FALSE;
#line 234 "../src/client/util/util-js.vala"
							if (!(i < len)) {
#line 234 "../src/client/util/util-js.vala"
								break;
#line 1002 "util-js.c"
							}
#line 235 "../src/client/util/util-js.vala"
							_tmp23_ = jsc_value_object_get_property_at_index (value, (guint) i);
#line 235 "../src/client/util/util-js.vala"
							_g_object_unref0 (element);
#line 235 "../src/client/util/util-js.vala"
							element = _tmp23_;
#line 236 "../src/client/util/util-js.vala"
							_tmp25_ = element;
#line 236 "../src/client/util/util-js.vala"
							_tmp26_ = util_js_value_to_variant (_tmp25_, &_inner_error0_);
#line 236 "../src/client/util/util-js.vala"
							_tmp24_ = _tmp26_;
#line 236 "../src/client/util/util-js.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 236 "../src/client/util/util-js.vala"
								if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 236 "../src/client/util/util-js.vala"
									g_propagate_error (error, _inner_error0_);
#line 236 "../src/client/util/util-js.vala"
									_g_variant_unref0 (_tmp16_);
#line 236 "../src/client/util/util-js.vala"
									values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 236 "../src/client/util/util-js.vala"
									_g_object_unref0 (element);
#line 236 "../src/client/util/util-js.vala"
									_g_variant_unref0 (variant);
#line 236 "../src/client/util/util-js.vala"
									return NULL;
#line 1032 "util-js.c"
								} else {
#line 236 "../src/client/util/util-js.vala"
									_g_variant_unref0 (_tmp16_);
#line 236 "../src/client/util/util-js.vala"
									values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 236 "../src/client/util/util-js.vala"
									_g_object_unref0 (element);
#line 236 "../src/client/util/util-js.vala"
									_g_variant_unref0 (variant);
#line 236 "../src/client/util/util-js.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 236 "../src/client/util/util-js.vala"
									g_clear_error (&_inner_error0_);
#line 236 "../src/client/util/util-js.vala"
									return NULL;
#line 1048 "util-js.c"
								}
							}
#line 236 "../src/client/util/util-js.vala"
							_tmp27_ = values;
#line 236 "../src/client/util/util-js.vala"
							_tmp27__length1 = values_length1;
#line 236 "../src/client/util/util-js.vala"
							_tmp28_ = _tmp24_;
#line 236 "../src/client/util/util-js.vala"
							_tmp24_ = NULL;
#line 236 "../src/client/util/util-js.vala"
							_g_variant_unref0 (_tmp27_[i]);
#line 236 "../src/client/util/util-js.vala"
							_tmp27_[i] = _tmp28_;
#line 237 "../src/client/util/util-js.vala"
							_tmp29_ = element;
#line 237 "../src/client/util/util-js.vala"
							all_same_type &= first_type == util_js_jsc_type_to_type (_tmp29_);
#line 234 "../src/client/util/util-js.vala"
							_g_variant_unref0 (_tmp24_);
#line 1069 "util-js.c"
						}
					}
				}
#line 239 "../src/client/util/util-js.vala"
				if (!all_same_type) {
#line 1075 "util-js.c"
					GVariant** _tmp30_;
					gint _tmp30__length1;
					GVariant* _tmp31_;
#line 240 "../src/client/util/util-js.vala"
					_tmp30_ = values;
#line 240 "../src/client/util/util-js.vala"
					_tmp30__length1 = values_length1;
#line 240 "../src/client/util/util-js.vala"
					_tmp31_ = g_variant_new_tuple (_tmp30_, _tmp30__length1);
#line 240 "../src/client/util/util-js.vala"
					g_variant_ref_sink (_tmp31_);
#line 240 "../src/client/util/util-js.vala"
					_g_variant_unref0 (variant);
#line 240 "../src/client/util/util-js.vala"
					variant = _tmp31_;
#line 1091 "util-js.c"
				} else {
					GVariant** _tmp32_;
					gint _tmp32__length1;
					GVariant* _tmp33_;
					const GVariantType* _tmp34_;
					GVariant** _tmp35_;
					gint _tmp35__length1;
					GVariant* _tmp36_;
#line 242 "../src/client/util/util-js.vala"
					_tmp32_ = values;
#line 242 "../src/client/util/util-js.vala"
					_tmp32__length1 = values_length1;
#line 242 "../src/client/util/util-js.vala"
					_tmp33_ = _tmp32_[0];
#line 242 "../src/client/util/util-js.vala"
					_tmp34_ = g_variant_get_type (_tmp33_);
#line 242 "../src/client/util/util-js.vala"
					_tmp35_ = values;
#line 242 "../src/client/util/util-js.vala"
					_tmp35__length1 = values_length1;
#line 242 "../src/client/util/util-js.vala"
					_tmp36_ = g_variant_new_array (_tmp34_, _tmp35_, _tmp35__length1);
#line 242 "../src/client/util/util-js.vala"
					g_variant_ref_sink (_tmp36_);
#line 242 "../src/client/util/util-js.vala"
					_g_variant_unref0 (variant);
#line 242 "../src/client/util/util-js.vala"
					variant = _tmp36_;
#line 1120 "util-js.c"
				}
#line 226 "../src/client/util/util-js.vala"
				_g_variant_unref0 (_tmp16_);
#line 226 "../src/client/util/util-js.vala"
				values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 226 "../src/client/util/util-js.vala"
				_g_object_unref0 (element);
#line 1128 "util-js.c"
			}
#line 247 "../src/client/util/util-js.vala"
			break;
#line 1132 "util-js.c"
		}
#line 206 "../src/client/util/util-js.vala"
		case UTIL_JS_JSC_TYPE_OBJECT:
#line 1136 "util-js.c"
		{
			GVariantDict* dict = NULL;
			GVariantDict* _tmp37_;
			gchar** names = NULL;
			gchar** _tmp38_;
			gchar** _tmp39_;
			gint names_length1;
			gint _names_size_;
			gchar** _tmp40_;
			gint _tmp40__length1;
			GVariantDict* _tmp51_;
			GVariant* _tmp52_;
#line 250 "../src/client/util/util-js.vala"
			_tmp37_ = g_variant_dict_new (NULL);
#line 250 "../src/client/util/util-js.vala"
			dict = _tmp37_;
#line 251 "../src/client/util/util-js.vala"
			_tmp39_ = _tmp38_ = jsc_value_object_enumerate_properties (value);
#line 251 "../src/client/util/util-js.vala"
			names = _tmp39_;
#line 251 "../src/client/util/util-js.vala"
			names_length1 = _vala_array_length (_tmp38_);
#line 251 "../src/client/util/util-js.vala"
			_names_size_ = names_length1;
#line 252 "../src/client/util/util-js.vala"
			_tmp40_ = names;
#line 252 "../src/client/util/util-js.vala"
			_tmp40__length1 = names_length1;
#line 252 "../src/client/util/util-js.vala"
			if (_tmp40_ != NULL) {
#line 1167 "util-js.c"
				gchar** _tmp41_;
				gint _tmp41__length1;
#line 253 "../src/client/util/util-js.vala"
				_tmp41_ = names;
#line 253 "../src/client/util/util-js.vala"
				_tmp41__length1 = names_length1;
#line 1174 "util-js.c"
				{
					gchar** name_collection = NULL;
					gint name_collection_length1 = 0;
					gint _name_collection_size_ = 0;
					gint name_it = 0;
#line 253 "../src/client/util/util-js.vala"
					name_collection = _tmp41_;
#line 253 "../src/client/util/util-js.vala"
					name_collection_length1 = _tmp41__length1;
#line 253 "../src/client/util/util-js.vala"
					for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 1186 "util-js.c"
						gchar* _tmp42_;
						gchar* name = NULL;
#line 253 "../src/client/util/util-js.vala"
						_tmp42_ = g_strdup (name_collection[name_it]);
#line 253 "../src/client/util/util-js.vala"
						name = _tmp42_;
#line 1193 "util-js.c"
						{
							GVariant* _tmp43_ = NULL;
							const gchar* _tmp44_;
							JSCValue* _tmp45_;
							JSCValue* _tmp46_;
							GVariant* _tmp47_;
							GVariant* _tmp48_;
							GVariantDict* _tmp49_;
							const gchar* _tmp50_;
#line 256 "../src/client/util/util-js.vala"
							_tmp44_ = name;
#line 256 "../src/client/util/util-js.vala"
							_tmp45_ = jsc_value_object_get_property (value, _tmp44_);
#line 256 "../src/client/util/util-js.vala"
							_tmp46_ = _tmp45_;
#line 256 "../src/client/util/util-js.vala"
							_tmp47_ = util_js_value_to_variant (_tmp46_, &_inner_error0_);
#line 256 "../src/client/util/util-js.vala"
							_tmp48_ = _tmp47_;
#line 256 "../src/client/util/util-js.vala"
							_g_object_unref0 (_tmp46_);
#line 256 "../src/client/util/util-js.vala"
							_tmp43_ = _tmp48_;
#line 256 "../src/client/util/util-js.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 256 "../src/client/util/util-js.vala"
								if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 256 "../src/client/util/util-js.vala"
									g_propagate_error (error, _inner_error0_);
#line 256 "../src/client/util/util-js.vala"
									_g_free0 (name);
#line 256 "../src/client/util/util-js.vala"
									names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 256 "../src/client/util/util-js.vala"
									_g_variant_dict_unref0 (dict);
#line 256 "../src/client/util/util-js.vala"
									_g_variant_unref0 (variant);
#line 256 "../src/client/util/util-js.vala"
									return NULL;
#line 1233 "util-js.c"
								} else {
#line 256 "../src/client/util/util-js.vala"
									_g_free0 (name);
#line 256 "../src/client/util/util-js.vala"
									names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 256 "../src/client/util/util-js.vala"
									_g_variant_dict_unref0 (dict);
#line 256 "../src/client/util/util-js.vala"
									_g_variant_unref0 (variant);
#line 256 "../src/client/util/util-js.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 256 "../src/client/util/util-js.vala"
									g_clear_error (&_inner_error0_);
#line 256 "../src/client/util/util-js.vala"
									return NULL;
#line 1249 "util-js.c"
								}
							}
#line 254 "../src/client/util/util-js.vala"
							_tmp49_ = dict;
#line 254 "../src/client/util/util-js.vala"
							_tmp50_ = name;
#line 254 "../src/client/util/util-js.vala"
							g_variant_dict_insert_value (_tmp49_, _tmp50_, _tmp43_);
#line 253 "../src/client/util/util-js.vala"
							_g_variant_unref0 (_tmp43_);
#line 253 "../src/client/util/util-js.vala"
							_g_free0 (name);
#line 1262 "util-js.c"
						}
					}
				}
			}
#line 260 "../src/client/util/util-js.vala"
			_tmp51_ = dict;
#line 260 "../src/client/util/util-js.vala"
			_tmp52_ = g_variant_dict_end (_tmp51_);
#line 260 "../src/client/util/util-js.vala"
			g_variant_ref_sink (_tmp52_);
#line 260 "../src/client/util/util-js.vala"
			_g_variant_unref0 (variant);
#line 260 "../src/client/util/util-js.vala"
			variant = _tmp52_;
#line 261 "../src/client/util/util-js.vala"
			names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 261 "../src/client/util/util-js.vala"
			_g_variant_dict_unref0 (dict);
#line 261 "../src/client/util/util-js.vala"
			break;
#line 1283 "util-js.c"
		}
		default:
		{
			gchar* _tmp53_;
			gchar* _tmp54_;
			GError* _tmp55_;
			GError* _tmp56_;
#line 264 "../src/client/util/util-js.vala"
			_tmp53_ = jsc_value_to_string (value);
#line 264 "../src/client/util/util-js.vala"
			_tmp54_ = _tmp53_;
#line 264 "../src/client/util/util-js.vala"
			_tmp55_ = g_error_new (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Unsupported JS type: %s", _tmp54_);
#line 264 "../src/client/util/util-js.vala"
			_tmp56_ = _tmp55_;
#line 264 "../src/client/util/util-js.vala"
			_g_free0 (_tmp54_);
#line 264 "../src/client/util/util-js.vala"
			_inner_error0_ = _tmp56_;
#line 264 "../src/client/util/util-js.vala"
			if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 264 "../src/client/util/util-js.vala"
				g_propagate_error (error, _inner_error0_);
#line 264 "../src/client/util/util-js.vala"
				_g_variant_unref0 (variant);
#line 264 "../src/client/util/util-js.vala"
				return NULL;
#line 1311 "util-js.c"
			} else {
#line 264 "../src/client/util/util-js.vala"
				_g_variant_unref0 (variant);
#line 264 "../src/client/util/util-js.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 264 "../src/client/util/util-js.vala"
				g_clear_error (&_inner_error0_);
#line 264 "../src/client/util/util-js.vala"
				return NULL;
#line 1321 "util-js.c"
			}
		}
	}
#line 266 "../src/client/util/util-js.vala"
	result = variant;
#line 266 "../src/client/util/util-js.vala"
	return result;
#line 1329 "util-js.c"
}

/**
     * Converts a GLib variant to a JS value.
     *
     * Simple value objects (string, number, and Boolean values),
     * arrays and tuples of these, and dictionaries with string keys
     * are supported. Tuples and arrays are converted to JS arrays,
     * and dictionaries or tuples containing dictionary entries are
     * converted to JS objects.
     *
     * Throws a type error if the given variant's type is not supported.
     */
static void
_g_object_unref0_ (gpointer var)
{
#line 349 "../src/client/util/util-js.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1348 "util-js.c"
}

inline JSCValue*
util_js_variant_to_value (JSCContext* context,
                          GVariant* variant,
                          GError** error)
{
	JSCValue* value = NULL;
	GVariantClass type = 0;
	JSCValue* _tmp68_;
	GError* _inner_error0_ = NULL;
	JSCValue* result;
#line 280 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (context, jsc_context_get_type ()), NULL);
#line 280 "../src/client/util/util-js.vala"
	g_return_val_if_fail (variant != NULL, NULL);
#line 283 "../src/client/util/util-js.vala"
	value = NULL;
#line 284 "../src/client/util/util-js.vala"
	type = g_variant_classify (variant);
#line 285 "../src/client/util/util-js.vala"
	if (type == G_VARIANT_CLASS_MAYBE) {
#line 1371 "util-js.c"
		GVariant* maybe = NULL;
		GVariant* _tmp0_;
		GVariant* _tmp1_;
#line 286 "../src/client/util/util-js.vala"
		_tmp0_ = g_variant_get_maybe (variant);
#line 286 "../src/client/util/util-js.vala"
		maybe = _tmp0_;
#line 287 "../src/client/util/util-js.vala"
		_tmp1_ = maybe;
#line 287 "../src/client/util/util-js.vala"
		if (_tmp1_ != NULL) {
#line 1383 "util-js.c"
			JSCValue* _tmp2_ = NULL;
			GVariant* _tmp3_;
			JSCValue* _tmp4_;
			JSCValue* _tmp5_;
#line 288 "../src/client/util/util-js.vala"
			_tmp3_ = maybe;
#line 288 "../src/client/util/util-js.vala"
			_tmp4_ = util_js_variant_to_value (context, _tmp3_, &_inner_error0_);
#line 288 "../src/client/util/util-js.vala"
			_tmp2_ = _tmp4_;
#line 288 "../src/client/util/util-js.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../src/client/util/util-js.vala"
				if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 288 "../src/client/util/util-js.vala"
					g_propagate_error (error, _inner_error0_);
#line 288 "../src/client/util/util-js.vala"
					_g_variant_unref0 (maybe);
#line 288 "../src/client/util/util-js.vala"
					_g_object_unref0 (value);
#line 288 "../src/client/util/util-js.vala"
					return NULL;
#line 1406 "util-js.c"
				} else {
#line 288 "../src/client/util/util-js.vala"
					_g_variant_unref0 (maybe);
#line 288 "../src/client/util/util-js.vala"
					_g_object_unref0 (value);
#line 288 "../src/client/util/util-js.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 288 "../src/client/util/util-js.vala"
					g_clear_error (&_inner_error0_);
#line 288 "../src/client/util/util-js.vala"
					return NULL;
#line 1418 "util-js.c"
				}
			}
#line 288 "../src/client/util/util-js.vala"
			_tmp5_ = _tmp2_;
#line 288 "../src/client/util/util-js.vala"
			_tmp2_ = NULL;
#line 288 "../src/client/util/util-js.vala"
			_g_object_unref0 (value);
#line 288 "../src/client/util/util-js.vala"
			value = _tmp5_;
#line 287 "../src/client/util/util-js.vala"
			_g_object_unref0 (_tmp2_);
#line 1431 "util-js.c"
		} else {
			JSCValue* _tmp6_;
#line 290 "../src/client/util/util-js.vala"
			_tmp6_ = jsc_value_new_null (context);
#line 290 "../src/client/util/util-js.vala"
			_g_object_unref0 (value);
#line 290 "../src/client/util/util-js.vala"
			value = _tmp6_;
#line 1440 "util-js.c"
		}
#line 285 "../src/client/util/util-js.vala"
		_g_variant_unref0 (maybe);
#line 1444 "util-js.c"
	} else {
#line 292 "../src/client/util/util-js.vala"
		if (type == G_VARIANT_CLASS_VARIANT) {
#line 1448 "util-js.c"
			JSCValue* _tmp7_ = NULL;
			GVariant* _tmp8_;
			GVariant* _tmp9_;
			JSCValue* _tmp10_;
			JSCValue* _tmp11_;
			JSCValue* _tmp12_;
#line 293 "../src/client/util/util-js.vala"
			_tmp8_ = g_variant_get_variant (variant);
#line 293 "../src/client/util/util-js.vala"
			_tmp9_ = _tmp8_;
#line 293 "../src/client/util/util-js.vala"
			_tmp10_ = util_js_variant_to_value (context, _tmp9_, &_inner_error0_);
#line 293 "../src/client/util/util-js.vala"
			_tmp11_ = _tmp10_;
#line 293 "../src/client/util/util-js.vala"
			_g_variant_unref0 (_tmp9_);
#line 293 "../src/client/util/util-js.vala"
			_tmp7_ = _tmp11_;
#line 293 "../src/client/util/util-js.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 293 "../src/client/util/util-js.vala"
				if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 293 "../src/client/util/util-js.vala"
					g_propagate_error (error, _inner_error0_);
#line 293 "../src/client/util/util-js.vala"
					_g_object_unref0 (value);
#line 293 "../src/client/util/util-js.vala"
					return NULL;
#line 1477 "util-js.c"
				} else {
#line 293 "../src/client/util/util-js.vala"
					_g_object_unref0 (value);
#line 293 "../src/client/util/util-js.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 293 "../src/client/util/util-js.vala"
					g_clear_error (&_inner_error0_);
#line 293 "../src/client/util/util-js.vala"
					return NULL;
#line 1487 "util-js.c"
				}
			}
#line 293 "../src/client/util/util-js.vala"
			_tmp12_ = _tmp7_;
#line 293 "../src/client/util/util-js.vala"
			_tmp7_ = NULL;
#line 293 "../src/client/util/util-js.vala"
			_g_object_unref0 (value);
#line 293 "../src/client/util/util-js.vala"
			value = _tmp12_;
#line 292 "../src/client/util/util-js.vala"
			_g_object_unref0 (_tmp7_);
#line 1500 "util-js.c"
		} else {
#line 294 "../src/client/util/util-js.vala"
			if (type == G_VARIANT_CLASS_STRING) {
#line 1504 "util-js.c"
				const gchar* _tmp13_;
				JSCValue* _tmp14_;
#line 295 "../src/client/util/util-js.vala"
				_tmp13_ = g_variant_get_string (variant, NULL);
#line 295 "../src/client/util/util-js.vala"
				_tmp14_ = jsc_value_new_string (context, _tmp13_);
#line 295 "../src/client/util/util-js.vala"
				_g_object_unref0 (value);
#line 295 "../src/client/util/util-js.vala"
				value = _tmp14_;
#line 1515 "util-js.c"
			} else {
#line 296 "../src/client/util/util-js.vala"
				if (type == G_VARIANT_CLASS_BOOLEAN) {
#line 1519 "util-js.c"
					JSCValue* _tmp15_;
#line 297 "../src/client/util/util-js.vala"
					_tmp15_ = jsc_value_new_boolean (context, g_variant_get_boolean (variant));
#line 297 "../src/client/util/util-js.vala"
					_g_object_unref0 (value);
#line 297 "../src/client/util/util-js.vala"
					value = _tmp15_;
#line 1527 "util-js.c"
				} else {
#line 298 "../src/client/util/util-js.vala"
					if (type == G_VARIANT_CLASS_DOUBLE) {
#line 1531 "util-js.c"
						JSCValue* _tmp16_;
#line 299 "../src/client/util/util-js.vala"
						_tmp16_ = jsc_value_new_number (context, g_variant_get_double (variant));
#line 299 "../src/client/util/util-js.vala"
						_g_object_unref0 (value);
#line 299 "../src/client/util/util-js.vala"
						value = _tmp16_;
#line 1539 "util-js.c"
					} else {
#line 300 "../src/client/util/util-js.vala"
						if (type == G_VARIANT_CLASS_INT64) {
#line 1543 "util-js.c"
							JSCValue* _tmp17_;
#line 301 "../src/client/util/util-js.vala"
							_tmp17_ = jsc_value_new_number (context, (gdouble) g_variant_get_int64 (variant));
#line 301 "../src/client/util/util-js.vala"
							_g_object_unref0 (value);
#line 301 "../src/client/util/util-js.vala"
							value = _tmp17_;
#line 1551 "util-js.c"
						} else {
#line 302 "../src/client/util/util-js.vala"
							if (type == G_VARIANT_CLASS_INT32) {
#line 1555 "util-js.c"
								JSCValue* _tmp18_;
#line 303 "../src/client/util/util-js.vala"
								_tmp18_ = jsc_value_new_number (context, (gdouble) g_variant_get_int32 (variant));
#line 303 "../src/client/util/util-js.vala"
								_g_object_unref0 (value);
#line 303 "../src/client/util/util-js.vala"
								value = _tmp18_;
#line 1563 "util-js.c"
							} else {
#line 304 "../src/client/util/util-js.vala"
								if (type == G_VARIANT_CLASS_INT16) {
#line 1567 "util-js.c"
									JSCValue* _tmp19_;
#line 305 "../src/client/util/util-js.vala"
									_tmp19_ = jsc_value_new_number (context, (gdouble) g_variant_get_int16 (variant));
#line 305 "../src/client/util/util-js.vala"
									_g_object_unref0 (value);
#line 305 "../src/client/util/util-js.vala"
									value = _tmp19_;
#line 1575 "util-js.c"
								} else {
#line 306 "../src/client/util/util-js.vala"
									if (type == G_VARIANT_CLASS_UINT64) {
#line 1579 "util-js.c"
										JSCValue* _tmp20_;
#line 307 "../src/client/util/util-js.vala"
										_tmp20_ = jsc_value_new_number (context, (gdouble) g_variant_get_uint64 (variant));
#line 307 "../src/client/util/util-js.vala"
										_g_object_unref0 (value);
#line 307 "../src/client/util/util-js.vala"
										value = _tmp20_;
#line 1587 "util-js.c"
									} else {
#line 308 "../src/client/util/util-js.vala"
										if (type == G_VARIANT_CLASS_UINT32) {
#line 1591 "util-js.c"
											JSCValue* _tmp21_;
#line 309 "../src/client/util/util-js.vala"
											_tmp21_ = jsc_value_new_number (context, (gdouble) g_variant_get_uint32 (variant));
#line 309 "../src/client/util/util-js.vala"
											_g_object_unref0 (value);
#line 309 "../src/client/util/util-js.vala"
											value = _tmp21_;
#line 1599 "util-js.c"
										} else {
#line 310 "../src/client/util/util-js.vala"
											if (type == G_VARIANT_CLASS_UINT16) {
#line 1603 "util-js.c"
												JSCValue* _tmp22_;
#line 311 "../src/client/util/util-js.vala"
												_tmp22_ = jsc_value_new_number (context, (gdouble) g_variant_get_uint16 (variant));
#line 311 "../src/client/util/util-js.vala"
												_g_object_unref0 (value);
#line 311 "../src/client/util/util-js.vala"
												value = _tmp22_;
#line 1611 "util-js.c"
											} else {
#line 312 "../src/client/util/util-js.vala"
												if (type == G_VARIANT_CLASS_BYTE) {
#line 1615 "util-js.c"
													JSCValue* _tmp23_;
#line 313 "../src/client/util/util-js.vala"
													_tmp23_ = jsc_value_new_number (context, (gdouble) g_variant_get_byte (variant));
#line 313 "../src/client/util/util-js.vala"
													_g_object_unref0 (value);
#line 313 "../src/client/util/util-js.vala"
													value = _tmp23_;
#line 1623 "util-js.c"
												} else {
													gboolean _tmp24_ = FALSE;
#line 314 "../src/client/util/util-js.vala"
													if (type == G_VARIANT_CLASS_ARRAY) {
#line 314 "../src/client/util/util-js.vala"
														_tmp24_ = TRUE;
#line 1630 "util-js.c"
													} else {
#line 315 "../src/client/util/util-js.vala"
														_tmp24_ = type == G_VARIANT_CLASS_TUPLE;
#line 1634 "util-js.c"
													}
#line 314 "../src/client/util/util-js.vala"
													if (_tmp24_) {
#line 1638 "util-js.c"
														gsize len = 0UL;
#line 316 "../src/client/util/util-js.vala"
														len = g_variant_n_children (variant);
#line 317 "../src/client/util/util-js.vala"
														if (len == ((gsize) 0)) {
#line 1644 "util-js.c"
															gboolean _tmp25_ = FALSE;
#line 318 "../src/client/util/util-js.vala"
															if (type == G_VARIANT_CLASS_ARRAY) {
#line 318 "../src/client/util/util-js.vala"
																_tmp25_ = TRUE;
#line 1650 "util-js.c"
															} else {
#line 319 "../src/client/util/util-js.vala"
																_tmp25_ = type == G_VARIANT_CLASS_TUPLE;
#line 1654 "util-js.c"
															}
#line 318 "../src/client/util/util-js.vala"
															if (_tmp25_) {
#line 1658 "util-js.c"
																JSCValue* _tmp26_;
#line 320 "../src/client/util/util-js.vala"
																_tmp26_ = jsc_value_new_array_from_garray (context, NULL);
#line 320 "../src/client/util/util-js.vala"
																_g_object_unref0 (value);
#line 320 "../src/client/util/util-js.vala"
																value = _tmp26_;
#line 1666 "util-js.c"
															} else {
																JSCValue* _tmp27_;
#line 322 "../src/client/util/util-js.vala"
																_tmp27_ = jsc_value_new_object (context, NULL, NULL);
#line 322 "../src/client/util/util-js.vala"
																_g_object_unref0 (value);
#line 322 "../src/client/util/util-js.vala"
																value = _tmp27_;
#line 1675 "util-js.c"
															}
														} else {
															GVariant* first = NULL;
															GVariant* _tmp28_;
															GVariant* _tmp29_;
#line 325 "../src/client/util/util-js.vala"
															_tmp28_ = g_variant_get_child_value (variant, (gsize) 0);
#line 325 "../src/client/util/util-js.vala"
															first = _tmp28_;
#line 326 "../src/client/util/util-js.vala"
															_tmp29_ = first;
#line 326 "../src/client/util/util-js.vala"
															if (g_variant_classify (_tmp29_) == G_VARIANT_CLASS_DICT_ENTRY) {
#line 1689 "util-js.c"
																JSCValue* _tmp30_;
#line 327 "../src/client/util/util-js.vala"
																_tmp30_ = jsc_value_new_object (context, NULL, NULL);
#line 327 "../src/client/util/util-js.vala"
																_g_object_unref0 (value);
#line 327 "../src/client/util/util-js.vala"
																value = _tmp30_;
#line 1697 "util-js.c"
																{
																	gsize i = 0UL;
#line 328 "../src/client/util/util-js.vala"
																	i = (gsize) 0;
#line 1702 "util-js.c"
																	{
																		gboolean _tmp31_ = FALSE;
#line 328 "../src/client/util/util-js.vala"
																		_tmp31_ = TRUE;
#line 328 "../src/client/util/util-js.vala"
																		while (TRUE) {
#line 1709 "util-js.c"
																			GVariant* entry = NULL;
																			GVariant* _tmp33_;
																			GVariant* _tmp34_;
																			GVariant* key = NULL;
																			GVariant* _tmp39_;
																			GVariant* _tmp40_;
																			GVariant* _tmp41_;
																			JSCValue* _tmp47_ = NULL;
																			GVariant* _tmp48_;
																			GVariant* _tmp49_;
																			GVariant* _tmp50_;
																			JSCValue* _tmp51_;
																			JSCValue* _tmp52_;
																			JSCValue* _tmp53_;
																			GVariant* _tmp54_;
																			const gchar* _tmp55_;
#line 328 "../src/client/util/util-js.vala"
																			if (!_tmp31_) {
#line 1728 "util-js.c"
																				gsize _tmp32_;
#line 328 "../src/client/util/util-js.vala"
																				_tmp32_ = i;
#line 328 "../src/client/util/util-js.vala"
																				i = _tmp32_ + 1;
#line 1734 "util-js.c"
																			}
#line 328 "../src/client/util/util-js.vala"
																			_tmp31_ = FALSE;
#line 328 "../src/client/util/util-js.vala"
																			if (!(i < len)) {
#line 328 "../src/client/util/util-js.vala"
																				break;
#line 1742 "util-js.c"
																			}
#line 329 "../src/client/util/util-js.vala"
																			_tmp33_ = g_variant_get_child_value (variant, i);
#line 329 "../src/client/util/util-js.vala"
																			entry = _tmp33_;
#line 330 "../src/client/util/util-js.vala"
																			_tmp34_ = entry;
#line 330 "../src/client/util/util-js.vala"
																			if (g_variant_classify (_tmp34_) != G_VARIANT_CLASS_DICT_ENTRY) {
#line 1752 "util-js.c"
																				gchar* _tmp35_;
																				gchar* _tmp36_;
																				GError* _tmp37_;
																				GError* _tmp38_;
#line 331 "../src/client/util/util-js.vala"
																				_tmp35_ = g_variant_print (variant, TRUE);
#line 331 "../src/client/util/util-js.vala"
																				_tmp36_ = _tmp35_;
#line 331 "../src/client/util/util-js.vala"
																				_tmp37_ = g_error_new (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Variant mixes dict entries with others: %s", _tmp36_);
#line 331 "../src/client/util/util-js.vala"
																				_tmp38_ = _tmp37_;
#line 331 "../src/client/util/util-js.vala"
																				_g_free0 (_tmp36_);
#line 331 "../src/client/util/util-js.vala"
																				_inner_error0_ = _tmp38_;
#line 331 "../src/client/util/util-js.vala"
																				if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 331 "../src/client/util/util-js.vala"
																					g_propagate_error (error, _inner_error0_);
#line 331 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (entry);
#line 331 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (first);
#line 331 "../src/client/util/util-js.vala"
																					_g_object_unref0 (value);
#line 331 "../src/client/util/util-js.vala"
																					return NULL;
#line 1781 "util-js.c"
																				} else {
#line 331 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (entry);
#line 331 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (first);
#line 331 "../src/client/util/util-js.vala"
																					_g_object_unref0 (value);
#line 331 "../src/client/util/util-js.vala"
																					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 331 "../src/client/util/util-js.vala"
																					g_clear_error (&_inner_error0_);
#line 331 "../src/client/util/util-js.vala"
																					return NULL;
#line 1795 "util-js.c"
																				}
																			}
#line 336 "../src/client/util/util-js.vala"
																			_tmp39_ = entry;
#line 336 "../src/client/util/util-js.vala"
																			_tmp40_ = g_variant_get_child_value (_tmp39_, (gsize) 0);
#line 336 "../src/client/util/util-js.vala"
																			key = _tmp40_;
#line 337 "../src/client/util/util-js.vala"
																			_tmp41_ = key;
#line 337 "../src/client/util/util-js.vala"
																			if (g_variant_classify (_tmp41_) != G_VARIANT_CLASS_STRING) {
#line 1808 "util-js.c"
																				GVariant* _tmp42_;
																				gchar* _tmp43_;
																				gchar* _tmp44_;
																				GError* _tmp45_;
																				GError* _tmp46_;
#line 338 "../src/client/util/util-js.vala"
																				_tmp42_ = entry;
#line 338 "../src/client/util/util-js.vala"
																				_tmp43_ = g_variant_print (_tmp42_, TRUE);
#line 338 "../src/client/util/util-js.vala"
																				_tmp44_ = _tmp43_;
#line 338 "../src/client/util/util-js.vala"
																				_tmp45_ = g_error_new (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Dict entry key is not a string: %s", _tmp44_);
#line 338 "../src/client/util/util-js.vala"
																				_tmp46_ = _tmp45_;
#line 338 "../src/client/util/util-js.vala"
																				_g_free0 (_tmp44_);
#line 338 "../src/client/util/util-js.vala"
																				_inner_error0_ = _tmp46_;
#line 338 "../src/client/util/util-js.vala"
																				if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 338 "../src/client/util/util-js.vala"
																					g_propagate_error (error, _inner_error0_);
#line 338 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (key);
#line 338 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (entry);
#line 338 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (first);
#line 338 "../src/client/util/util-js.vala"
																					_g_object_unref0 (value);
#line 338 "../src/client/util/util-js.vala"
																					return NULL;
#line 1842 "util-js.c"
																				} else {
#line 338 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (key);
#line 338 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (entry);
#line 338 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (first);
#line 338 "../src/client/util/util-js.vala"
																					_g_object_unref0 (value);
#line 338 "../src/client/util/util-js.vala"
																					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 338 "../src/client/util/util-js.vala"
																					g_clear_error (&_inner_error0_);
#line 338 "../src/client/util/util-js.vala"
																					return NULL;
#line 1858 "util-js.c"
																				}
																			}
#line 345 "../src/client/util/util-js.vala"
																			_tmp48_ = entry;
#line 345 "../src/client/util/util-js.vala"
																			_tmp49_ = g_variant_get_child_value (_tmp48_, (gsize) 1);
#line 345 "../src/client/util/util-js.vala"
																			_tmp50_ = _tmp49_;
#line 345 "../src/client/util/util-js.vala"
																			_tmp51_ = util_js_variant_to_value (context, _tmp50_, &_inner_error0_);
#line 345 "../src/client/util/util-js.vala"
																			_tmp52_ = _tmp51_;
#line 345 "../src/client/util/util-js.vala"
																			_g_variant_unref0 (_tmp50_);
#line 345 "../src/client/util/util-js.vala"
																			_tmp47_ = _tmp52_;
#line 345 "../src/client/util/util-js.vala"
																			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 345 "../src/client/util/util-js.vala"
																				if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 345 "../src/client/util/util-js.vala"
																					g_propagate_error (error, _inner_error0_);
#line 345 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (key);
#line 345 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (entry);
#line 345 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (first);
#line 345 "../src/client/util/util-js.vala"
																					_g_object_unref0 (value);
#line 345 "../src/client/util/util-js.vala"
																					return NULL;
#line 1891 "util-js.c"
																				} else {
#line 345 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (key);
#line 345 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (entry);
#line 345 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (first);
#line 345 "../src/client/util/util-js.vala"
																					_g_object_unref0 (value);
#line 345 "../src/client/util/util-js.vala"
																					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 345 "../src/client/util/util-js.vala"
																					g_clear_error (&_inner_error0_);
#line 345 "../src/client/util/util-js.vala"
																					return NULL;
#line 1907 "util-js.c"
																				}
																			}
#line 343 "../src/client/util/util-js.vala"
																			_tmp53_ = value;
#line 343 "../src/client/util/util-js.vala"
																			_tmp54_ = key;
#line 343 "../src/client/util/util-js.vala"
																			_tmp55_ = g_variant_get_string (_tmp54_, NULL);
#line 343 "../src/client/util/util-js.vala"
																			jsc_value_object_set_property (_tmp53_, _tmp55_, _tmp47_);
#line 328 "../src/client/util/util-js.vala"
																			_g_object_unref0 (_tmp47_);
#line 328 "../src/client/util/util-js.vala"
																			_g_variant_unref0 (key);
#line 328 "../src/client/util/util-js.vala"
																			_g_variant_unref0 (entry);
#line 1924 "util-js.c"
																		}
																	}
																}
															} else {
																GPtrArray* values = NULL;
																GPtrArray* _tmp56_;
																GPtrArray* _tmp66_;
																JSCValue* _tmp67_;
#line 349 "../src/client/util/util-js.vala"
																_tmp56_ = g_ptr_array_new_full ((guint) len, _g_object_unref0_);
#line 349 "../src/client/util/util-js.vala"
																values = _tmp56_;
#line 1937 "util-js.c"
																{
																	gsize i = 0UL;
#line 350 "../src/client/util/util-js.vala"
																	i = (gsize) 0;
#line 1942 "util-js.c"
																	{
																		gboolean _tmp57_ = FALSE;
#line 350 "../src/client/util/util-js.vala"
																		_tmp57_ = TRUE;
#line 350 "../src/client/util/util-js.vala"
																		while (TRUE) {
#line 1949 "util-js.c"
																			JSCValue* _tmp59_ = NULL;
																			GVariant* _tmp60_;
																			GVariant* _tmp61_;
																			JSCValue* _tmp62_;
																			JSCValue* _tmp63_;
																			GPtrArray* _tmp64_;
																			JSCValue* _tmp65_;
#line 350 "../src/client/util/util-js.vala"
																			if (!_tmp57_) {
#line 1959 "util-js.c"
																				gsize _tmp58_;
#line 350 "../src/client/util/util-js.vala"
																				_tmp58_ = i;
#line 350 "../src/client/util/util-js.vala"
																				i = _tmp58_ + 1;
#line 1965 "util-js.c"
																			}
#line 350 "../src/client/util/util-js.vala"
																			_tmp57_ = FALSE;
#line 350 "../src/client/util/util-js.vala"
																			if (!(i < len)) {
#line 350 "../src/client/util/util-js.vala"
																				break;
#line 1973 "util-js.c"
																			}
#line 352 "../src/client/util/util-js.vala"
																			_tmp60_ = g_variant_get_child_value (variant, i);
#line 352 "../src/client/util/util-js.vala"
																			_tmp61_ = _tmp60_;
#line 352 "../src/client/util/util-js.vala"
																			_tmp62_ = util_js_variant_to_value (context, _tmp61_, &_inner_error0_);
#line 352 "../src/client/util/util-js.vala"
																			_tmp63_ = _tmp62_;
#line 352 "../src/client/util/util-js.vala"
																			_g_variant_unref0 (_tmp61_);
#line 352 "../src/client/util/util-js.vala"
																			_tmp59_ = _tmp63_;
#line 352 "../src/client/util/util-js.vala"
																			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 352 "../src/client/util/util-js.vala"
																				if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 352 "../src/client/util/util-js.vala"
																					g_propagate_error (error, _inner_error0_);
#line 352 "../src/client/util/util-js.vala"
																					_g_ptr_array_unref0 (values);
#line 352 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (first);
#line 352 "../src/client/util/util-js.vala"
																					_g_object_unref0 (value);
#line 352 "../src/client/util/util-js.vala"
																					return NULL;
#line 2001 "util-js.c"
																				} else {
#line 352 "../src/client/util/util-js.vala"
																					_g_ptr_array_unref0 (values);
#line 352 "../src/client/util/util-js.vala"
																					_g_variant_unref0 (first);
#line 352 "../src/client/util/util-js.vala"
																					_g_object_unref0 (value);
#line 352 "../src/client/util/util-js.vala"
																					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 352 "../src/client/util/util-js.vala"
																					g_clear_error (&_inner_error0_);
#line 352 "../src/client/util/util-js.vala"
																					return NULL;
#line 2015 "util-js.c"
																				}
																			}
#line 351 "../src/client/util/util-js.vala"
																			_tmp64_ = values;
#line 351 "../src/client/util/util-js.vala"
																			_tmp65_ = _tmp59_;
#line 351 "../src/client/util/util-js.vala"
																			_tmp59_ = NULL;
#line 351 "../src/client/util/util-js.vala"
																			g_ptr_array_add (_tmp64_, _tmp65_);
#line 350 "../src/client/util/util-js.vala"
																			_g_object_unref0 (_tmp59_);
#line 2028 "util-js.c"
																		}
																	}
																}
#line 355 "../src/client/util/util-js.vala"
																_tmp66_ = values;
#line 355 "../src/client/util/util-js.vala"
																_tmp67_ = jsc_value_new_array_from_garray (context, _tmp66_);
#line 355 "../src/client/util/util-js.vala"
																_g_object_unref0 (value);
#line 355 "../src/client/util/util-js.vala"
																value = _tmp67_;
#line 326 "../src/client/util/util-js.vala"
																_g_ptr_array_unref0 (values);
#line 2042 "util-js.c"
															}
#line 317 "../src/client/util/util-js.vala"
															_g_variant_unref0 (first);
#line 2046 "util-js.c"
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 359 "../src/client/util/util-js.vala"
	_tmp68_ = value;
#line 359 "../src/client/util/util-js.vala"
	if (_tmp68_ == NULL) {
#line 2065 "util-js.c"
		gchar* _tmp69_;
		gchar* _tmp70_;
		GError* _tmp71_;
		GError* _tmp72_;
#line 360 "../src/client/util/util-js.vala"
		_tmp69_ = g_variant_print (variant, TRUE);
#line 360 "../src/client/util/util-js.vala"
		_tmp70_ = _tmp69_;
#line 360 "../src/client/util/util-js.vala"
		_tmp71_ = g_error_new (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Unsupported variant type %s", _tmp70_);
#line 360 "../src/client/util/util-js.vala"
		_tmp72_ = _tmp71_;
#line 360 "../src/client/util/util-js.vala"
		_g_free0 (_tmp70_);
#line 360 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp72_;
#line 360 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 360 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 360 "../src/client/util/util-js.vala"
			_g_object_unref0 (value);
#line 360 "../src/client/util/util-js.vala"
			return NULL;
#line 2090 "util-js.c"
		} else {
#line 360 "../src/client/util/util-js.vala"
			_g_object_unref0 (value);
#line 360 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 360 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 360 "../src/client/util/util-js.vala"
			return NULL;
#line 2100 "util-js.c"
		}
	}
#line 364 "../src/client/util/util-js.vala"
	result = value;
#line 364 "../src/client/util/util-js.vala"
	return result;
#line 2107 "util-js.c"
}

/**
     * Convenience method for returning a new Callable instance.
     */
UtilJSCallable*
util_js_callable (const gchar* base_name)
{
	UtilJSCallable* _tmp0_;
	UtilJSCallable* result;
#line 370 "../src/client/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 371 "../src/client/util/util-js.vala"
	_tmp0_ = util_js_callable_new (base_name);
#line 371 "../src/client/util/util-js.vala"
	result = _tmp0_;
#line 371 "../src/client/util/util-js.vala"
	return result;
#line 2126 "util-js.c"
}

static inline gpointer
util_js_callable_get_instance_private (UtilJSCallable* self)
{
	return G_STRUCT_MEMBER_P (self, UtilJSCallable_private_offset);
}

UtilJSCallable*
util_js_callable_construct (GType object_type,
                            const gchar* name)
{
	UtilJSCallable* self = NULL;
	gchar* _tmp0_;
#line 383 "../src/client/util/util-js.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 383 "../src/client/util/util-js.vala"
	self = (UtilJSCallable*) g_type_create_instance (object_type);
#line 384 "../src/client/util/util-js.vala"
	_tmp0_ = g_strdup (name);
#line 384 "../src/client/util/util-js.vala"
	_g_free0 (self->priv->name);
#line 384 "../src/client/util/util-js.vala"
	self->priv->name = _tmp0_;
#line 383 "../src/client/util/util-js.vala"
	return self;
#line 2153 "util-js.c"
}

UtilJSCallable*
util_js_callable_new (const gchar* name)
{
#line 383 "../src/client/util/util-js.vala"
	return util_js_callable_construct (UTIL_JS_TYPE_CALLABLE, name);
#line 2161 "util-js.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 390 "../src/client/util/util-js.vala"
	return self ? g_variant_ref (self) : NULL;
#line 2169 "util-js.c"
}

WebKitUserMessage*
util_js_callable_to_message (UtilJSCallable* self)
{
	GVariant* args = NULL;
	GVariant** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp7_;
	GVariant* _tmp8_;
	WebKitUserMessage* _tmp9_;
	WebKitUserMessage* result;
#line 387 "../src/client/util/util-js.vala"
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
#line 388 "../src/client/util/util-js.vala"
	args = NULL;
#line 389 "../src/client/util/util-js.vala"
	_tmp0_ = self->priv->args;
#line 389 "../src/client/util/util-js.vala"
	_tmp0__length1 = self->priv->args_length1;
#line 389 "../src/client/util/util-js.vala"
	if (_tmp0__length1 == 1) {
#line 2192 "util-js.c"
		GVariant** _tmp1_;
		gint _tmp1__length1;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
#line 390 "../src/client/util/util-js.vala"
		_tmp1_ = self->priv->args;
#line 390 "../src/client/util/util-js.vala"
		_tmp1__length1 = self->priv->args_length1;
#line 390 "../src/client/util/util-js.vala"
		_tmp2_ = _tmp1_[0];
#line 390 "../src/client/util/util-js.vala"
		_tmp3_ = _g_variant_ref0 (_tmp2_);
#line 390 "../src/client/util/util-js.vala"
		_g_variant_unref0 (args);
#line 390 "../src/client/util/util-js.vala"
		args = _tmp3_;
#line 2209 "util-js.c"
	} else {
		GVariant** _tmp4_;
		gint _tmp4__length1;
#line 391 "../src/client/util/util-js.vala"
		_tmp4_ = self->priv->args;
#line 391 "../src/client/util/util-js.vala"
		_tmp4__length1 = self->priv->args_length1;
#line 391 "../src/client/util/util-js.vala"
		if (_tmp4__length1 > 1) {
#line 2219 "util-js.c"
			GVariant** _tmp5_;
			gint _tmp5__length1;
			GVariant* _tmp6_;
#line 392 "../src/client/util/util-js.vala"
			_tmp5_ = self->priv->args;
#line 392 "../src/client/util/util-js.vala"
			_tmp5__length1 = self->priv->args_length1;
#line 392 "../src/client/util/util-js.vala"
			_tmp6_ = g_variant_new_tuple (_tmp5_, _tmp5__length1);
#line 392 "../src/client/util/util-js.vala"
			g_variant_ref_sink (_tmp6_);
#line 392 "../src/client/util/util-js.vala"
			_g_variant_unref0 (args);
#line 392 "../src/client/util/util-js.vala"
			args = _tmp6_;
#line 2235 "util-js.c"
		}
	}
#line 394 "../src/client/util/util-js.vala"
	_tmp7_ = self->priv->name;
#line 394 "../src/client/util/util-js.vala"
	_tmp8_ = args;
#line 394 "../src/client/util/util-js.vala"
	_tmp9_ = webkit_user_message_new (_tmp7_, _tmp8_);
#line 394 "../src/client/util/util-js.vala"
	g_object_ref_sink (_tmp9_);
#line 394 "../src/client/util/util-js.vala"
	result = _tmp9_;
#line 394 "../src/client/util/util-js.vala"
	_g_variant_unref0 (args);
#line 394 "../src/client/util/util-js.vala"
	return result;
#line 2252 "util-js.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 2266 "util-js.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 2270 "util-js.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 2276 "util-js.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 2281 "util-js.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 2287 "util-js.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 2291 "util-js.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 2295 "util-js.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 2299 "util-js.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 2303 "util-js.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2307 "util-js.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 2322 "util-js.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 2331 "util-js.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 2338 "util-js.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 2344 "util-js.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 2352 "util-js.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 2356 "util-js.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 2362 "util-js.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 2367 "util-js.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 2373 "util-js.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 2377 "util-js.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 2381 "util-js.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 2387 "util-js.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 2393 "util-js.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 2405 "util-js.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 2409 "util-js.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 2413 "util-js.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 2418 "util-js.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 2426 "util-js.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 2444 "util-js.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 2450 "util-js.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 2454 "util-js.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 2462 "util-js.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 2471 "util-js.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 2480 "util-js.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 2486 "util-js.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 2494 "util-js.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 2506 "util-js.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 2512 "util-js.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 2516 "util-js.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 2524 "util-js.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 2535 "util-js.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 2544 "util-js.c"
	}
}

gchar*
util_js_callable_to_string (UtilJSCallable* self)
{
	gchar** args = NULL;
	GVariant** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint args_length1;
	gint _args_size_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* result;
#line 397 "../src/client/util/util-js.vala"
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
#line 398 "../src/client/util/util-js.vala"
	_tmp0_ = self->priv->args;
#line 398 "../src/client/util/util-js.vala"
	_tmp0__length1 = self->priv->args_length1;
#line 398 "../src/client/util/util-js.vala"
	_tmp1_ = g_new0 (gchar*, _tmp0__length1 + 1);
#line 398 "../src/client/util/util-js.vala"
	args = _tmp1_;
#line 398 "../src/client/util/util-js.vala"
	args_length1 = _tmp0__length1;
#line 398 "../src/client/util/util-js.vala"
	_args_size_ = args_length1;
#line 2583 "util-js.c"
	{
		gint i = 0;
#line 399 "../src/client/util/util-js.vala"
		i = 0;
#line 2588 "util-js.c"
		{
			gboolean _tmp2_ = FALSE;
#line 399 "../src/client/util/util-js.vala"
			_tmp2_ = TRUE;
#line 399 "../src/client/util/util-js.vala"
			while (TRUE) {
#line 2595 "util-js.c"
				gchar** _tmp4_;
				gint _tmp4__length1;
				gchar** _tmp5_;
				gint _tmp5__length1;
				GVariant** _tmp6_;
				gint _tmp6__length1;
				GVariant* _tmp7_;
				gchar* _tmp8_;
#line 399 "../src/client/util/util-js.vala"
				if (!_tmp2_) {
#line 2606 "util-js.c"
					gint _tmp3_;
#line 399 "../src/client/util/util-js.vala"
					_tmp3_ = i;
#line 399 "../src/client/util/util-js.vala"
					i = _tmp3_ + 1;
#line 2612 "util-js.c"
				}
#line 399 "../src/client/util/util-js.vala"
				_tmp2_ = FALSE;
#line 399 "../src/client/util/util-js.vala"
				_tmp4_ = args;
#line 399 "../src/client/util/util-js.vala"
				_tmp4__length1 = args_length1;
#line 399 "../src/client/util/util-js.vala"
				if (!(i < _tmp4__length1)) {
#line 399 "../src/client/util/util-js.vala"
					break;
#line 2624 "util-js.c"
				}
#line 400 "../src/client/util/util-js.vala"
				_tmp5_ = args;
#line 400 "../src/client/util/util-js.vala"
				_tmp5__length1 = args_length1;
#line 400 "../src/client/util/util-js.vala"
				_tmp6_ = self->priv->args;
#line 400 "../src/client/util/util-js.vala"
				_tmp6__length1 = self->priv->args_length1;
#line 400 "../src/client/util/util-js.vala"
				_tmp7_ = _tmp6_[i];
#line 400 "../src/client/util/util-js.vala"
				_tmp8_ = g_variant_print (_tmp7_, TRUE);
#line 400 "../src/client/util/util-js.vala"
				_g_free0 (_tmp5_[i]);
#line 400 "../src/client/util/util-js.vala"
				_tmp5_[i] = _tmp8_;
#line 2642 "util-js.c"
			}
		}
	}
#line 402 "../src/client/util/util-js.vala"
	_tmp9_ = self->priv->name;
#line 402 "../src/client/util/util-js.vala"
	_tmp10_ = g_strconcat (_tmp9_, "(", NULL);
#line 402 "../src/client/util/util-js.vala"
	_tmp11_ = _tmp10_;
#line 402 "../src/client/util/util-js.vala"
	_tmp12_ = args;
#line 402 "../src/client/util/util-js.vala"
	_tmp12__length1 = args_length1;
#line 402 "../src/client/util/util-js.vala"
	_tmp13_ = _vala_g_strjoinv (",", _tmp12_, (gint) _tmp12__length1);
#line 402 "../src/client/util/util-js.vala"
	_tmp14_ = _tmp13_;
#line 402 "../src/client/util/util-js.vala"
	_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 402 "../src/client/util/util-js.vala"
	_tmp16_ = _tmp15_;
#line 402 "../src/client/util/util-js.vala"
	_tmp17_ = g_strconcat (_tmp16_, ")", NULL);
#line 402 "../src/client/util/util-js.vala"
	_tmp18_ = _tmp17_;
#line 402 "../src/client/util/util-js.vala"
	_g_free0 (_tmp16_);
#line 402 "../src/client/util/util-js.vala"
	_g_free0 (_tmp14_);
#line 402 "../src/client/util/util-js.vala"
	_g_free0 (_tmp11_);
#line 402 "../src/client/util/util-js.vala"
	result = _tmp18_;
#line 402 "../src/client/util/util-js.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 402 "../src/client/util/util-js.vala"
	return result;
#line 2680 "util-js.c"
}

static gpointer
_util_js_callable_ref0 (gpointer self)
{
#line 407 "../src/client/util/util-js.vala"
	return self ? util_js_callable_ref (self) : NULL;
#line 2688 "util-js.c"
}

UtilJSCallable*
util_js_callable_string (UtilJSCallable* self,
                         const gchar* value)
{
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	UtilJSCallable* _tmp2_;
	UtilJSCallable* result;
#line 405 "../src/client/util/util-js.vala"
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
#line 405 "../src/client/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 406 "../src/client/util/util-js.vala"
	_tmp0_ = g_variant_new_string (value);
#line 406 "../src/client/util/util-js.vala"
	g_variant_ref_sink (_tmp0_);
#line 406 "../src/client/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 406 "../src/client/util/util-js.vala"
	util_js_callable_add_param (self, _tmp1_);
#line 406 "../src/client/util/util-js.vala"
	_g_variant_unref0 (_tmp1_);
#line 407 "../src/client/util/util-js.vala"
	_tmp2_ = _util_js_callable_ref0 (self);
#line 407 "../src/client/util/util-js.vala"
	result = _tmp2_;
#line 407 "../src/client/util/util-js.vala"
	return result;
#line 2719 "util-js.c"
}

UtilJSCallable*
util_js_callable_double (UtilJSCallable* self,
                         gdouble value)
{
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	UtilJSCallable* _tmp2_;
	UtilJSCallable* result;
#line 410 "../src/client/util/util-js.vala"
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
#line 411 "../src/client/util/util-js.vala"
	_tmp0_ = g_variant_new_double (value);
#line 411 "../src/client/util/util-js.vala"
	g_variant_ref_sink (_tmp0_);
#line 411 "../src/client/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 411 "../src/client/util/util-js.vala"
	util_js_callable_add_param (self, _tmp1_);
#line 411 "../src/client/util/util-js.vala"
	_g_variant_unref0 (_tmp1_);
#line 412 "../src/client/util/util-js.vala"
	_tmp2_ = _util_js_callable_ref0 (self);
#line 412 "../src/client/util/util-js.vala"
	result = _tmp2_;
#line 412 "../src/client/util/util-js.vala"
	return result;
#line 2748 "util-js.c"
}

UtilJSCallable*
util_js_callable_int (UtilJSCallable* self,
                      gint value)
{
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	UtilJSCallable* _tmp2_;
	UtilJSCallable* result;
#line 415 "../src/client/util/util-js.vala"
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
#line 416 "../src/client/util/util-js.vala"
	_tmp0_ = g_variant_new_int32 ((gint32) value);
#line 416 "../src/client/util/util-js.vala"
	g_variant_ref_sink (_tmp0_);
#line 416 "../src/client/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 416 "../src/client/util/util-js.vala"
	util_js_callable_add_param (self, _tmp1_);
#line 416 "../src/client/util/util-js.vala"
	_g_variant_unref0 (_tmp1_);
#line 417 "../src/client/util/util-js.vala"
	_tmp2_ = _util_js_callable_ref0 (self);
#line 417 "../src/client/util/util-js.vala"
	result = _tmp2_;
#line 417 "../src/client/util/util-js.vala"
	return result;
#line 2777 "util-js.c"
}

UtilJSCallable*
util_js_callable_bool (UtilJSCallable* self,
                       gboolean value)
{
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	UtilJSCallable* _tmp2_;
	UtilJSCallable* result;
#line 420 "../src/client/util/util-js.vala"
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
#line 421 "../src/client/util/util-js.vala"
	_tmp0_ = g_variant_new_boolean (value);
#line 421 "../src/client/util/util-js.vala"
	g_variant_ref_sink (_tmp0_);
#line 421 "../src/client/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 421 "../src/client/util/util-js.vala"
	util_js_callable_add_param (self, _tmp1_);
#line 421 "../src/client/util/util-js.vala"
	_g_variant_unref0 (_tmp1_);
#line 422 "../src/client/util/util-js.vala"
	_tmp2_ = _util_js_callable_ref0 (self);
#line 422 "../src/client/util/util-js.vala"
	result = _tmp2_;
#line 422 "../src/client/util/util-js.vala"
	return result;
#line 2806 "util-js.c"
}

static void
_vala_array_add1 (GVariant** * array,
                  gint* length,
                  gint* size,
                  GVariant* value)
{
#line 426 "../src/client/util/util-js.vala"
	if ((*length) == (*size)) {
#line 426 "../src/client/util/util-js.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 426 "../src/client/util/util-js.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 2821 "util-js.c"
	}
#line 426 "../src/client/util/util-js.vala"
	(*array)[(*length)++] = value;
#line 426 "../src/client/util/util-js.vala"
	(*array)[*length] = NULL;
#line 2827 "util-js.c"
}

static inline void
util_js_callable_add_param (UtilJSCallable* self,
                            GVariant* value)
{
	GVariant* _tmp0_;
#line 425 "../src/client/util/util-js.vala"
	g_return_if_fail (UTIL_JS_IS_CALLABLE (self));
#line 425 "../src/client/util/util-js.vala"
	g_return_if_fail (value != NULL);
#line 426 "../src/client/util/util-js.vala"
	_tmp0_ = _g_variant_ref0 (value);
#line 426 "../src/client/util/util-js.vala"
	_vala_array_add1 (&self->priv->args, &self->priv->args_length1, &self->priv->_args_size_, _tmp0_);
#line 2843 "util-js.c"
}

static void
util_js_value_callable_init (GValue* value)
{
#line 377 "../src/client/util/util-js.vala"
	value->data[0].v_pointer = NULL;
#line 2851 "util-js.c"
}

static void
util_js_value_callable_free_value (GValue* value)
{
#line 377 "../src/client/util/util-js.vala"
	if (value->data[0].v_pointer) {
#line 377 "../src/client/util/util-js.vala"
		util_js_callable_unref (value->data[0].v_pointer);
#line 2861 "util-js.c"
	}
}

static void
util_js_value_callable_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 377 "../src/client/util/util-js.vala"
	if (src_value->data[0].v_pointer) {
#line 377 "../src/client/util/util-js.vala"
		dest_value->data[0].v_pointer = util_js_callable_ref (src_value->data[0].v_pointer);
#line 2873 "util-js.c"
	} else {
#line 377 "../src/client/util/util-js.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2877 "util-js.c"
	}
}

static gpointer
util_js_value_callable_peek_pointer (const GValue* value)
{
#line 377 "../src/client/util/util-js.vala"
	return value->data[0].v_pointer;
#line 2886 "util-js.c"
}

static gchar*
util_js_value_callable_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 377 "../src/client/util/util-js.vala"
	if (collect_values[0].v_pointer) {
#line 2897 "util-js.c"
		UtilJSCallable * object;
		object = collect_values[0].v_pointer;
#line 377 "../src/client/util/util-js.vala"
		if (object->parent_instance.g_class == NULL) {
#line 377 "../src/client/util/util-js.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2904 "util-js.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 377 "../src/client/util/util-js.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2908 "util-js.c"
		}
#line 377 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = util_js_callable_ref (object);
#line 2912 "util-js.c"
	} else {
#line 377 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 2916 "util-js.c"
	}
#line 377 "../src/client/util/util-js.vala"
	return NULL;
#line 2920 "util-js.c"
}

static gchar*
util_js_value_callable_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	UtilJSCallable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 377 "../src/client/util/util-js.vala"
	if (!object_p) {
#line 377 "../src/client/util/util-js.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2935 "util-js.c"
	}
#line 377 "../src/client/util/util-js.vala"
	if (!value->data[0].v_pointer) {
#line 377 "../src/client/util/util-js.vala"
		*object_p = NULL;
#line 2941 "util-js.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 377 "../src/client/util/util-js.vala"
		*object_p = value->data[0].v_pointer;
#line 2945 "util-js.c"
	} else {
#line 377 "../src/client/util/util-js.vala"
		*object_p = util_js_callable_ref (value->data[0].v_pointer);
#line 2949 "util-js.c"
	}
#line 377 "../src/client/util/util-js.vala"
	return NULL;
#line 2953 "util-js.c"
}

GParamSpec*
util_js_param_spec_callable (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	UtilJSParamSpecCallable* spec;
#line 377 "../src/client/util/util-js.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UTIL_JS_TYPE_CALLABLE), NULL);
#line 377 "../src/client/util/util-js.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 377 "../src/client/util/util-js.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 377 "../src/client/util/util-js.vala"
	return G_PARAM_SPEC (spec);
#line 2972 "util-js.c"
}

gpointer
util_js_value_get_callable (const GValue* value)
{
#line 377 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE), NULL);
#line 377 "../src/client/util/util-js.vala"
	return value->data[0].v_pointer;
#line 2982 "util-js.c"
}

void
util_js_value_set_callable (GValue* value,
                            gpointer v_object)
{
	UtilJSCallable * old;
#line 377 "../src/client/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE));
#line 377 "../src/client/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 377 "../src/client/util/util-js.vala"
	if (v_object) {
#line 377 "../src/client/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTIL_JS_TYPE_CALLABLE));
#line 377 "../src/client/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 377 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 377 "../src/client/util/util-js.vala"
		util_js_callable_ref (value->data[0].v_pointer);
#line 3004 "util-js.c"
	} else {
#line 377 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 3008 "util-js.c"
	}
#line 377 "../src/client/util/util-js.vala"
	if (old) {
#line 377 "../src/client/util/util-js.vala"
		util_js_callable_unref (old);
#line 3014 "util-js.c"
	}
}

void
util_js_value_take_callable (GValue* value,
                             gpointer v_object)
{
	UtilJSCallable * old;
#line 377 "../src/client/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE));
#line 377 "../src/client/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 377 "../src/client/util/util-js.vala"
	if (v_object) {
#line 377 "../src/client/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTIL_JS_TYPE_CALLABLE));
#line 377 "../src/client/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 377 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 3035 "util-js.c"
	} else {
#line 377 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 3039 "util-js.c"
	}
#line 377 "../src/client/util/util-js.vala"
	if (old) {
#line 377 "../src/client/util/util-js.vala"
		util_js_callable_unref (old);
#line 3045 "util-js.c"
	}
}

static void
util_js_callable_class_init (UtilJSCallableClass * klass,
                             gpointer klass_data)
{
#line 377 "../src/client/util/util-js.vala"
	util_js_callable_parent_class = g_type_class_peek_parent (klass);
#line 377 "../src/client/util/util-js.vala"
	((UtilJSCallableClass *) klass)->finalize = util_js_callable_finalize;
#line 377 "../src/client/util/util-js.vala"
	g_type_class_adjust_private_offset (klass, &UtilJSCallable_private_offset);
#line 3059 "util-js.c"
}

static void
util_js_callable_instance_init (UtilJSCallable * self,
                                gpointer klass)
{
	GVariant** _tmp0_;
#line 377 "../src/client/util/util-js.vala"
	self->priv = util_js_callable_get_instance_private (self);
#line 380 "../src/client/util/util-js.vala"
	_tmp0_ = g_new0 (GVariant*, 0 + 1);
#line 380 "../src/client/util/util-js.vala"
	self->priv->args = _tmp0_;
#line 380 "../src/client/util/util-js.vala"
	self->priv->args_length1 = 0;
#line 380 "../src/client/util/util-js.vala"
	self->priv->_args_size_ = self->priv->args_length1;
#line 377 "../src/client/util/util-js.vala"
	self->ref_count = 1;
#line 3079 "util-js.c"
}

static void
util_js_callable_finalize (UtilJSCallable * obj)
{
	UtilJSCallable * self;
#line 377 "../src/client/util/util-js.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTIL_JS_TYPE_CALLABLE, UtilJSCallable);
#line 377 "../src/client/util/util-js.vala"
	g_signal_handlers_destroy (self);
#line 379 "../src/client/util/util-js.vala"
	_g_free0 (self->priv->name);
#line 380 "../src/client/util/util-js.vala"
	self->priv->args = (_vala_array_free (self->priv->args, self->priv->args_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 3094 "util-js.c"
}

/**
     * A class for constructing a well formed, safe, invocable JS call.
     */
static GType
util_js_callable_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { util_js_value_callable_init, util_js_value_callable_free_value, util_js_value_callable_copy_value, util_js_value_callable_peek_pointer, "p", util_js_value_callable_collect_value, "p", util_js_value_callable_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UtilJSCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) util_js_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilJSCallable), 0, (GInstanceInitFunc) util_js_callable_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType util_js_callable_type_id;
	util_js_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UtilJSCallable", &g_define_type_info, &g_define_type_fundamental_info, 0);
	UtilJSCallable_private_offset = g_type_add_instance_private (util_js_callable_type_id, sizeof (UtilJSCallablePrivate));
	return util_js_callable_type_id;
}

GType
util_js_callable_get_type (void)
{
	static volatile gsize util_js_callable_type_id__once = 0;
	if (g_once_init_enter (&util_js_callable_type_id__once)) {
		GType util_js_callable_type_id;
		util_js_callable_type_id = util_js_callable_get_type_once ();
		g_once_init_leave (&util_js_callable_type_id__once, util_js_callable_type_id);
	}
	return util_js_callable_type_id__once;
}

gpointer
util_js_callable_ref (gpointer instance)
{
	UtilJSCallable * self;
	self = instance;
#line 377 "../src/client/util/util-js.vala"
	g_atomic_int_inc (&self->ref_count);
#line 377 "../src/client/util/util-js.vala"
	return instance;
#line 3133 "util-js.c"
}

void
util_js_callable_unref (gpointer instance)
{
	UtilJSCallable * self;
	self = instance;
#line 377 "../src/client/util/util-js.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 377 "../src/client/util/util-js.vala"
		UTIL_JS_CALLABLE_GET_CLASS (self)->finalize (self);
#line 377 "../src/client/util/util-js.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3147 "util-js.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

